// wildcardKaze.h written by Kaze

long long KAZE_strlen (const char * str)
{
        const char *eos = str;
        while( *eos++ ) ;
        return( (long long)(eos - str - 1) );
}

long long KAZE_strlenLF (const char * str)
{
        const char *eos = str;
        char LFa[1];
        LFa[0] = 10; //BUG UNcrushed yet: for Windows 13 for POSIX 10
        while( *eos++ != LFa[0] ) ;
        return( (long long)(eos - str - 1) );
}

/*
#ifndef NULL
#ifdef __cplusplus
#define NULL 0
#else
#define NULL ((void*)0)
#endif
#endif
*/
/*
	Exact_flag = 0;
	WILDCARD_FAST_flag = 2;
	if (WILDCARD_IP_flag) {
	if ( memchrKAZE(argv[2-WILDCARD_IP_flag], &TAGfreeFAST[0], n) == NULL && \
	     memchrKAZE(argv[2-WILDCARD_IP_flag], &TAGfreeFAST[1], n) == NULL ) Exact_flag = 1;
	else WILDCARD_FAST_flag = 1;
	}

	if (EXHAUSTIVE_flag && n<=AtMostLevenshteinDistance)
	{ printf( "Kazahana: In EXHAUSTIVE mode 'PatternLength' should be bigger than 'AtMostLevenshteinDistance'.\n" ); return( 1 ); }

	// The way it is done now the SLOW overrides the FAST, meaning that presence of at least one of the 9 wildcards trumps the FAST mode.

	if (WILDCARD_IP_flag) {
	if ( memchrKAZE(argv[2-WILDCARD_IP_flag], &TAGfree[0], n) == NULL && \
	     memchrKAZE(argv[2-WILDCARD_IP_flag], &TAGfree[1], n) == NULL && \
	     memchrKAZE(argv[2-WILDCARD_IP_flag], &TAGfree[2], n) == NULL && \
	     memchrKAZE(argv[2-WILDCARD_IP_flag], &TAGfree[3], n) == NULL && \
	     memchrKAZE(argv[2-WILDCARD_IP_flag], &TAGfree[4], n) == NULL && \
	     memchrKAZE(argv[2-WILDCARD_IP_flag], &TAGfree[5], n) == NULL && \
	     memchrKAZE(argv[2-WILDCARD_IP_flag], &TAGfree[6], n) == NULL && \
	     memchrKAZE(argv[2-WILDCARD_IP_flag], &TAGfree[7], n) == NULL && \
	     memchrKAZE(argv[2-WILDCARD_IP_flag], &TAGfree[8], n) == NULL ) Exact_flag = 1;
	else WILDCARD_FAST_flag = 0;
	}

	if (WILDCARD_FAST_flag == 1) Exact_flag = 0;
	if (WILDCARD_FAST_flag == 0) Exact_flag = 0;

	if (WILDCARD_FAST_flag != 2) {
		if (CaseSensitiveWildcardMatching_flag == 1) printf("Enforcing Case Sensitive wildcard mode ...\n");	
		if (CaseSensitiveWildcardMatching_flag == 0) printf("Enforcing Case Insensitive wildcard mode ...\n");	
	}

	if (WILDCARD_FAST_flag == 1) printf("Enforcing FAST wildcard mode ...\n");	
	if (WILDCARD_FAST_flag == 0) printf("Enforcing SLOW wildcard mode ...\n");	
*/

#ifndef false
#define false 0
#endif
#ifndef true
#define true 1
#endif

// typedef unsigned char char_t;
// typedef char_t *string;
// char TAGfree[10] = "*@#^$|~`.";
// char TAGfreeFAST[3] = "&+"; // '&' stands for "standard" '*', '+' stands for "standard" '?'.
// typedef unsigned char boolean;
#define KAZE_tolower(c) ( (((c) >= 'A') && ((c) <= 'Z')) ? ((c) - 'A' + 'a') : (c) )
#define KAZE_toupper(c) ( (((c) >= 'a') && ((c) <= 'z')) ? ((c) - 'a' + 'A') : (c) )
// int CaseSensitiveWildcardMatching_flag; // ZERO for INSENSITIVE, NONZERO for SENSITIVE

// Kazahana's wildcard function, my best function:
int WildcardMatch_Iterative_Kaze (const char* mask, const char* name) {
// Revision 1:
/*
const char* maskSTACK;
const char* nameSTACK;
int BacktrackFlag = 0;
Backtrack:
for (nameSTACK = name, maskSTACK = mask; *nameSTACK; ++nameSTACK, ++maskSTACK) {
	if (*maskSTACK == '&') {
		mask = maskSTACK+1;
		if (!*mask) return 1;
		name = nameSTACK;
		BacktrackFlag = -1;
		goto Backtrack;
	}
	//else if (*maskSTACK == '+') {
	//} else {
	else if (*maskSTACK != '+') {
		//if (tolower(*nameSTACK) != tolower(*maskSTACK)) { // These 'tolower's are outrageous, they hurt speed BADLY, in real-world usage both should have been lowercased outwith the 'for'.
		if (*nameSTACK != *maskSTACK) { 
			if (!BacktrackFlag) return 0;
			name++;
			goto Backtrack;
		}
	} 
} 
while (*maskSTACK == '&') ++maskSTACK;
return (!*maskSTACK);
*/
// Revision 2, 2013-Nov-30:
const char* maskSTACK;
const char* nameSTACK;
//int BacktrackFlag = 0; // No need of it in rev.2
/*
    // Simplest heuristic with SUPEROVERHEAD enforced: trying to skip the whole wildcard section by comparing the two arrays order 1 of mask&name.
    int i;
    unsigned char maskOrder1[256];
    unsigned char nameOrder1[256];
    for (i='a'; i <= 'z'; i++) { maskOrder1[i]=0; nameOrder1[i]=0;}
    for (i=0; i < strlen(mask); i++) maskOrder1[mask[i]]=1;
    for (i=0; i < strlen(name); i++) nameOrder1[name[i]]=1;
    // Assuming the incoming strings are already lowercased (as it should for speed) and if we don't have matching alphabet parts (from mask side) means we don't need to compare any further i.e. the match fails.
    for (i='a'; i <= 'z'; i++) if ( maskOrder1[i] == 1 && nameOrder1[i] == 0 ) return 0;
*/
/*
    int i;
    for (i=0; i < strlen(mask); i++) {
        if ( mask[i] != '&' && mask[i] != '+' )
            if ( !memchr(name,mask[i],strlen(name)) ) return 0;
    }
*/
/*
Backtrack:
for (nameSTACK = name, maskSTACK = mask; *nameSTACK; ++nameSTACK, ++maskSTACK) {
	if (*maskSTACK == '&') {
		mask = maskSTACK+1;
		if (!*mask) return 1;
		name = nameSTACK;
		BacktrackFlag = -1;
		goto Backtrack;
	}
	//else if (*maskSTACK == '+') {
	//} else {
	else if (*maskSTACK != '+') {
		//if (tolower(*nameSTACK) != tolower(*maskSTACK)) { // These 'tolower's are outrageous, they hurt speed BADLY, in real-world usage both should have been lowercased outwith the 'for'.
		if (*nameSTACK != *maskSTACK) { 
			if (!BacktrackFlag) return 0; // Stupid branching, SLOW!
			name++;
			goto Backtrack;
		}
	} 
} 
*/
// Here, outside the main/second 'for', in order to avoid branching we need to set the old/obsolete BacktrackFlag i.e. we need first occurrence of '&':
for (name, mask; *name; ++name, ++mask) {
	if (*mask == '&') {
		goto Backtrack;
	}
	//else if (*mask == '+') {
	//} else {
	else if (*mask != '+') {
		if (*name != *mask) { 
			return 0;
		}
	} 
}
// We are entering the main/second 'for' with mask pointing to '&' as if BacktrackFlag is already set in the very first iteration at first condition:
Backtrack:
for (nameSTACK = name, maskSTACK = mask; *nameSTACK; ++nameSTACK, ++maskSTACK) {
	if (*maskSTACK == '&') {
		mask = maskSTACK+1;
		if (!*mask) return 1;
		name = nameSTACK;
		//BacktrackFlag = -1;
		goto Backtrack;
	}
	//else if (*maskSTACK == '+') {
	//} else {
	else if (*maskSTACK != '+') {
		//if (tolower(*nameSTACK) != tolower(*maskSTACK)) { // These 'tolower's are outrageous, they hurt speed BADLY, in real-world usage both should have been lowercased outwith the 'for'.
		if (*nameSTACK != *maskSTACK) { 
			//if (!BacktrackFlag) return 0; // Stupid branching, SLOW!
			name++;
			goto Backtrack;
		}
	} 
}
while (*maskSTACK == '&') ++maskSTACK;
return (!*maskSTACK);
}

int Tcheburaschka_Wildcard_CaseSensitive (const char* mask, const char* name) {
        const char* maskSTACK;
        const char* nameSTACK;
#pragma nounroll
        for (name, mask; *name; ++name, ++mask) {
	        if (*mask == '*') {
		        goto Backtrack;
	        //} else if ((*mask != '?') && (*name != *mask)) {
/*
		} else if ((*mask - '?') * (*name - *mask)) {
		        return 0;
	        } 
*/
		}
		if ((*mask - '#') * (*name - *mask)) {
		        return 0;
	        } 
        }
Backtrack:
#pragma nounroll
        for (nameSTACK = name, maskSTACK = mask; *nameSTACK; ++nameSTACK, ++maskSTACK) {
// r5 [
//	        //if ( (*maskSTACK == '*') || ((*maskSTACK - '?') * (*nameSTACK - *maskSTACK)) ) {
//	        if ( (!(*maskSTACK - '*')) + ((*maskSTACK - '?') * (*nameSTACK - *maskSTACK)) ) { // slightly faster ~4s
//		        name++; // Nicely below 'name' is overwritten, it adds another 14s boost
//	                if ( !(*maskSTACK - '*') ) {
//		                mask = maskSTACK+1;
//		                if (!*mask) return 1; // Not needed, we can rely on 'name' exhaustion, or, put it in the 'for' as *nameSTACK * *mask
//		                name = nameSTACK;
//		        //} else {              // ]----+
//		        //        name++;       // ]    |
//	                //}                     // ]    |
//	                //goto Backtrack;       // ]    |
//                        }                       // ]
//	                goto Backtrack;         // ]
//                }
// r5 ]
// r4 [
//	        //if ( (*maskSTACK == '*') || ((*maskSTACK - '?') * (*nameSTACK - *maskSTACK)) ) {
//	        if ( (!(*maskSTACK - '*')) + ((*maskSTACK - '?') * (*nameSTACK - *maskSTACK)) ) { // slightly faster ~4s
//	                if ( !(*maskSTACK - '*') ) {
//		                mask = maskSTACK+1;
//		                if (!*mask) return 1;
//		                name = nameSTACK;
//		        //} else {              // ]----+
//		        //        name++;       // ]    |
//	                //}                     // ]    |
//	                //goto Backtrack;       // ]    |
//	                goto Backtrack;         // ]<---+
//	                }                       // ]
//		        name++;                 // ]
//	                goto Backtrack;         // ]
//	        }
// r4 ]
// r3 [
	        if (*maskSTACK == '*') {
		        mask = maskSTACK+1;
		        if (!*mask) return 1;
		        name = nameSTACK;
		        goto Backtrack;
	        //} else if ((*maskSTACK != '?') && (*nameSTACK != *maskSTACK)) {
///*
//		} else if ((*maskSTACK - '?') * (*nameSTACK - *maskSTACK)) {
//		        name++;
//		        goto Backtrack;
//	        } 
//*/
		}
		if ((*maskSTACK - '#') * (*nameSTACK - *maskSTACK)) {
		        name++;
		        goto Backtrack;
	        } 
// r3 ]
        }
        while (*maskSTACK == '*') ++maskSTACK;
        return (!*maskSTACK);
}

int Tcheburaschka_Wildcard_CaseInsensitive (const char* mask, const char* name) {
        const char* maskSTACK;
        const char* nameSTACK;
#pragma nounroll
        for (name, mask; *name; ++name, ++mask) {
	        if (*mask == '*') {
		        goto Backtrack;
	        //} else if ((*mask != '?') && (*name != *mask)) {
/*
		} else if ((*mask - '?') * (*name - *mask)) {
		        return 0;
	        } 
*/
		}
		if ((*mask - '#') * (KAZE_toupper(*name) - KAZE_toupper(*mask))) {
		        return 0;
	        } 
        }
Backtrack:
#pragma nounroll
        for (nameSTACK = name, maskSTACK = mask; *nameSTACK; ++nameSTACK, ++maskSTACK) {
// r5 [
//	        //if ( (*maskSTACK == '*') || ((*maskSTACK - '?') * (*nameSTACK - *maskSTACK)) ) {
//	        if ( (!(*maskSTACK - '*')) + ((*maskSTACK - '?') * (*nameSTACK - *maskSTACK)) ) { // slightly faster ~4s
//		        name++; // Nicely below 'name' is overwritten, it adds another 14s boost
//	                if ( !(*maskSTACK - '*') ) {
//		                mask = maskSTACK+1;
//		                if (!*mask) return 1; // Not needed, we can rely on 'name' exhaustion, or, put it in the 'for' as *nameSTACK * *mask
//		                name = nameSTACK;
//		        //} else {              // ]----+
//		        //        name++;       // ]    |
//	                //}                     // ]    |
//	                //goto Backtrack;       // ]    |
//                        }                       // ]
//	                goto Backtrack;         // ]
//                }
// r5 ]
// r4 [
//	        //if ( (*maskSTACK == '*') || ((*maskSTACK - '?') * (*nameSTACK - *maskSTACK)) ) {
//	        if ( (!(*maskSTACK - '*')) + ((*maskSTACK - '?') * (*nameSTACK - *maskSTACK)) ) { // slightly faster ~4s
//	                if ( !(*maskSTACK - '*') ) {
//		                mask = maskSTACK+1;
//		                if (!*mask) return 1;
//		                name = nameSTACK;
//		        //} else {              // ]----+
//		        //        name++;       // ]    |
//	                //}                     // ]    |
//	                //goto Backtrack;       // ]    |
//	                goto Backtrack;         // ]<---+
//	                }                       // ]
//		        name++;                 // ]
//	                goto Backtrack;         // ]
//	        }
// r4 ]
// r3 [
	        if (*maskSTACK == '*') {
		        mask = maskSTACK+1;
		        if (!*mask) return 1;
		        name = nameSTACK;
		        goto Backtrack;
	        //} else if ((*maskSTACK != '?') && (*nameSTACK != *maskSTACK)) {
///*
//		} else if ((*maskSTACK - '?') * (*nameSTACK - *maskSTACK)) {
//		        name++;
//		        goto Backtrack;
//	        } 
//*/
		}
		if ((*maskSTACK - '#') * (KAZE_toupper(*nameSTACK) - KAZE_toupper(*maskSTACK))) {
		        name++;
		        goto Backtrack;
	        } 
// r3 ]
        }
        while (*maskSTACK == '*') ++maskSTACK;
        return (!*maskSTACK);
}

// SLOW mode is clearly written, however recursive calls are very "overheadY" also it has scary branching:
// The way it is done (in Kazahana) now the SLOW overrides the FAST, meaning that presence of at least one of the 9 wildcards trumps the FAST mode.
// FAST, iterative:
//       wildcard '*' any character(s) or empty,
//       wildcard '#' any character and not empty.
// CAUTION: For speed case-insensitivity is achieved outwith the function i.e. by default it is case-sensitive unless you did take care of the opposite.
static unsigned char IterativeWildcards (const char *mask, const char *name)
{
        const char *maskSTACK;
        const char *nameSTACK;
        while ( (*name) && (*mask != '*') ) {
	        if ( (*mask != *name) && (*mask != '#') ) return false;
	        mask++;
	        name++;
        }
        while ( *name ) {
	        if ( *mask == '*' ) {
		        if (!*++mask) return true;
		        maskSTACK = mask;
		        nameSTACK = name + 1;
	        } else if ( (*mask == *name) || (*mask == '#') ) {
		        mask++;
		        name++;
	        } else {
		        mask = maskSTACK;
		        name = nameSTACK++;
	        }
        }
        while ( *mask == '*' ) mask++;
        return !*mask;
}

// Igor Pavlov's variant modified by Kaze
// Note: '@' stands for "standard" '?'
// wildcard '*' any character(s) or empty,
// wildcard '@'/'#' any character {or empty}/{and not empty},
static unsigned char Wildcard_IP (const char *mask, int maskPos, const char *name, int namePos)
{
char maskChar;
int maskLen = KAZE_strlen(mask) - maskPos;
int nameLen = KAZE_strlen(name) - namePos;
// Above 2 lines are to be modified with GLOBAL variables for speed as follows (or passed as arguments):
//int maskLen = maskGLOBALlen - maskPos;
//int nameLen = nameGLOBALlen - namePos;
if (maskLen == 0)
	if (nameLen == 0) return true;
	else return false;
maskChar = mask[maskPos];
if (maskChar == '@') { // wildcard '@'/'#' any character {or empty}/{and not empty},
        if (Wildcard_IP (mask, maskPos + 1, name, namePos)) return true; // KAZE: THIS LINE DECIDES whether 'or empty' or 'and not empty', uncommented is 'or empty'
        if (nameLen == 0) return false;
	return Wildcard_IP (mask, maskPos + 1, name, namePos + 1);
} else if (maskChar == '#') { // wildcard '@'/'#' any character {or empty}/{and not empty},
        if (nameLen == 0) return false;
	return Wildcard_IP (mask, maskPos + 1, name, namePos + 1);
} else if (maskChar == '*') {
	if (Wildcard_IP (mask, maskPos + 1, name, namePos)) return true;
	if (nameLen == 0) return false;
	return Wildcard_IP (mask, maskPos, name, namePos + 1);
} else {
	if (maskChar != name[namePos]) return false;
	return Wildcard_IP (mask, maskPos + 1, name, namePos + 1);
}
}

// SLOW, recursive:
//       wildcard '*' any character(s) or empty,
//       wildcard '.' any ALPHA character(s) or empty,
//       wildcard '`' any NON-ALPHA character(s) or empty,
//       wildcard '@'/'#' any character {or empty}/{and not empty},
//       wildcard '^'/'$' any ALPHA character {or empty}/{and not empty},
//       wildcard '|'/'~' any NON-ALPHA character {or empty}/{and not empty},
//       wildcard '+'/'%' any DIGIT character {or empty}/{and not empty},
// Note: Due to different line endings(CRLF in Windows; LF in UNIX) you must add a '|' wildcard in place of CR: for example in case of searching for '*.pdf' write '*.pdf|'.
// Pattern example: *%%take@%%$$|
// GLOBAL definitions [
// int CaseSensitiveWildcardMatching_flag; // ZERO for INSENSITIVE, NONZERO for SENSITIVE
// int maskGLOBALlen; // Length of Needle
// int nameGLOBALlen; // Length of Haystack
// GLOBAL definitions ]
// How to Invoke: if ( EnhancedMaskTest_OrEmpty_AndNotEmpty_1(wrdARG, 0, wrdLOW, 0) ) { // Caution: Not lowercased as it should!
static unsigned char IP_enhanched_Kaze (const char *mask, long long maskPos, const char *name, long long namePos) {
int CaseSensitiveWildcardMatching_flag=0; // ZERO for INSENSITIVE, NONZERO for SENSITIVE
char maskChar;
char c;
long long maskLen = KAZE_strlen(mask) - maskPos;
long long nameLen = KAZE_strlen(name) - namePos;
// Above 2 lines are to be modified with GLOBAL variables for speed as follows (or passed as arguments):
//int maskLen = maskGLOBALlen - maskPos;
//int nameLen = nameGLOBALlen - namePos;
if (maskLen == 0)
        if (nameLen == 0) return true;
        else return false;
maskChar = mask[maskPos];
if (maskChar == '@') { // wildcard '@'/'#' any character {or empty}/{and not empty},
        /*
        if (IP_enhanched_Kaze(mask, maskPos + 1, name, namePos)) 
        return true;
        */
        if (IP_enhanched_Kaze(mask, maskPos + 1, name, namePos)) return true; // KAZE: THIS LINE DECIDES whether 'or empty' or 'and not empty', uncommented is 'or empty'
        if (nameLen == 0) return false;
        return IP_enhanched_Kaze(mask,  maskPos + 1, name, namePos + 1);
} else if (maskChar == '#') { // wildcard '@'/'#' any character {or empty}/{and not empty},
        /*
        if (IP_enhanched_Kaze(mask, maskPos + 1, name, namePos)) 
        return true;
        */
        if (nameLen == 0) return false;
        return IP_enhanched_Kaze(mask,  maskPos + 1, name, namePos + 1);
} else if (maskChar == '|') { // wildcard '|'/'~' any NON-ALPHA character {or empty}/{and not empty},
        if (IP_enhanched_Kaze(mask, maskPos + 1, name, namePos)) return true;
        c = name[namePos]; 
        if ( (KAZE_toupper(c) >= 'A') && (KAZE_toupper(c) <= 'Z') ) return false;
        if (nameLen == 0) return false;
        return IP_enhanched_Kaze(mask,  maskPos + 1, name, namePos + 1);
} else if (maskChar == '~') { // wildcard '|'/'~' any NON-ALPHA character {or empty}/{and not empty},
        /*
        if (IP_enhanched_Kaze(mask, maskPos + 1, name, namePos)) 
        return true;
        */
        c = name[namePos]; 
        if ( (KAZE_toupper(c) >= 'A') && (KAZE_toupper(c) <= 'Z') ) return false;
        if (nameLen == 0) return false;
        return IP_enhanched_Kaze(mask,  maskPos + 1, name, namePos + 1);
} else if (maskChar == '^') { // wildcard '^'/'$' any ALPHA character {or empty}/{and not empty},
        if (IP_enhanched_Kaze(mask, maskPos + 1, name, namePos)) return true;
        c = name[namePos]; 
        if ( (KAZE_toupper(c) < 'A') || (KAZE_toupper(c) > 'Z') ) return false;
        if (nameLen == 0) return false;
        return IP_enhanched_Kaze(mask,  maskPos + 1, name, namePos + 1);
} else if (maskChar == '$') { // wildcard '^'/'$' any ALPHA character {or empty}/{and not empty},
        /*
        if (IP_enhanched_Kaze(mask, maskPos + 1, name, namePos)) 
        return true;
        */
        c = name[namePos]; 
        if ( (KAZE_toupper(c) < 'A') || (KAZE_toupper(c) > 'Z') ) return false;
        if (nameLen == 0) return false;
        return IP_enhanched_Kaze(mask,  maskPos + 1, name, namePos + 1);
} else if (maskChar == '`') { // wildcard '`' any NON-ALPHA character(s) or empty,
        if (IP_enhanched_Kaze(mask, maskPos + 1, name, namePos)) return true;
        c = name[namePos]; 
        if ( (KAZE_toupper(c) >= 'A') && (KAZE_toupper(c) <= 'Z') ) return false;
        if (nameLen == 0) return false;
        return IP_enhanched_Kaze(mask,  maskPos, name, namePos + 1);
} else if (maskChar == '.') { // wildcard '.' any ALPHA character(s) or empty,
        if (IP_enhanched_Kaze(mask, maskPos + 1, name, namePos)) return true;
        c = name[namePos]; 
        if ( (KAZE_toupper(c) < 'A') || (KAZE_toupper(c) > 'Z') ) return false;
        if (nameLen == 0) return false;
        return IP_enhanched_Kaze(mask,  maskPos, name, namePos + 1);
} else if (maskChar == '+') { // wildcard '+'/'%' any DIGIT character {or empty}/{and not empty},
        if (IP_enhanched_Kaze(mask, maskPos + 1, name, namePos)) return true;
        c = name[namePos]; 
        if ( (c < '0') || (c > '9') ) return false;
        if (nameLen == 0) return false;
        return IP_enhanched_Kaze(mask,  maskPos + 1, name, namePos + 1);
} else if (maskChar == '%') { // wildcard '+'/'%' any DIGIT character {or empty}/{and not empty},
        /*
        if (IP_enhanched_Kaze(mask, maskPos + 1, name, namePos)) 
        return true;
        */
        c = name[namePos]; 
        if ( (c < '0') || (c > '9') ) return false;
        if (nameLen == 0) return false;
        return IP_enhanched_Kaze(mask,  maskPos + 1, name, namePos + 1);
} else if (maskChar == '*') { // wildcard '*' any character(s) or empty,
        if (IP_enhanched_Kaze(mask, maskPos + 1, name, namePos)) return true;
        if (nameLen == 0) return false;
        return IP_enhanched_Kaze(mask, maskPos, name, namePos + 1);
} else {
        c = name[namePos];
        //if (maskChar != c)
	if (CaseSensitiveWildcardMatching_flag == 0) {
                if (KAZE_toupper(maskChar) != KAZE_toupper(c)) return false;
	} else {
                if ((maskChar) != (c)) return false;
	}
        return IP_enhanched_Kaze(mask,  maskPos + 1, name, namePos + 1);
}
} //static unsigned char IP_enhanched_Kaze (const char *mask, int maskPos, const char *name, int namePos) {

