// Last change: 2021-Dec-25

// manatarka.h:
// In order to compile properly, edit the next line from E:\qb64\internal\temp\recompile_win.bat:
// c_compiler\bin\g++ -s -Wfatal-errors ...
// Insert "-O3 -msse4.1 -maes", or even better "-O3 -mavx2 -maes" for YMM variants, so:
// c_compiler\bin\g++ -O3 -mavx2 -maes -s -Wfatal-errors ...

/*
Declare CustomType Library
    Sub memcpy (ByVal dest As _Offset, Byval source As _Offset, Byval bytes As Long)
End Declare

a$ = "1234567890"
b$ = "ABCDEFGHIJ"

memcpy _Offset(a$) + 5, _Offset(b$) + 5, 5
Print a$
*/

/*
Rem In folder 'E:\qb64\internal\temp' in 'recompile_win.bat' file had to add '-O2 -msse4.1' into compile line in order to get XMM going:

Rem @echo off
Rem cd %0\..\
Rem echo Recompiling...
Rem cd ../c
Rem c_compiler\bin\g++ -O2 -msse4.1 -s -Wfatal-errors -w -Wall qbx.cpp  libqb\os\win\libqb_2_0.1_0000000000000.o  -D DEPENDENCY_NO_SOCKETS -D DEPENDENCY_NO_PRINTER -D DEPENDENCY_NO_ICON -D DEPENDENCY_NO_SCREENIMAGE   parts\core\os\win\src.a -lopengl32 -lglu32   -mwindows -static-libgcc -static-libstdc++ -D GLEW_STATIC -D FREEGLUT_STATIC     -lwinmm -o "..\..\UCASE_showdown.exe"
Rem pause
*/

/*
Declare CustomType Library "manatarka"
    Sub UCASE_XMM (ByVal QWORDSsrc As _Offset, Byval QWORDSdst As _Offset, Byval bytesto As _Integer64)
    Sub UCASE_XMM_inplace (ByVal QWORDSsrc As _Offset, Byval bytesto As _Integer64)
    Function Railgun_Doublet%& (ByVal HaystackADDR As _Offset, Byval NeedleADDR As _Offset, Byval HaystackLEN As _Offset, Byval NeedleLEN As Long) ' the workaround in QB64 for lacking casting (in pointer arithmetic) is to define HaystackLEN as _Offset instead of LONG
    Function Railgun_Trolldom_64%& (ByVal HaystackADDR As _Offset, Byval NeedleADDR As _Offset, Byval HaystackLEN As _Offset, Byval NeedleLEN As Long) ' the workaround in QB64 for lacking casting (in pointer arithmetic) is to define HaystackLEN as _Offset instead of _Integer64
    Function Railgun_Nyotengu_XMM_YMM_ZMM%& (ByVal HaystackADDR As _Offset, Byval NeedleADDR As _Offset, Byval HaystackLEN As _Offset, Byval NeedleLEN As Long) ' the workaround in QB64 for lacking casting (in pointer arithmetic) is to define HaystackLEN as _Offset instead of _Integer64
    'char * Railgun_Doublet (char * pbTarget, char * pbPattern, uint32_t cbTarget, uint32_t cbPattern)
    'char * Railgun_Trolldom_64 (char * pbTarget, char * pbPattern, uint64_t cbTarget, uint32_t cbPattern)
    'char * Railgun_Nyotengu_XMM_YMM_ZMM (char * pbTarget, char * pbPattern, uint64_t cbTarget, uint32_t cbPattern) // Last change: 2020-Nov-30
    Sub DoubleDeuceAES_Gumbotron (ByVal buffer As _Offset, Byval bytesto As _Integer64, Byval LoPart As _Offset, Byval HiPart As _Offset) 'Note: This hasher uses AES extension, the CPU has to support it!
    Sub DoubleDeuceAES_Gumbotron_YMM (ByVal buffer As _Offset, Byval bytesto As _Integer64, Byval LoPart As _Offset, Byval HiPart As _Offset) 'Note: This hasher uses AES extension, the CPU has to support it!
    'void DoubleDeuceAES_Gumbotron(const uint8_t *buffer, size_t length, uint64_t *LoPart, uint64_t *HiPart) {

    Sub memcpyKAZE (ByVal dest As _Offset, Byval source As _Offset, Byval bytes As Long)
    Function memcmpKAZE% (ByVal buf1 As _Offset, Byval buf2 As _Offset, Byval bytes As Long)
End Declare
*/
//UCASE_XMM MhandleSRC.OFFSET, MhandleDST.OFFSET, bytesto

/*
#include <emmintrin.h> // SSE2 intrinsics
#include <smmintrin.h> // SSE4.1 intrinsics
#include <immintrin.h> // AVX intrinsics
#include <zmmintrin.h> // AVX2 intrinsics, definitions and declarations for use with 512-bit compiler intrinsics.
*/
#include <immintrin.h>
#include <stdint.h> // Needed for uint32_t

void UCASE_XMM(uint64_t QWORDSsrc[], uint64_t QWORDSdst[], int64_t bytesto) {

	int64_t i = 0;
	__m128i maska;
	__m128i maskz;
	__m128i mask32;
	__m128i maskaz;
	__m128i r0;
	char *QWORDSs = (char *)QWORDSsrc;
	char *QWORDSd = (char *)QWORDSdst;

	maska = _mm_set1_epi8( 'a' );
	maskz = _mm_set1_epi8( 'z' );
	mask32 = _mm_set1_epi8( 32 );

	for( ; i < bytesto/16 * 16 ; i+=16 )
	{
		r0 = _mm_loadu_si128( ( __m128i * )&QWORDSs[ i ] );

		// maskaz contains 0x00 where character between 'a' and 'z', 0xff otherwise.
		maskaz = _mm_or_si128( _mm_cmplt_epi8( r0, maska ), _mm_cmpgt_epi8( r0, maskz ) );

		// Set the 6th bit to 0 only for lowercase characters.
		r0 = _mm_andnot_si128( _mm_andnot_si128( maskaz, mask32 ), r0 );
		_mm_storeu_si128( ( __m128i * )&QWORDSd[ i ], r0 );
	}
}

void UCASE_XMM_inplace(uint64_t QWORDSsrc[], int64_t bytesto) {

	int64_t i = 0;
	__m128i maska;
	__m128i maskz;
	__m128i mask32;
	__m128i maskaz;
	__m128i r0;
	char *QWORDSs = (char *)QWORDSsrc;

	maska = _mm_set1_epi8( 'a' );
	maskz = _mm_set1_epi8( 'z' );
	mask32 = _mm_set1_epi8( 32 );

	for( ; i < bytesto/16 * 16 ; i+=16 )
	{
		r0 = _mm_loadu_si128( ( __m128i * )&QWORDSs[ i ] );

		// maskaz contains 0x00 where character between 'a' and 'z', 0xff otherwise.
		maskaz = _mm_or_si128( _mm_cmplt_epi8( r0, maska ), _mm_cmpgt_epi8( r0, maskz ) );

		// Set the 6th bit to 0 only for lowercase characters.
		r0 = _mm_andnot_si128( _mm_andnot_si128( maskaz, mask32 ), r0 );
		_mm_storeu_si128( ( __m128i * )&QWORDSs[ i ], r0 );
	}
}

void UCASE_XMM_inplace_NULL2SPC(uint64_t QWORDSsrc[], int64_t bytesto) {

	int64_t i = 0;
	__m128i maska;
	__m128i maskz;
	__m128i mask00;
	__m128i mask32;
	__m128i maskaz;
	__m128i maskNULL;
	__m128i r0;
	char *QWORDSs = (char *)QWORDSsrc;

	maska = _mm_set1_epi8( 'a' );
	maskz = _mm_set1_epi8( 'z' );
	mask00 = _mm_set1_epi8( 0 );
	mask32 = _mm_set1_epi8( 32 );

	for( ; i < bytesto/16 * 16 ; i+=16 )
	{
		r0 = _mm_loadu_si128( ( __m128i * )&QWORDSs[ i ] );

		// maskaz contains 0x00 where character between 'a' and 'z', 0xff otherwise.
		maskaz = _mm_or_si128( _mm_cmplt_epi8( r0, maska ), _mm_cmpgt_epi8( r0, maskz ) );
		// maskNULL contains 0x00 where character is NULL, 0xff otherwise.
		maskNULL = _mm_cmpgt_epi8( r0, mask00 );

		// Set the 6th bit to 0 only for lowercase characters.
		r0 = _mm_andnot_si128( _mm_andnot_si128( maskaz, mask32 ), r0 );
		// Set the 6th bit to 1 only for NULL characters.
		r0 = _mm_or_si128( _mm_andnot_si128( maskNULL, mask32 ), r0 );

		_mm_storeu_si128( ( __m128i * )&QWORDSs[ i ], r0 );
	}
}

// Railgun_Trolldom (the successor of Railgun_Swampshine_BailOut - avoiding second pattern comparison in BMH2 and pseudo-BMH4), copyleft 2016-Aug-19, Kaze.
// Railgun_Swampshine_BailOut, copyleft 2016-Aug-10, Kaze.
// Internet "home" page: http://www.codeproject.com/Articles/250566/Fastest-strstr-like-function-in-C
// My homepage (homeserver, often down): http://www.sanmayce.com/Railgun/
/*
!!!!!!!!!!!!!!!!!!!!!!!! BENCHMARKING GNU's memmem vs Railgun !!!!!!!!!!!!!!!!!!!!!!!! [
Add-on: 2016-Aug-22

Two things.

First, the fix from the last time was buggy, my apologies, now fixed, quite embarrassing since it is a simple left/right boundary check. It doesn't affect the speed, it appears as rare pattern hit misses.
Since I don't believe in saying "sorry" but in making things right, here my attempt to further disgrace my amateurish work follows:
Two years ago, I didn't pay due attention to adding 'Swampwalker' heuristic to the Railgun_Ennearch, I mean, only quick test was done and no real proofing - this was due not to a blunder of mine, nor carelessness, but overconfidence in my ability to write "on the fly". Stupid, indeed, however, when a coder gets momentum in writing simple etudes he starts gaining false confidence of mastering the subject, not good for sure!
Hopefully, other coders will learn to avoid such full of neglect style.

Second, wanted to present the heaviest testbed for search i.e. memmem() functions: it benefits the benchmarking (speed in real application) as well as bug-control.

The benchmark is downloadable at my INTERNET drive:
https://1drv.ms/u/s!AmWWFXGMzDmEglwjlUtnMJrfhosK

The speed showdown has three facets:
- compares the 64bit code generated from GCC 5.10 versus Intel 15.0 compilers;
- compares four types of datasets - search speed through English texts versus genome ACGT-type data versus binary versus UTF8;
- compares the tweaked Two-Way algorithm (implemented by Eric Blake) and adopted by GLIBC as memmem() versus my Railgun_Swampshine.

Note1: The GLIBC memmem() was taken from latest (2016-08-05) glibc 2.24 tar:
https://www.gnu.org/software/libc/
Note2: Eric Blake says that he enhanced the linearity of Two-Way by adding some sublinear paths, well, Railgun is all about sublinearity, so feel free to experiment with your own testfiles (worst-case-scenarios), just make such a file feed the compressor with it, then we will see how the LINEAR Two-Way behaves versus Railgun_Swampshine.
Note3: Just copy-and-paste 'Railgun_Swampshine' or 'Railgun_Ennearch' from the benchmark's source.

So the result on Core 2 Q9550s @2.83GHz DDR2 @666MHz / i5-2430M @3.00GHz DDR3 @666MHz:
--------------------------------------------------------------------------------------------------------------------------------
| Searcher                                  | GNU/GLIBC memmem()        | Railgun_Swampshine       | Railgun_Trolldom          | 
|--------------------------------------------------------------------------------------------------|---------------------------|
| Testfile\Compiler                         | Intel 15.0 | GCC 5.10     | Intel 15.0 | GCC 5.10    | Intel 15.0  | GCC 5.10    |
|------------------------------------------------------------------------------------------------------------------------------|
| Size: 27,703 bytes                        |     4506/- |   5330/14725 |    13198/- | 11581/15171 | 19105/22449 | 15493/21642 |
| Name: An_Interview_with_Carlos_Castaneda.TXT                          |            |             |             |             |
| LATENCY-WISE: Number of 'memmem()' Invocations: 308,062               |            |             |             |             |
| THROUGHPUT-WISE: Number of Total bytes Traversed: 3,242,492,648       |            |             |             |             |
|------------------------------------------------------------------------------------------------------------------------------|
| Size: 2,347,772 bytes                     |      190/- |      226/244 |     1654/- |   1729/1806 |   1794/1822 |   1743/1809 |
| Name: Gutenberg_EBook_Don_Quixote_996_(ANSI).txt                      |            |             |             |             |
| LATENCY-WISE: Number of 'memmem()' Invocations: 14,316,954            |            |             |             |             |
| THROUGHPUT-WISE: Number of Total bytes Traversed: 6,663,594,719,173   |            |             |             |             |
|------------------------------------------------------------------------------------------------------------------------------|
| Size: 899,425 bytes                       |      582/- |      760/816 |     3094/- |   2898/3088 |   3255/3289 |   2915/3322 |
| Name: Gutenberg_EBook_Dokoe_by_Hakucho_Masamune_(Japanese_UTF8).txt   |            |             |             |             |
| LATENCY-WISE: Number of 'memmem()' Invocations: 3,465,806             |            |             |             |             |
| THROUGHPUT-WISE: Number of Total bytes Traversed: 848,276,034,315     |            |             |             |             |
|------------------------------------------------------------------------------------------------------------------------------|
| Size: 4,487,433 bytes                     |      104/- |      109/116 |      445/- |     458/417 |     450/411 |     467/425 |
| Name: Dragonfly_genome_shotgun_sequence_(ACGT_alphabet).fasta         |            |             |             |             |
| LATENCY-WISE: Number of 'memmem()' Invocations: 20,540,375            |            |             |             |             |
| THROUGHPUT-WISE: Number of Total bytes Traversed: 13,592,530,857,131  |            |             |             |             |
|------------------------------------------------------------------------------------------------------------------------------|
| Size: 954,035 bytes                       |       99/- |      144/144 |      629/- |     580/682 |     634/807 |     585/725 |
| Name: LAOTZU_Wu_Wei_(BINARY).pdf                                      |            |             |             |             |
| LATENCY-WISE: Number of 'memmem()' Invocations: 27,594,933            |            |             |             |             |
| THROUGHPUT-WISE: Number of Total bytes Traversed: 8,702,455,122,519   |            |             |             |             |
|------------------------------------------------------------------------------------------------------------------------------|
| Size: 15,583,440 bytes                    |        -/- |          -/- |        -/- |     663/771 |     675/778 |     663/757 |
| Name: Arabian_Nights_complete.html                                    |            |             |             |             |
| LATENCY-WISE: Number of 'memmem()' Invocations: 72,313,262            |            |             |             |             |
| THROUGHPUT-WISE: Number of Total bytes Traversed: 105,631,163,854,099 |            |             |             |             |
--------------------------------------------------------------------------------------------------------------------------------

Note0: Railgun_Trolldom is slightly faster (both with Intel & GCC) than Railgun_Swampshine, this is mostly due to adding a bitwise BMH order 2 (8KB table overhead instead of 64KB) path - for haystacks <77777 bytes long - the warm-up is faster.
Note1: The numbers represent the rate (bytes/s) at which patterns/needles 4,5,6,8,9,10,12,13,14,16,17,18,24 bytes long are memmemed into 4KB, 256KB, 1MB, 256MB long haystacks.
in fact, these numbers are the compression speed using LZSS and memmem() as matchfinder.
Note2: The Arabian Nights is downloadable at:
https://ebooks.adelaide.edu.au/b/burton/richard/b97b/complete.html
Note3: On i5-2430M, TW is catching up since this CPU crunches instructions faster while the RAM speed is almost the same, Railgun suffers from the slow RAM fetches - the prefetcher and such suck.
Note4: With a simple English text 'Tales of 1001 Nights', 15,583,440 bytes long, the cumulative size of traversed haystack data is nearly 100TB, 105,631,163,854,099 ~ 1024^4 = 1,099,511,627,776.
Note5: With a simple French text 'Agatha_Christie_85-ebooks_(French)_TXT.tar', 32,007,168 bytes long, the cumulative size of traversed haystack data is nearly 200TB ~ 234,427,099,834,376.

Just to see how faster is Yann's Zstd in decompression (its level 12 is 377-331 MB/s faster), on Core 2 Q9550s @2.83GHz DDR2 @666MHz:
[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
D:\Nakamichi_Kintaro++_source_executables_64bit_(GCC510-vs-Intel150)_(TW-vs-RG)_BENCHMARK>Nakamichi_Kintaro++_Intel_15.0_64bit.exe Agatha_Christie_85-ebooks_(French)_TXT.tar
Nakamichi 'Kintaro++', written by Kaze, based on Nobuo Ito's LZSS source, babealicious suggestion by m^2 enforced, muffinesque suggestion by Jim Dempsey enforced.
Note1: This compile can handle files up to 1711MB.
Note2: The matchfinder/memmem() is Railgun_Trolldom.
Current priority class is HIGH_PRIORITY_CLASS.
Compressing 32007168 bytes ...
|; Each rotation means 64KB are encoded; Done 100%; Compression Ratio: 3.53:1
NumberOfFullLiterals (lower-the-better): 164
NumberOfFlushLiteralsHeuristic (bigger-the-better): 184323
Legend: WindowSizes: 1/2/3/4=Tiny/Short/Medium/Long
NumberOf(Tiny)Matches[Short]Window (4)[2]: 226869
NumberOf(Short)Matches[Short]Window (8)[2]: 119810
NumberOf(Medium)Matches[Short]Window (12)[2]: 71202
NumberOf(Long)Matches[Short]Window (16)[2]: 31955
NumberOf(MaxLong)Matches[Short]Window (24)[2]: 7078
NumberOf(Tiny)Matches[Medium]Window (5)[3]: 257313
NumberOf(Short)Matches[Medium]Window (9)[3]: 526493
NumberOf(Medium)Matches[Medium]Window (13)[3]: 285579
NumberOf(Long)Matches[Medium]Window (17)[3]: 158873
NumberOf(MaxLong)Matches[Medium]Window (24)[3]: 51276
NumberOf(Tiny)Matches[Long]Window (6)[4]: 41075
NumberOf(Short)Matches[Long]Window (10)[4]: 240454
NumberOf(Medium)Matches[Long]Window (14)[4]: 258653
NumberOf(Long)Matches[Long]Window (18)[4]: 209007
NumberOf(MaxLong)Matches[Long]Window (24)[4]: 190929
RAM-to-RAM performance: 605 bytes/s.
Compressed to 9076876 bytes.
LATENCY-WISE: Number of 'memmem()' Invocations: 102,091,852
THROUGHPUT-WISE: Number of Total bytes Traversed: 234,427,099,834,376

D:\Nakamichi_Kintaro++_source_executables_64bit_(GCC510-vs-Intel150)_(TW-vs-RG)_BENCHMARK>"Nakamichi_Kintaro++_Intel_15.0_64bit.exe" "Agatha_Christie_85-ebooks_(French)_TXT.tar.Nakamichi"
Nakamichi 'Kintaro++', written by Kaze, based on Nobuo Ito's LZSS source, babealicious suggestion by m^2 enforced, muffinesque suggestion by Jim Dempsey enforced.
Note1: This compile can handle files up to 1711MB.
Note2: The matchfinder/memmem() is Railgun_Trolldom.
Current priority class is HIGH_PRIORITY_CLASS.
Decompressing 9076876 bytes ...
RAM-to-RAM performance: 331 MB/s.
Compression Ratio (bigger-the-better): 3.53:1

D:\Nakamichi_Kintaro++_source_executables_64bit_(GCC510-vs-Intel150)_(TW-vs-RG)_BENCHMARK>zstd-windows-v0.8.1_win64.exe -h
*** zstd command line interface 64-bits v0.8.1, by Yann Collet ***
...

D:\Nakamichi_Kintaro++_source_executables_64bit_(GCC510-vs-Intel150)_(TW-vs-RG)_BENCHMARK>zstd-windows-v0.8.1_win64.exe -b12 "Agatha_Christie_85-ebooks_(French)_TXT.tar"
12#_(French)_TXT.tar :  32007168 ->   8965791 (3.570),   6.7 MB/s , 377.0 MB/s

D:\Nakamichi_Kintaro++_source_executables_64bit_(GCC510-vs-Intel150)_(TW-vs-RG)_BENCHMARK>zstd-windows-v0.8.1_win64.exe -b22 "Agatha_Christie_85-ebooks_(French)_TXT.tar"
22#_(French)_TXT.tar :  32007168 ->   6802321 (4.705),   1.0 MB/s , 260.7 MB/s

D:\Nakamichi_Kintaro++_source_executables_64bit_(GCC510-vs-Intel150)_(TW-vs-RG)_BENCHMARK>
]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]

Two-Way is significantly slower than BMH Order 2, the speed-down is in range:
- for TEXTUAL ANSI alphabets: 1729/226= 7.6x
- for TEXTUAL UTF8 alphabets: 2898/760= 3.8x
- for TEXTUAL ACGT alphabets:  458/109= 4.2x
- for BINARY-esque alphabets:  580/144= 4.0x

For faster RAM, than mine @666MHz, and for haystacks multimegabytes long, the speedup goes beyond 8x.

The benchmark shows the real behavior (both latency and raw speed) of the memmem variants, I added also the Thierry Lecroq's Two-Way implementation:
http://www-igm.univ-mlv.fr/~lecroq/string/node26.html#SECTION00260
However, Eric Blake's one is faster, so it was chosen for the speed showdown.

Once I measured the total length of traversed haystacks, and for files 100+MB long, it went ... quintillion of bytes i.e. petabytes - good torture it is.

!!!!!!!!!!!!!!!!!!!!!!!! BENCHMARKING GNU's memmem vs Railgun !!!!!!!!!!!!!!!!!!!!!!!! ]
*/
// 2014-Apr-27: The nasty SIGNED/UNSIGNED bug in 'Swampshines' which I illustrated several months ago in my fuzzy search article now is fixed here too:
/*
The bug is this (the variables 'i' and 'PRIMALposition' are uint32_t):
Next line assumes -19 >= 0 is true:
if ( (i-(PRIMALposition-1)) >= 0) printf ("THE NASTY BUG AGAIN: %d >= 0\n", i-(PRIMALposition-1));
Next line assumes -19 >= 0 is false:
if ( (signed int)(i-(PRIMALposition-1)) >= 0) printf ("THE NASTY BUG AGAIN: %d >= 0\n", i-(PRIMALposition-1));
And the actual fix:
...
// If we miss to hit then no need to compare the original: Needle
if ( count <= 0 ) {
// I have to add out-of-range checks...
// i-(PRIMALposition-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4

// "FIX" from 2014-Apr-27:
// Because (count-1) is negative, above fours are reduced to next twos:
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
	// The line below is BUGGY:
	//if ( (i-(PRIMALposition-1) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) && (&pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4) ) {
	// The line below is NOT OKAY, in fact so stupid, grrr, not a blunder, not carelessness, but overconfidence in writing "on the fly":
	//if ( ((signed int)(i-(PRIMALposition-1)+(count-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) ) {
// FIX from 2016-Aug-10 (two times failed to do simple boundary checks, pfu):
	if ( ((signed int)(i-(PRIMALposition-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)]+((PRIMALlengthCANDIDATE-4+1)-1) <= pbTargetMax - 4) ) {
		if ( *(uint32_t *)&pbTarget[i-(PRIMALposition-1)] == *(uint32_t *)(pbPattern-(PRIMALposition-1))) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
			count = PRIMALlengthCANDIDATE-4+1; 
			while ( count > 0 && *(uint32_t *)(pbPattern-(PRIMALposition-1)+count-1) == *(uint32_t *)(&pbTarget[i-(PRIMALposition-1)]+(count-1)) )
				count = count-4;
			if ( count <= 0 ) return(pbTarget+i-(PRIMALposition-1));	
		}
	}
}
...
*/
// Railgun_Swampshine_BailOut, copyleft 2014-Jan-31, Kaze.
// Caution: For better speed the case 'if (cbPattern==1)' was removed, so Pattern must be longer than 1 char.
#define NeedleThreshold2vs4swampLITE 9+10 // Should be bigger than 9. BMH2 works up to this value (inclusive), if bigger then BMH4 takes over. Should be <=255 otherwise the 0|1 BMH2 should be used.
#define QB64_32bit
// With QB64 x32 had to be 'uint32_t cbTarget' otherwise doesn't work - _Offset is 32bit and cannot handle 'uint64_t cbTarget'!
#ifdef QB64_32bit
char * Railgun_Trolldom_64 (char * pbTarget, char * pbPattern, uint32_t cbTarget, uint32_t cbPattern) 
#else
char * Railgun_Trolldom_64 (char * pbTarget, char * pbPattern, uint64_t cbTarget, uint32_t cbPattern) 
#endif
{
	char * pbTargetMax = pbTarget + cbTarget;
	register uint32_t ulHashPattern;
	//signed long count;
	signed long long count; // 2020-Jan-11

	unsigned char bm_Horspool_Order2[256*256]; // Bitwise soon...
	unsigned char bm_Horspool_Order2bitwise[(256*256)>>3]; // Bitwise soon...
	//uint32_t i, Gulliver;
	uint64_t i, Gulliver;

	//uint32_t PRIMALposition, PRIMALpositionCANDIDATE;
	//uint32_t PRIMALlength, PRIMALlengthCANDIDATE;
	//uint32_t j, FoundAtPosition;

	uint64_t PRIMALposition, PRIMALpositionCANDIDATE;
	uint64_t PRIMALlength, PRIMALlengthCANDIDATE;
	uint64_t j, FoundAtPosition;

// Quadruplet [
    //char * pbTargetMax = pbTarget + cbTarget;
    //register unsigned long  ulHashPattern;
    unsigned long ulHashTarget;
    //unsigned long count;
    unsigned long countSTATIC;
    unsigned char SINGLET;
    unsigned long Quadruplet2nd;
    unsigned long Quadruplet3rd;
    unsigned long Quadruplet4th;
    unsigned long  AdvanceHopperGrass;
// Quadruplet ]

// 2020-Jan-11 [
//	uint64_t A=3123123123, B=5123123123;
//if ((signed int)A > 0) printf("(signed int)3billion OK\n"); else printf("(signed int)3billion Bug\n");
//if ((signed int)B > 0) printf("(signed int)5billion OK\n"); else printf("(signed int)5billion Bug\n");
//if ((signed long long)A > 0) printf("(signed long long)3billion OK\n"); else printf("(signed long long)3billion Bug\n");
//if ((signed long long)B > 0) printf("(signed long long)5billion OK\n"); else printf("(signed long long)5billion Bug\n");

//(signed int)3billion Bug
//(signed int)5billion OK
//(signed long long)3billion OK
//(signed long long)5billion OK
// 2020-Jan-11 ]

//GLOBAL_Railgun_INVOCATIONS++; // 2020-Jan-29
//GLOBAL_Railgun_INVOCATIONS_ARRAY[cbPattern]++; // 2020-Jan-29

	if (cbPattern > cbTarget) return(NULL);

#ifdef LITE
return(NULL); // 2020-Feb-14
#endif

	if ( cbPattern<4 ) { 
		// SSE2 i.e. 128bit Assembly rules here, Mischa knows best:
		// ...
        	pbTarget = pbTarget+cbPattern;
		ulHashPattern = ( (*(char *)(pbPattern))<<8 ) + *(pbPattern+(cbPattern-1));
		if ( cbPattern==3 ) {
			for ( ;; ) {
				if ( ulHashPattern == ( (*(char *)(pbTarget-3))<<8 ) + *(pbTarget-1) ) {
					if ( *(char *)(pbPattern+1) == *(char *)(pbTarget-2) ) return((pbTarget-3));
				}
				if ( (char)(ulHashPattern>>8) != *(pbTarget-2) ) { 
					pbTarget++;
					if ( (char)(ulHashPattern>>8) != *(pbTarget-2) ) pbTarget++;
				}
				pbTarget++;
				if (pbTarget > pbTargetMax) return(NULL);
			}
		} else {
		}
		for ( ;; ) {
			if ( ulHashPattern == ( (*(char *)(pbTarget-2))<<8 ) + *(pbTarget-1) ) return((pbTarget-2));
			if ( (char)(ulHashPattern>>8) != *(pbTarget-1) ) pbTarget++;
			pbTarget++;
			if (pbTarget > pbTargetMax) return(NULL);
		}
	} else { //if ( cbPattern<4 )
		if ( cbPattern<=NeedleThreshold2vs4swampLITE ) { 

// This is the awesome 'Railgun_Quadruplet', it did outperform EVERYWHERE the fastest strstr (back in old GLIBCes ~2003, by the Dutch hacker Stephen R. van den Berg), suitable for short haystacks ~100bytes.
// Caution: For better speed the case 'if (cbPattern==1)' was removed, so Pattern must be longer than 1 char.
// char * Railgun_Quadruplet (char * pbTarget, char * pbPattern, unsigned long cbTarget, unsigned long cbPattern)
// ...
//    if (cbPattern > cbTarget) return(NULL);
//} else { //if ( cbPattern<4)
if (cbTarget<777) // This value is arbitrary(don't know how exactly), it ensures(at least must) better performance than 'Boyer_Moore_Horspool'.
{
        pbTarget = pbTarget+cbPattern;
        ulHashPattern = *(unsigned long *)(pbPattern);
//        countSTATIC = cbPattern-1;

    //SINGLET = *(char *)(pbPattern);
    SINGLET = ulHashPattern & 0xFF;
    Quadruplet2nd = SINGLET<<8;
    Quadruplet3rd = SINGLET<<16;
    Quadruplet4th = SINGLET<<24;

    for ( ;; )
    {
	AdvanceHopperGrass = 0;
	ulHashTarget = *(unsigned long *)(pbTarget-cbPattern);

        if ( ulHashPattern == ulHashTarget ) { // Three unnecessary comparisons here, but 'AdvanceHopperGrass' must be calculated - it has a higher priority.
//         count = countSTATIC;
//         while ( count && *(char *)(pbPattern+1+(countSTATIC-count)) == *(char *)(pbTarget-cbPattern+1+(countSTATIC-count)) ) {
//	       if ( countSTATIC==AdvanceHopperGrass+count && SINGLET != *(char *)(pbTarget-cbPattern+1+(countSTATIC-count)) ) AdvanceHopperGrass++;
//               count--;
//         }
         count = cbPattern-1;
         while ( count && *(char *)(pbPattern+(cbPattern-count)) == *(char *)(pbTarget-count) ) {
	       if ( cbPattern-1==AdvanceHopperGrass+count && SINGLET != *(char *)(pbTarget-count) ) AdvanceHopperGrass++;
               count--;
         }
         if ( count == 0) return((pbTarget-cbPattern));
        } else { // The goal here: to avoid memory accesses by stressing the registers.
    if ( Quadruplet2nd != (ulHashTarget & 0x0000FF00) ) {
         AdvanceHopperGrass++;
         if ( Quadruplet3rd != (ulHashTarget & 0x00FF0000) ) {
              AdvanceHopperGrass++;
              if ( Quadruplet4th != (ulHashTarget & 0xFF000000) ) AdvanceHopperGrass++;
         }
    }
	}

	AdvanceHopperGrass++;

	pbTarget = pbTarget + AdvanceHopperGrass;
        if (pbTarget > pbTargetMax)
            return(NULL);
    }
} else if (cbTarget<77777) { // The warmup/overhead is lowered from 64K down to 8K, however the bitwise additional instructions quickly start hurting the throughput/traversal.
// The below bitwise 0|1 BMH2 gives 1427 bytes/s for 'Don_Quixote' with Intel:
// The below bitwise 0|1 BMH2 gives 1242 bytes/s for 'Don_Quixote' with GCC:
//	} else { //if ( cbPattern<4 )
//		if ( cbPattern<=NeedleThreshold2vs4Decumanus ) { 
			// BMH order 2, needle should be >=4:
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			//for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]=0;}
			for (i=0; i < (256*256)>>3; i++) {bm_Horspool_Order2bitwise[i]=0;}
			//for (i=0; i < cbPattern-1; i++) bm_Horspool_Order2[*(unsigned short *)(pbPattern+i)]=1;
			for (i=0; i < cbPattern-2+1; i++) bm_Horspool_Order2bitwise[(*(unsigned short *)(pbPattern+i))>>3]= bm_Horspool_Order2bitwise[(*(unsigned short *)(pbPattern+i))>>3] | (1<<((*(unsigned short *)(pbPattern+i))&0x7));
			i=0;
			while (i <= cbTarget-cbPattern) {
				Gulliver = 1; // 'Gulliver' is the skip
				//if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1]] != 0 ) {
				if ( ( bm_Horspool_Order2bitwise[(*(unsigned short *)&pbTarget[i+cbPattern-1-1])>>3] & (1<<((*(unsigned short *)&pbTarget[i+cbPattern-1-1])&0x7)) ) != 0 ) {
					//if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1-2]] == 0 ) Gulliver = cbPattern-(2-1)-2; else {
					if ( ( bm_Horspool_Order2bitwise[(*(unsigned short *)&pbTarget[i+cbPattern-1-1-2])>>3] & (1<<((*(unsigned short *)&pbTarget[i+cbPattern-1-1-2])&0x7)) ) == 0 ) Gulliver = cbPattern-(2-1)-2; else {
						if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
							count = cbPattern-4+1; 
							while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
								count = count-4;
							if ( count <= 0 ) return(pbTarget+i);
						}
					}
				} else Gulliver = cbPattern-(2-1);
				i = i + Gulliver;
				//GlobalI++; // Comment it, it is only for stats.
			}
			return(NULL);
//		} else { // if ( cbPattern<=NeedleThreshold2vs4Decumanus )
} else { //if (cbTarget<777)
			// BMH order 2, needle should be >=4:
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]=0;}
			for (i=0; i < cbPattern-1; i++) bm_Horspool_Order2[*(unsigned short *)(pbPattern+i)]=1;
			i=0;
			while (i <= cbTarget-cbPattern) {
				Gulliver = 1; // 'Gulliver' is the skip
				if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1]] != 0 ) {
					if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1-2]] == 0 ) Gulliver = cbPattern-(2-1)-2; else {
						if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
							count = cbPattern-4+1; 
							while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
								count = count-4;
							if ( count <= 0 ) return(pbTarget+i);
						}
					}
				} else Gulliver = cbPattern-(2-1);
				i = i + Gulliver;
				//GlobalI++; // Comment it, it is only for stats.
			}
			return(NULL);

// Slower than Swampshine's simple 0|1 segment:
/*
PRIMALlength=0;
for (i=0+(1); i < cbPattern-2+1+(1)-(1); i++) { // -(1) because the last BB order 2 has no counterpart(s)
    FoundAtPosition = cbPattern;
    PRIMALpositionCANDIDATE=i;
    while ( PRIMALpositionCANDIDATE <= (FoundAtPosition-1) ) {
        j = PRIMALpositionCANDIDATE + 1;
        while ( j <= (FoundAtPosition-1) ) {
            if ( *(unsigned short *)(pbPattern+PRIMALpositionCANDIDATE-(1)) == *(unsigned short *)(pbPattern+j-(1)) ) FoundAtPosition = j;
            j++;
        }
        PRIMALpositionCANDIDATE++;
    }
    PRIMALlengthCANDIDATE = (FoundAtPosition-1)-i+(2);
    if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=i; PRIMALlength = PRIMALlengthCANDIDATE;}
}
PRIMALlengthCANDIDATE = cbPattern;
cbPattern = PRIMALlength;
pbPattern = pbPattern + (PRIMALposition-1);
if (cbPattern<4) {
	cbPattern = PRIMALlengthCANDIDATE;
	pbPattern = pbPattern - (PRIMALposition-1);
}
if (cbPattern == PRIMALlengthCANDIDATE) {
			// BMH order 2, needle should be >=4:
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]=0;}
			for (i=0; i < cbPattern-1; i++) bm_Horspool_Order2[*(unsigned short *)(pbPattern+i)]=1;
			i=0;
			while (i <= cbTarget-cbPattern) {
				Gulliver = 1; // 'Gulliver' is the skip
				if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1]] != 0 ) {
					if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1-2]] == 0 ) Gulliver = cbPattern-(2-1)-2; else {
						if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
							count = cbPattern-4+1; 
							while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
								count = count-4;
							if ( count <= 0 ) return(pbTarget+i);
						}
					}
				} else Gulliver = cbPattern-(2-1);
				i = i + Gulliver;
				//GlobalI++; // Comment it, it is only for stats.
			}
			return(NULL);
} else { //if (cbPattern == PRIMALlengthCANDIDATE) {
// BMH Order 2 [
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]= cbPattern-1;} // cbPattern-(Order-1) for Horspool; 'memset' if not optimized
			// The above 'for' gives  1424 bytes/s for 'Don_Quixote' with Intel:
			// The above 'for' gives  1431 bytes/s for 'Don_Quixote' with GCC:
			// The below 'memset' gives  1389 bytes/s for 'Don_Quixote' with Intel:
			// The below 'memset' gives  1432 bytes/s for 'Don_Quixote' with GCC:
			//memset(&bm_Horspool_Order2[0], cbPattern-1, 256*256); // Why why? It is 1700:1000 slower than above 'for'!?
			for (i=0; i < cbPattern-1; i++) bm_Horspool_Order2[*(unsigned short *)(pbPattern+i)]=i; // Rightmost appearance/position is needed
			i=0;
			while (i <= cbTarget-cbPattern) { 
				Gulliver = bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1]];
				if ( Gulliver != cbPattern-1 ) { // CASE #2: if equal means the pair (char order 2) is not found i.e. Gulliver remains intact, skip the whole pattern and fall back (Order-1) chars i.e. one char for Order 2
				if ( Gulliver == cbPattern-2 ) { // CASE #1: means the pair (char order 2) is found
					if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) {
						count = cbPattern-4+1; 
						while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
							count = count-4;
// If we miss to hit then no need to compare the original: Needle
if ( count <= 0 ) {
// I have to add out-of-range checks...
// i-(PRIMALposition-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4

// "FIX" from 2014-Apr-27:
// Because (count-1) is negative, above fours are reduced to next twos:
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
	// The line below is BUGGY:
	//if ( (i-(PRIMALposition-1) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) && (&pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4) ) {
	// The line below is NOT OKAY, in fact so stupid, grrr, not a blunder, not carelessness, but overconfidence in writing "on the fly":
	//if ( ((signed int)(i-(PRIMALposition-1)+(count-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) ) {
// FIX from 2016-Aug-10 (two times failed to do simple boundary checks, pfu):
	if ( ((signed long long)(i-(PRIMALposition-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)]+((PRIMALlengthCANDIDATE-4+1)-1) <= pbTargetMax - 4) ) { // 2020-jan-11
		if ( *(uint32_t *)&pbTarget[i-(PRIMALposition-1)] == *(uint32_t *)(pbPattern-(PRIMALposition-1))) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
			count = PRIMALlengthCANDIDATE-4+1; 
			while ( count > 0 && *(uint32_t *)(pbPattern-(PRIMALposition-1)+count-1) == *(uint32_t *)(&pbTarget[i-(PRIMALposition-1)]+(count-1)) )
				count = count-4;
			if ( count <= 0 ) return(pbTarget+i-(PRIMALposition-1));	
		}
	}
}
					}
					Gulliver = 1;
				} else
					Gulliver = cbPattern - Gulliver - 2; // CASE #3: the pair is found and not as suffix i.e. rightmost position
				}
				i = i + Gulliver;
				//GlobalI++; // Comment it, it is only for stats.
			}
			return(NULL);
// BMH Order 2 ]
} //if (cbPattern == PRIMALlengthCANDIDATE) {
*/

/*
So the result on Core 2 Q9550s @2.83GHz:
---------------------------------------------------------------------------------------------------------------------
| testfile\Searcher                         | GNU/GLIBC memmem()    | Railgun_Swampshine    | Railgun_Trolldom      | 
|-------------------------------------------------------------------------------------------|-----------------------|
| Compiler                                  | Intel 15.0 | GCC 5.10 | Intel 15.0 | GCC 5.10 | Intel 15.0 | GCC 5.10 |
|-------------------------------------------------------------------------------------------|-----------------------|
| The_Project_Gutenberg_EBook_of_Don        |        190 |      226 |       1654 |     1729 |       1147 |     1764 |
| _Quixote_996_(ANSI).txt                   |            |          |            |          |            |          |
| 2,347,772 bytes                           |            |          |            |          |            |          |
|-------------------------------------------------------------------------------------------|-----------------------|
| The_Project_Gutenberg_EBook_of_Dokoe      |        582 |      760 |       3094 |     2898 |       2410 |     3036 |
| _by_Hakucho_Masamune_(Japanese_UTF-8).txt |            |          |            |          |            |          |
| 899,425 bytes                             |            |          |            |          |            |          |
|-------------------------------------------------------------------------------------------|-----------------------|
| Dragonfly_genome_shotgun_sequence         |        104 |      109 |        445 |      458 |        484 |      553 |
| _(ACGT_alphabet).fasta                    |            |          |            |          |            |          |
| 4,487,433 bytes                           |            |          |            |          |            |          |
|-------------------------------------------------------------------------------------------|-----------------------|
| LAOTZU_Wu_Wei_(BINARY).pdf                |         99 |      144 |        629 |      580 |        185 |      570 |
| 954,035 bytes                             |            |          |            |          |            |          |
|-------------------------------------------------------------------------------------------|-----------------------|
Below segment (when compiled with Intel) is very slow, see Railgun_Trolldom two sub-columns above, compared to GCC:
*/
/*
// BMH Order 2 [
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]= (cbPattern-1);} // cbPattern-(Order-1) for Horspool; 'memset' if not optimized
			// The above 'for' is translated by Intel as:
//.B5.21::                        
//  0013f 83 c0 40         add eax, 64                            
//  00142 66 0f 7f 44 14 
//        60               movdqa XMMWORD PTR [96+rsp+rdx], xmm0  
//  00148 3d 00 00 01 00   cmp eax, 65536                         
//  0014d 66 0f 7f 44 14 
//        70               movdqa XMMWORD PTR [112+rsp+rdx], xmm0 
//  00153 66 0f 7f 84 14 
//        80 00 00 00      movdqa XMMWORD PTR [128+rsp+rdx], xmm0 
//  0015c 66 0f 7f 84 14 
//        90 00 00 00      movdqa XMMWORD PTR [144+rsp+rdx], xmm0 
//  00165 89 c2            mov edx, eax                           
//  00167 72 d6            jb .B5.21 
			//memset(&bm_Horspool_Order2[0], cbPattern-1, 256*256); // Why why? It is 1700:1000 slower than above 'for'!?
			// The above 'memset' is translated by Intel as:
//  00127 41 b8 00 00 01 
//        00               mov r8d, 65536                         
//  0012d 44 8b 26         mov r12d, DWORD PTR [rsi]              
//  00130 e8 fc ff ff ff   call _intel_fast_memset                
			// ! The problem is that 256*256, 64KB, is already too much, going bitwise i.e. 8KB is not that better, when 'cbPattern-1' is bigger than 255 - an unsigned char - then 
			// we must switch to 0|1 table i.e. present or not. Since we are in 'if ( cbPattern<=NeedleThreshold2vs4swampLITE ) {' branch and NeedleThreshold2vs4swampLITE, by default, is 19 - it is okay to use 'memset'. !
			for (i=0; i < cbPattern-1; i++) bm_Horspool_Order2[*(unsigned short *)(pbPattern+i)]=i; // Rightmost appearance/position is needed
			i=0;
			while (i <= cbTarget-cbPattern) { 
				Gulliver = bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1]];
				if ( Gulliver != cbPattern-1 ) { // CASE #2: if equal means the pair (char order 2) is not found i.e. Gulliver remains intact, skip the whole pattern and fall back (Order-1) chars i.e. one char for Order 2
				if ( Gulliver == cbPattern-2 ) { // CASE #1: means the pair (char order 2) is found
					if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) {
						count = cbPattern-4+1; 
						while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
							count = count-4;
						if ( count <= 0 ) return(pbTarget+i);	
					}
					Gulliver = 1;
				} else
					Gulliver = cbPattern - Gulliver - 2; // CASE #3: the pair is found and not as suffix i.e. rightmost position
				}
				i = i + Gulliver;
				//GlobalI++; // Comment it, it is only for stats.
			}
			return(NULL);
// BMH Order 2 ]
*/

} //if (cbTarget<777)

		} else { // if ( cbPattern<=NeedleThreshold2vs4swampLITE )

// Swampwalker_BAILOUT heuristic order 4 (Needle should be bigger than 4) [
// Needle: 1234567890qwertyuiopasdfghjklzxcv            PRIMALposition=01 PRIMALlength=33  '1234567890qwertyuiopasdfghjklzxcv'
// Needle: vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv            PRIMALposition=29 PRIMALlength=04  'vvvv'
// Needle: vvvvvvvvvvBOOMSHAKALAKAvvvvvvvvvv            PRIMALposition=08 PRIMALlength=20  'vvvBOOMSHAKALAKAvvvv'
// Needle: Trollland                                    PRIMALposition=01 PRIMALlength=09  'Trollland'
// Needle: Swampwalker                                  PRIMALposition=01 PRIMALlength=11  'Swampwalker'
// Needle: licenselessness                              PRIMALposition=01 PRIMALlength=15  'licenselessness'
// Needle: alfalfa                                      PRIMALposition=02 PRIMALlength=06  'lfalfa'
// Needle: Sandokan                                     PRIMALposition=01 PRIMALlength=08  'Sandokan'
// Needle: shazamish                                    PRIMALposition=01 PRIMALlength=09  'shazamish'
// Needle: Simplicius Simplicissimus                    PRIMALposition=06 PRIMALlength=20  'icius Simplicissimus'
// Needle: domilliaquadringenquattuorquinquagintillion  PRIMALposition=01 PRIMALlength=32  'domilliaquadringenquattuorquinqu'
// Needle: boom-boom                                    PRIMALposition=02 PRIMALlength=08  'oom-boom'
// Needle: vvvvv                                        PRIMALposition=01 PRIMALlength=04  'vvvv'
// Needle: 12345                                        PRIMALposition=01 PRIMALlength=05  '12345'
// Needle: likey-likey                                  PRIMALposition=03 PRIMALlength=09  'key-likey'
// Needle: BOOOOOM                                      PRIMALposition=03 PRIMALlength=05  'OOOOM'
// Needle: aaaaaBOOOOOM                                 PRIMALposition=02 PRIMALlength=09  'aaaaBOOOO'
// Needle: BOOOOOMaaaaa                                 PRIMALposition=03 PRIMALlength=09  'OOOOMaaaa'
PRIMALlength=0;
for (i=0+(1); i < cbPattern-((4)-1)+(1)-(1); i++) { // -(1) because the last BB (Building-Block) order 4 has no counterpart(s)
	FoundAtPosition = cbPattern - ((4)-1) + 1;
	PRIMALpositionCANDIDATE=i;
	while ( PRIMALpositionCANDIDATE <= (FoundAtPosition-1) ) {
		j = PRIMALpositionCANDIDATE + 1;
		while ( j <= (FoundAtPosition-1) ) {
			if ( *(uint32_t *)(pbPattern+PRIMALpositionCANDIDATE-(1)) == *(uint32_t *)(pbPattern+j-(1)) ) FoundAtPosition = j;
			j++;
		}
		PRIMALpositionCANDIDATE++;
	}
	PRIMALlengthCANDIDATE = (FoundAtPosition-1)-i+1 +((4)-1);
	if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=i; PRIMALlength = PRIMALlengthCANDIDATE;}
	if (cbPattern-i+1 <= PRIMALlength) break;
	if (PRIMALlength > 128) break; // Bail Out for 129[+]
}
// Swampwalker_BAILOUT heuristic order 4 (Needle should be bigger than 4) ]

// Swampwalker_BAILOUT heuristic order 2 (Needle should be bigger than 2) [
// Needle: 1234567890qwertyuiopasdfghjklzxcv            PRIMALposition=01 PRIMALlength=33  '1234567890qwertyuiopasdfghjklzxcv'
// Needle: vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv            PRIMALposition=31 PRIMALlength=02  'vv'
// Needle: vvvvvvvvvvBOOMSHAKALAKAvvvvvvvvvv            PRIMALposition=09 PRIMALlength=13  'vvBOOMSHAKALA'
// Needle: Trollland                                    PRIMALposition=05 PRIMALlength=05  'lland'
// Needle: Swampwalker                                  PRIMALposition=03 PRIMALlength=09  'ampwalker'
// Needle: licenselessness                              PRIMALposition=01 PRIMALlength=13  'licenselessne'
// Needle: alfalfa                                      PRIMALposition=04 PRIMALlength=04  'alfa'
// Needle: Sandokan                                     PRIMALposition=01 PRIMALlength=07  'Sandoka'
// Needle: shazamish                                    PRIMALposition=02 PRIMALlength=08  'hazamish'
// Needle: Simplicius Simplicissimus                    PRIMALposition=08 PRIMALlength=15  'ius Simplicissi'
// Needle: domilliaquadringenquattuorquinquagintillion  PRIMALposition=01 PRIMALlength=19  'domilliaquadringenq'
// Needle: DODO                                         PRIMALposition=02 PRIMALlength=03  'ODO'
// Needle: DODOD                                        PRIMALposition=03 PRIMALlength=03  'DOD'
// Needle: aaaDODO                                      PRIMALposition=02 PRIMALlength=05  'aaDOD'
// Needle: aaaDODOD                                     PRIMALposition=02 PRIMALlength=05  'aaDOD'
// Needle: DODOaaa                                      PRIMALposition=02 PRIMALlength=05  'ODOaa'
// Needle: DODODaaa                                     PRIMALposition=03 PRIMALlength=05  'DODaa'
/*
PRIMALlength=0;
for (i=0+(1); i < cbPattern-2+1+(1)-(1); i++) { // -(1) because the last BB order 2 has no counterpart(s)
    FoundAtPosition = cbPattern;
    PRIMALpositionCANDIDATE=i;
    while ( PRIMALpositionCANDIDATE <= (FoundAtPosition-1) ) {
        j = PRIMALpositionCANDIDATE + 1;
        while ( j <= (FoundAtPosition-1) ) {
            if ( *(unsigned short *)(pbPattern+PRIMALpositionCANDIDATE-(1)) == *(unsigned short *)(pbPattern+j-(1)) ) FoundAtPosition = j;
            j++;
        }
        PRIMALpositionCANDIDATE++;
    }
    PRIMALlengthCANDIDATE = (FoundAtPosition-1)-i+(2);
    if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=i; PRIMALlength = PRIMALlengthCANDIDATE;}
}
*/
// Swampwalker_BAILOUT heuristic order 2 (Needle should be bigger than 2) ]

/*
Legend:
'[]' points to BB forming left or right boundary;
'{}' points to BB being searched for;
'()' position of duplicate and new right boundary;

                       00000000011111111112222222222333
                       12345678901234567890123456789012
Example #1 for Needle: 1234567890qwertyuiopasdfghjklzxcv  NewNeedle = '1234567890qwertyuiopasdfghjklzxcv'
Example #2 for Needle: vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv  NewNeedle = 'vv'
Example #3 for Needle: vvvvvvvvvvBOOMSHAKALAKAvvvvvvvvvv  NewNeedle = 'vvBOOMSHAKALA'


     PRIMALlength=00; FoundAtPosition=33; 
Step 01_00: {}[12]34567890qwertyuiopasdfghjklzxc[v?] ! For position #01 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=01, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-01+(2)=33 !
Step 01_01: [{12}]34567890qwertyuiopasdfghjklzxc[v?] ! Searching for '12', FoundAtPosition = 33, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(33-1)-01+(2)=33 ! 
Step 01_02: [1{2]3}4567890qwertyuiopasdfghjklzxc[v?] ! Searching for '23', FoundAtPosition = 33, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(33-1)-01+(2)=33 ! 
...
Step 01_30: [12]34567890qwertyuiopasdfghjkl{zx}c[v?] ! Searching for 'zx', FoundAtPosition = 33, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(33-1)-01+(2)=33 ! 
Step 01_31: [12]34567890qwertyuiopasdfghjklz{xc}[v?] ! Searching for 'xc', FoundAtPosition = 33, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(33-1)-01+(2)=33 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
Step 02_00: {}1[23]4567890qwertyuiopasdfghjklzxc[v?] ! For position #02 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=02, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-02+(2)=32 !
Step 02_01: 1[{23}]4567890qwertyuiopasdfghjklzxc[v?] ! Searching for '23', FoundAtPosition = 33, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(33-1)-02+(2)=32 ! 
Step 02_02: 1[2{3]4}567890qwertyuiopasdfghjklzxc[v?] ! Searching for '34', FoundAtPosition = 33, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(33-1)-02+(2)=32 ! 
...
Step 02_29: 1[23]4567890qwertyuiopasdfghjkl{zx}c[v?] ! Searching for 'zx', FoundAtPosition = 33, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(33-1)-02+(2)=32 ! 
Step 02_30: 1[23]4567890qwertyuiopasdfghjklz{xc}[v?] ! Searching for 'xc', FoundAtPosition = 33, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(33-1)-02+(2)=32 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
...
Step 31_00: {}1234567890qwertyuiopasdfghjklz[xc][v?] ! For position #31 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=31, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-31+(2)=03 !
Step 31_01: 1234567890qwertyuiopasdfghjklz[{xc}][v?] ! Searching for 'xc', FoundAtPosition = 33, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(33-1)-31+(2)=03 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
     Result:
     PRIMALposition=01 PRIMALlength=33, NewNeedle = '1234567890qwertyuiopasdfghjklzxcv'


     PRIMALlength=00; FoundAtPosition=33; 
Step 01_00: {}[vv]vvvvvvvvvvvvvvvvvvvvvvvvvvvvvv[v?] ! For position #01 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=01, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-01+(2)=33 !
Step 01_01: [{v(v}]v)vvvvvvvvvvvvvvvvvvvvvvvvvvvvvv  ! Searching for 'vv', FoundAtPosition = 02, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(02-1)-01+(2)=02 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
Step 02_00: {}v[vv]vvvvvvvvvvvvvvvvvvvvvvvvvvvvv[v?] ! For position #02 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=02, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-02+(2)=32 !
Step 02_01: v[{v(v}]v)vvvvvvvvvvvvvvvvvvvvvvvvvvvvv  ! Searching for 'vv', FoundAtPosition = 03, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(03-1)-02+(2)=02 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
...
Step 31_00: {}vvvvvvvvvvvvvvvvvvvvvvvvvvvvvv[vv][v?] ! For position #31 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=31, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-31+(2)=03 !
Step 31_01: vvvvvvvvvvvvvvvvvvvvvvvvvvvvvv[{v(v}]v)  ! Searching for 'vv', FoundAtPosition = 32, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(32-1)-31+(2)=02 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
     Result:
     PRIMALposition=31 PRIMALlength=02, NewNeedle = 'vv'


     PRIMALlength=00; FoundAtPosition=33; 
Step 01_00: {}[vv]vvvvvvvvBOOMSHAKALAKAvvvvvvvvv[v?] ! For position #01 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=01, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-01+(2)=33 !
Step 01_01: [{v(v}]v)vvvvvvvBOOMSHAKALAKAvvvvvvvvvv  ! Searching for 'vv', FoundAtPosition = 02, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(02-1)-01+(2)=02 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
Step 02_00: {}v[vv]vvvvvvvBOOMSHAKALAKAvvvvvvvvv[v?] ! For position #02 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=02, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-02+(2)=32 !
Step 02_01: v[{v(v}]v)vvvvvvBOOMSHAKALAKAvvvvvvvvvv  ! Searching for 'vv', FoundAtPosition = 03, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(03-1)-02+(2)=02 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
...
Step 09_00: {}vvvvvvvv[vv]BOOMSHAKALAKAvvvvvvvvv[v?] ! For position #09 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=09, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-09+(2)=25 !
Step 09_01: vvvvvvvv[{vv}]BOOMSHAKALAKA(vv)vvvvvvvv  ! Searching for 'vv', FoundAtPosition = 24, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(24-1)-09+(2)=16 ! 
Step 09_02: vvvvvvvv[v{v]B}OOMSHAKALAKA[vv]vvvvvvvv  ! Searching for 'vB', FoundAtPosition = 24, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(24-1)-09+(2)=16 ! 
Step 09_03: vvvvvvvv[vv]{BO}OMSHAKALAKA[vv]vvvvvvvv  ! Searching for 'BO', FoundAtPosition = 24, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(24-1)-09+(2)=16 ! 
Step 09_04: vvvvvvvv[vv]B{OO}MSHAKALAKA[vv]vvvvvvvv  ! Searching for 'OO', FoundAtPosition = 24, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(24-1)-09+(2)=16 ! 
Step 09_05: vvvvvvvv[vv]BO{OM}SHAKALAKA[vv]vvvvvvvv  ! Searching for 'OM', FoundAtPosition = 24, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(24-1)-09+(2)=16 ! 
Step 09_06: vvvvvvvv[vv]BOO{MS}HAKALAKA[vv]vvvvvvvv  ! Searching for 'MS', FoundAtPosition = 24, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(24-1)-09+(2)=16 ! 
Step 09_07: vvvvvvvv[vv]BOOM{SH}AKALAKA[vv]vvvvvvvv  ! Searching for 'SH', FoundAtPosition = 24, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(24-1)-09+(2)=16 ! 
Step 09_08: vvvvvvvv[vv]BOOMS{HA}KALAKA[vv]vvvvvvvv  ! Searching for 'HA', FoundAtPosition = 24, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(24-1)-09+(2)=16 ! 
Step 09_09: vvvvvvvv[vv]BOOMSH{AK}AL(AK)Avvvvvvvvvv  ! Searching for 'AK', FoundAtPosition = 21, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(21-1)-09+(2)=13 ! 
Step 09_10: vvvvvvvv[vv]BOOMSHA{KA}L[AK]Avvvvvvvvvv  ! Searching for 'KA', FoundAtPosition = 21, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(21-1)-09+(2)=13 ! 
Step 09_11: vvvvvvvv[vv]BOOMSHAK{AL}[AK]Avvvvvvvvvv  ! Searching for 'AL', FoundAtPosition = 21, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(21-1)-09+(2)=13 ! 
Step 09_12: vvvvvvvv[vv]BOOMSHAKA{L[A}K]Avvvvvvvvvv  ! Searching for 'LA', FoundAtPosition = 21, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(21-1)-09+(2)=13 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
...
Step 31_00: {}vvvvvvvv[vv]BOOMSHAKALAKAvvvvvvvvv[v?] ! For position #31 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=31, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-31+(2)=03 !
Step 31_01: vvvvvvvvvvBOOMSHAKALAKAvvvvvvv[{v(v}]v)  ! Searching for 'vv', FoundAtPosition = 32, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(32-1)-31+(2)=02 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
     Result:
     PRIMALposition=09 PRIMALlength=13, NewNeedle = 'vvBOOMSHAKALA'
*/

// Here we have 4 or bigger NewNeedle, apply order 2 for pbPattern[i+(PRIMALposition-1)] with length 'PRIMALlength' and compare the pbPattern[i] with length 'cbPattern':
PRIMALlengthCANDIDATE = cbPattern;
cbPattern = PRIMALlength;
pbPattern = pbPattern + (PRIMALposition-1);

// Revision 2 commented section [
/*
if (cbPattern-1 <= 255) {
// BMH Order 2 [
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]= cbPattern-1;} // cbPattern-(Order-1) for Horspool; 'memset' if not optimized
			for (i=0; i < cbPattern-1; i++) bm_Horspool_Order2[*(unsigned short *)(pbPattern+i)]=i; // Rightmost appearance/position is needed
			i=0;
			while (i <= cbTarget-cbPattern) { 
				Gulliver = bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1]];
				if ( Gulliver != cbPattern-1 ) { // CASE #2: if equal means the pair (char order 2) is not found i.e. Gulliver remains intact, skip the whole pattern and fall back (Order-1) chars i.e. one char for Order 2
				if ( Gulliver == cbPattern-2 ) { // CASE #1: means the pair (char order 2) is found
					if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) {
						count = cbPattern-4+1; 
						while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
							count = count-4;
// If we miss to hit then no need to compare the original: Needle
if ( count <= 0 ) {
// I have to add out-of-range checks...
// i-(PRIMALposition-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4

// "FIX" from 2014-Apr-27:
// Because (count-1) is negative, above fours are reduced to next twos:
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
	// The line below is BUGGY:
	//if ( (i-(PRIMALposition-1) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) && (&pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4) ) {
	// The line below is NOT OKAY, in fact so stupid, grrr, not a blunder, not carelessness, but overconfidence in writing "on the fly":
	//if ( ((signed int)(i-(PRIMALposition-1)+(count-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) ) {
// FIX from 2016-Aug-10 (two times failed to do simple boundary checks, pfu):
	if ( ((signed long long)(i-(PRIMALposition-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)]+((PRIMALlengthCANDIDATE-4+1)-1) <= pbTargetMax - 4) ) { // 2020-jan-11
		if ( *(uint32_t *)&pbTarget[i-(PRIMALposition-1)] == *(uint32_t *)(pbPattern-(PRIMALposition-1))) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
			count = PRIMALlengthCANDIDATE-4+1; 
			while ( count > 0 && *(uint32_t *)(pbPattern-(PRIMALposition-1)+count-1) == *(uint32_t *)(&pbTarget[i-(PRIMALposition-1)]+(count-1)) )
				count = count-4;
			if ( count <= 0 ) return(pbTarget+i-(PRIMALposition-1));	
		}
	}
}
					}
					Gulliver = 1;
				} else
					Gulliver = cbPattern - Gulliver - 2; // CASE #3: the pair is found and not as suffix i.e. rightmost position
				}
				i = i + Gulliver;
				//GlobalI++; // Comment it, it is only for stats.
			}
			return(NULL);
// BMH Order 2 ]
} else {
			// BMH order 2, needle should be >=4:
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]=0;}
			for (i=0; i < cbPattern-1; i++) bm_Horspool_Order2[*(unsigned short *)(pbPattern+i)]=1;
			i=0;
			while (i <= cbTarget-cbPattern) {
				Gulliver = 1; // 'Gulliver' is the skip
				if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1]] != 0 ) {
					if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1-2]] == 0 ) Gulliver = cbPattern-(2-1)-2; else {
						if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
							count = cbPattern-4+1; 
							while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
								count = count-4;
// If we miss to hit then no need to compare the original: Needle
if ( count <= 0 ) {
// I have to add out-of-range checks...
// i-(PRIMALposition-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4

// "FIX" from 2014-Apr-27:
// Because (count-1) is negative, above fours are reduced to next twos:
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
	// The line below is BUGGY:
	//if ( (i-(PRIMALposition-1) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) && (&pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4) ) {
	// The line below is NOT OKAY, in fact so stupid, grrr, not a blunder, not carelessness, but overconfidence in writing "on the fly":
	//if ( ((signed int)(i-(PRIMALposition-1)+(count-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) ) {
// FIX from 2016-Aug-10 (two times failed to do simple boundary checks, pfu):
	if ( ((signed long long)(i-(PRIMALposition-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)]+((PRIMALlengthCANDIDATE-4+1)-1) <= pbTargetMax - 4) ) { // 2020-jan-11
		if ( *(uint32_t *)&pbTarget[i-(PRIMALposition-1)] == *(uint32_t *)(pbPattern-(PRIMALposition-1))) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
			count = PRIMALlengthCANDIDATE-4+1; 
			while ( count > 0 && *(uint32_t *)(pbPattern-(PRIMALposition-1)+count-1) == *(uint32_t *)(&pbTarget[i-(PRIMALposition-1)]+(count-1)) )
				count = count-4;
			if ( count <= 0 ) return(pbTarget+i-(PRIMALposition-1));	
		}
	}
}
						}
					}
				} else Gulliver = cbPattern-(2-1);
				i = i + Gulliver;
				//GlobalI++; // Comment it, it is only for stats.
			}
			return(NULL);
}
*/
// Revision 2 commented section ]

		if ( cbPattern<=NeedleThreshold2vs4swampLITE ) { 

			// BMH order 2, needle should be >=4:
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]=0;}
			// Above line is translated by Intel as:
//  0044c 41 b8 00 00 01 
//        00               mov r8d, 65536                         
//  00452 44 89 5c 24 20   mov DWORD PTR [32+rsp], r11d           
//  00457 44 89 54 24 60   mov DWORD PTR [96+rsp], r10d           
//  0045c e8 fc ff ff ff   call _intel_fast_memset                
			for (i=0; i < cbPattern-1; i++) bm_Horspool_Order2[*(unsigned short *)(pbPattern+i)]=1;
			i=0;
			while (i <= cbTarget-cbPattern) {
				Gulliver = 1; // 'Gulliver' is the skip
				if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1]] != 0 ) {
					if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1-2]] == 0 ) Gulliver = cbPattern-(2-1)-2; else {
						if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
							count = cbPattern-4+1; 
							while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
								count = count-4;

	if (cbPattern != PRIMALlengthCANDIDATE) { // No need of same comparison when Needle and NewNeedle are equal!
// If we miss to hit then no need to compare the original: Needle
if ( count <= 0 ) {
// I have to add out-of-range checks...
// i-(PRIMALposition-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4

// "FIX" from 2014-Apr-27:
// Because (count-1) is negative, above fours are reduced to next twos:
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
	// The line below is BUGGY:
	//if ( (i-(PRIMALposition-1) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) && (&pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4) ) {
	// The line below is NOT OKAY, in fact so stupid, grrr, not a blunder, not carelessness, but overconfidence in writing "on the fly":
	//if ( ((signed int)(i-(PRIMALposition-1)+(count-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) ) {
// FIX from 2016-Aug-10 (two times failed to do simple boundary checks, pfu):
	if ( ((signed long long)(i-(PRIMALposition-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)]+((PRIMALlengthCANDIDATE-4+1)-1) <= pbTargetMax - 4) ) { // 2020-jan-11
		if ( *(uint32_t *)&pbTarget[i-(PRIMALposition-1)] == *(uint32_t *)(pbPattern-(PRIMALposition-1))) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
			count = PRIMALlengthCANDIDATE-4+1; 
			while ( count > 0 && *(uint32_t *)(pbPattern-(PRIMALposition-1)+count-1) == *(uint32_t *)(&pbTarget[i-(PRIMALposition-1)]+(count-1)) )
				count = count-4;
			if ( count <= 0 ) return(pbTarget+i-(PRIMALposition-1));	
		}
	}
}
	} else { //if (cbPattern != PRIMALlengthCANDIDATE)
							if ( count <= 0 ) return(pbTarget+i);
	}
						}
					}
				} else Gulliver = cbPattern-(2-1);
				i = i + Gulliver;
				//GlobalI++; // Comment it, it is only for stats.
			}
			return(NULL);

		} else { // if ( cbPattern<=NeedleThreshold2vs4swampLITE )

			// BMH pseudo-order 4, needle should be >=8+2:
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]=0;}
			// In line below we "hash" 4bytes to 2bytes i.e. 16bit table, how to compute TOTAL number of BBs, 'cbPattern - Order + 1' is the number of BBs for text 'cbPattern' bytes long, for example, for cbPattern=11 'fastest fox' and Order=4 we have BBs = 11-4+1=8:
			//"fast"
			//"aste"
			//"stes"
			//"test"
			//"est "
			//"st f"
			//"t fo"
			//" fox"
			//for (i=0; i < cbPattern-4+1; i++) bm_Horspool_Order2[( *(unsigned short *)(pbPattern+i+0) + *(unsigned short *)(pbPattern+i+2) ) & ( (1<<16)-1 )]=1;
			//for (i=0; i < cbPattern-4+1; i++) bm_Horspool_Order2[( (*(uint32_t *)(pbPattern+i+0)>>16)+(*(uint32_t *)(pbPattern+i+0)&0xFFFF) ) & ( (1<<16)-1 )]=1;
			// Above line is replaced by next one with better hashing:
			for (i=0; i < cbPattern-4+1; i++) bm_Horspool_Order2[( (*(uint32_t *)(pbPattern+i+0)>>(16-1))+(*(uint32_t *)(pbPattern+i+0)&0xFFFF) ) & ( (1<<16)-1 )]=1;
			i=0;
			while (i <= cbTarget-cbPattern) {
				Gulliver = 1;
				//if ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2]>>16)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2]&0xFFFF) ) & ( (1<<16)-1 )] != 0 ) { // DWORD #1
				// Above line is replaced by next one with better hashing:
				if ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2]>>(16-1))+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2]&0xFFFF) ) & ( (1<<16)-1 )] != 0 ) { // DWORD #1
					//if ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]>>16)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]&0xFFFF) ) & ( (1<<16)-1 )] == 0 ) Gulliver = cbPattern-(2-1)-2-4; else {
					// Above line is replaced in order to strengthen the skip by checking the middle DWORD,if the two DWORDs are 'ab' and 'cd' i.e. [2x][2a][2b][2c][2d] then the middle DWORD is 'bc'.
					// The respective offsets (backwards) are: -10/-8/-6/-4 for 'xa'/'ab'/'bc'/'cd'.
					//if ( ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6]>>16)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6]&0xFFFF) ) & ( (1<<16)-1 )] ) + ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]>>16)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]&0xFFFF) ) & ( (1<<16)-1 )] ) + ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]>>16)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]&0xFFFF) ) & ( (1<<16)-1 )] ) < 3 ) Gulliver = cbPattern-(2-1)-2-4-2; else {
					// Above line is replaced by next one with better hashing:
					// When using (16-1) right shifting instead of 16 we will have two different pairs (if they are equal), the highest bit being lost do the job especialy for ASCII texts with no symbols in range 128-255.
					// Example for genomesque pair TT+TT being shifted by (16-1):
					// T            = 01010100
					// TT           = 01010100 01010100
					// TTTT         = 01010100 01010100 01010100 01010100
					// TTTT>>16     = 00000000 00000000 01010100 01010100
					// TTTT>>(16-1) = 00000000 00000000 10101000 10101000 <--- Due to the left shift by 1, the 8th bits of 1st and 2nd bytes are populated - usually they are 0 for English texts & 'ACGT' data.
					//if ( ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6]>>(16-1))+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6]&0xFFFF) ) & ( (1<<16)-1 )] ) + ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]>>(16-1))+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]&0xFFFF) ) & ( (1<<16)-1 )] ) + ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]>>(16-1))+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]&0xFFFF) ) & ( (1<<16)-1 )] ) < 3 ) Gulliver = cbPattern-(2-1)-2-4-2; else {
					// 'Maximus' uses branched 'if', again.
					if ( \
					( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6 +1]>>(16-1))+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6 +1]&0xFFFF) ) & ( (1<<16)-1 )] ) == 0 \
					|| ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4 +1]>>(16-1))+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4 +1]&0xFFFF) ) & ( (1<<16)-1 )] ) == 0 \
					) Gulliver = cbPattern-(2-1)-2-4-2 +1; else {
					// Above line is not optimized (several a SHR are used), we have 5 non-overlapping WORDs, or 3 overlapping WORDs, within 4 overlapping DWORDs so:
// [2x][2a][2b][2c][2d]
// DWORD #4
// [2a] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6]>>16) =     !SHR to be avoided! <--
// [2x] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6]&0xFFFF) =                        |
//     DWORD #3                                                                       |
// [2b] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]>>16) =     !SHR to be avoided!   |<--
// [2a] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]&0xFFFF) = ------------------------  |
//         DWORD #2                                                                      |
// [2c] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]>>16) =     !SHR to be avoided!      |<--
// [2b] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]&0xFFFF) = ---------------------------  |
//             DWORD #1                                                                     |
// [2d] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-0]>>16) =                                 |
// [2c] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-0]&0xFFFF) = ------------------------------
//
// So in order to remove 3 SHR instructions the equal extractions are:
// DWORD #4
// [2a] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]&0xFFFF) =  !SHR to be avoided! <--
// [2x] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6]&0xFFFF) =                        |
//     DWORD #3                                                                       |
// [2b] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]&0xFFFF) =  !SHR to be avoided!   |<--
// [2a] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]&0xFFFF) = ------------------------  |
//         DWORD #2                                                                      |
// [2c] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-0]&0xFFFF) =  !SHR to be avoided!      |<--
// [2b] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]&0xFFFF) = ---------------------------  |
//             DWORD #1                                                                     |
// [2d] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-0]>>16) =                                 |
// [2c] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-0]&0xFFFF) = ------------------------------
					//if ( ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]&0xFFFF)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6]&0xFFFF) ) & ( (1<<16)-1 )] ) + ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]&0xFFFF)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]&0xFFFF) ) & ( (1<<16)-1 )] ) + ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-0]&0xFFFF)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]&0xFFFF) ) & ( (1<<16)-1 )] ) < 3 ) Gulliver = cbPattern-(2-1)-2-6; else {
// Since the above Decumanus mumbo-jumbo (3 overlapping lookups vs 2 non-overlapping lookups) is not fast enough we go DuoDecumanus or 3x4:
// [2y][2x][2a][2b][2c][2d]
// DWORD #3
//         DWORD #2
//                 DWORD #1
					//if ( ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]>>16)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]&0xFFFF) ) & ( (1<<16)-1 )] ) + ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-8]>>16)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-8]&0xFFFF) ) & ( (1<<16)-1 )] ) < 2 ) Gulliver = cbPattern-(2-1)-2-8; else {
						if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) {
							// Order 4 [
						// Let's try something "outrageous" like comparing with[out] overlap BBs 4bytes long instead of 1 byte back-to-back:
						// Inhere we are using order 4, 'cbPattern - Order + 1' is the number of BBs for text 'cbPattern' bytes long, for example, for cbPattern=11 'fastest fox' and Order=4 we have BBs = 11-4+1=8:
						//0:"fast" if the comparison failed here, 'count' is 1; 'Gulliver' is cbPattern-(4-1)-7
						//1:"aste" if the comparison failed here, 'count' is 2; 'Gulliver' is cbPattern-(4-1)-6
						//2:"stes" if the comparison failed here, 'count' is 3; 'Gulliver' is cbPattern-(4-1)-5
						//3:"test" if the comparison failed here, 'count' is 4; 'Gulliver' is cbPattern-(4-1)-4
						//4:"est " if the comparison failed here, 'count' is 5; 'Gulliver' is cbPattern-(4-1)-3
						//5:"st f" if the comparison failed here, 'count' is 6; 'Gulliver' is cbPattern-(4-1)-2
						//6:"t fo" if the comparison failed here, 'count' is 7; 'Gulliver' is cbPattern-(4-1)-1
						//7:" fox" if the comparison failed here, 'count' is 8; 'Gulliver' is cbPattern-(4-1)
							count = cbPattern-4+1; 
							// Below comparison is UNIdirectional:
							while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
								count = count-4;

	if (cbPattern != PRIMALlengthCANDIDATE) { // No need of same comparison when Needle and NewNeedle are equal!
// count = cbPattern-4+1 = 23-4+1 = 20
// boomshakalakaZZZZZZ[ZZZZ] 20
// boomshakalakaZZ[ZZZZ]ZZZZ 20-4
// boomshakala[kaZZ]ZZZZZZZZ 20-8 = 12
// boomsha[kala]kaZZZZZZZZZZ 20-12 = 8
// boo[msha]kalakaZZZZZZZZZZ 20-16 = 4

// If we miss to hit then no need to compare the original: Needle
if ( count <= 0 ) {
// I have to add out-of-range checks...
// i-(PRIMALposition-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4

// "FIX" from 2014-Apr-27:
// Because (count-1) is negative, above fours are reduced to next twos:
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
	// The line below is BUGGY:
	//if ( (i-(PRIMALposition-1) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) && (&pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4) ) {
	// The line below is NOT OKAY, in fact so stupid, grrr, not a blunder, not carelessness, but overconfidence in writing "on the fly":
	//if ( ((signed int)(i-(PRIMALposition-1)+(count-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) ) {
// FIX from 2016-Aug-10 (two times failed to do simple boundary checks, pfu):
	if ( ((signed long long)(i-(PRIMALposition-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)]+((PRIMALlengthCANDIDATE-4+1)-1) <= pbTargetMax - 4) ) { // 2020-jan-11
		if ( *(uint32_t *)&pbTarget[i-(PRIMALposition-1)] == *(uint32_t *)(pbPattern-(PRIMALposition-1))) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
			count = PRIMALlengthCANDIDATE-4+1; 
			while ( count > 0 && *(uint32_t *)(pbPattern-(PRIMALposition-1)+count-1) == *(uint32_t *)(&pbTarget[i-(PRIMALposition-1)]+(count-1)) )
				count = count-4;
			if ( count <= 0 ) return(pbTarget+i-(PRIMALposition-1));	
		}
	}
}
	} else { //if (cbPattern != PRIMALlengthCANDIDATE)
							if ( count <= 0 ) return(pbTarget+i);
	}

							// In order to avoid only-left or only-right WCS the memcmp should be done as left-to-right and right-to-left AT THE SAME TIME.
							// Below comparison is BIdirectional. It pays off when needle is 8+++ long:
//							for (count = cbPattern-4+1; count > 0; count = count-4) {
//								if ( *(uint32_t *)(pbPattern+count-1) != *(uint32_t *)(&pbTarget[i]+(count-1)) ) {break;};
//								if ( *(uint32_t *)(pbPattern+(cbPattern-4+1)-count) != *(uint32_t *)(&pbTarget[i]+(cbPattern-4+1)-count) ) {count = (cbPattern-4+1)-count +(1); break;} // +(1) because two lookups are implemented as one, also no danger of 'count' being 0 because of the fast check outwith the 'while': if ( *(uint32_t *)&pbTarget[i] == ulHashPattern)
//							}
//							if ( count <= 0 ) return(pbTarget+i);
								// Checking the order 2 pairs in mismatched DWORD, all the 3:
								//if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+count-1]] == 0 ) Gulliver = count; // 1 or bigger, as it should
								//if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+count-1+1]] == 0 ) Gulliver = count+1; // 1 or bigger, as it should
								//if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+count-1+1+1]] == 0 ) Gulliver = count+1+1; // 1 or bigger, as it should
							//	if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+count-1]] + bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+count-1+1]] + bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+count-1+1+1]] < 3 ) Gulliver = count; // 1 or bigger, as it should, THE MIN(count,count+1,count+1+1)
								// Above compound 'if' guarantees not that Gulliver > 1, an example:
								// Needle:    fastest tax
								// Window: ...fastast tax...
								// After matching ' tax' vs ' tax' and 'fast' vs 'fast' the mismathced DWORD is 'test' vs 'tast':
								// 'tast' when factorized down to order 2 yields: 'ta','as','st' - all the three when summed give 1+1+1=3 i.e. Gulliver remains 1.
								// Roughly speaking, this attempt maybe has its place in worst-case scenarios but not in English text and even not in ACGT data, that's why I commented it in original 'Shockeroo'.
								//if ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+count-1]>>16)+(*(uint32_t *)&pbTarget[i+count-1]&0xFFFF) ) & ( (1<<16)-1 )] == 0 ) Gulliver = count; // 1 or bigger, as it should
								// Above line is replaced by next one with better hashing:
//								if ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+count-1]>>(16-1))+(*(uint32_t *)&pbTarget[i+count-1]&0xFFFF) ) & ( (1<<16)-1 )] == 0 ) Gulliver = count; // 1 or bigger, as it should
							// Order 4 ]
						}
					}
				} else Gulliver = cbPattern-(2-1)-2; // -2 because we check the 4 rightmost bytes not 2.
				i = i + Gulliver;
				//GlobalI++; // Comment it, it is only for stats.
			}
			return(NULL);

		} // if ( cbPattern<=NeedleThreshold2vs4swampLITE )
		} // if ( cbPattern<=NeedleThreshold2vs4swampLITE )
	} //if ( cbPattern<4 )
}

// For short needles, and mainly haystacks, 'Doublet' is quite effective. Consider it or 'Quadruplet'.
// Fixed version from 2012-Feb-27.
// Caution: For better speed the case 'if (cbPattern==1)' was removed, so Pattern must be longer than 1 char.
char * Railgun_Doublet (char * pbTarget, char * pbPattern, uint32_t cbTarget, uint32_t cbPattern)
{
	char * pbTargetMax = pbTarget + cbTarget;
	register uint32_t ulHashPattern;
	uint32_t ulHashTarget, count, countSTATIC;

	if (cbPattern > cbTarget) return(NULL);

	countSTATIC = cbPattern-2;

	pbTarget = pbTarget+cbPattern;
	ulHashPattern = (*(uint16_t *)(pbPattern));

	for ( ;; ) {
		if ( ulHashPattern == (*(uint16_t *)(pbTarget-cbPattern)) ) {
			count = countSTATIC;
			while ( count && *(char *)(pbPattern+2+(countSTATIC-count)) == *(char *)(pbTarget-cbPattern+2+(countSTATIC-count)) ) {
				count--;
			}
			if ( count == 0 ) return((pbTarget-cbPattern));
		}
		pbTarget++;
		if (pbTarget > pbTargetMax) return(NULL);
	}
}

#define XMMtengu
// Caution: It doesn't work for needles 1 byte long!
#ifdef QB64_32bit
char * Railgun_Nyotengu_XMM_YMM_ZMM (char * pbTarget, char * pbPattern, uint32_t cbTarget, uint32_t cbPattern) // Last change: 2020-Nov-30
#else
char * Railgun_Nyotengu_XMM_YMM_ZMM (char * pbTarget, char * pbPattern, uint64_t cbTarget, uint32_t cbPattern) // Last change: 2020-Nov-30
//char * Railgun_Nyotengu_XMM_YMM_ZMM (char * pbTarget, char * pbPattern, uint32_t cbTarget, uint32_t cbPattern)
#endif

{
	char * pbTargetMax = pbTarget + cbTarget;
	register uint32_t ulHashPattern;
	register uint32_t ulHashTarget;
	signed long count;

	unsigned char SINGLET;
	uint32_t Quadruplet2nd;
	uint32_t Quadruplet3rd;
	uint32_t Quadruplet4th;

	uint32_t AdvanceHopperGrass;

	size_t i;
	size_t j;
	size_t VECTORchunks;
	uint32_t mask;
	//uint8_t mask;

#ifdef XMMtengu
	int SkipWholeVector=16;
	__m128i last4;
	__m128i last1;
	__m128i first2;
	__m128i first4;
	__m128i HaystackVector1;
	__m128i HaystackVector2;
	__m128i HaystackVector3;
	__m128i HaystackVector4;

	__m128i EQD1;
	__m128i EQD2;
	__m128i EQD3;
	__m128i EQD4;

	__m128i FinalVector12;
	__m128i FinalVector34;
#endif 

#ifdef YMMtengu
	int SkipWholeVector=32;
	__m256i last4;
	__m256i last1;
	__m256i first2;
	__m256i first4;
	__m256i HaystackVector1;
	__m256i HaystackVector2;
	__m256i HaystackVector3;
	__m256i HaystackVector4;

	__m256i EQD1;
	__m256i EQD2;
	__m256i EQD3;
	__m256i EQD4;

	__m256i FinalVector12;
	__m256i FinalVector34;
#endif 

#ifdef ZMMtengu
	int SkipWholeVector=64;
	__m512i last4;
	__m512i last1;
	__m512i first2;
	__m512i first4;
	__m512i HaystackVector1;
	__m512i HaystackVector2;
	__m512i HaystackVector3;
	__m512i HaystackVector4;

	uint16_t EQD1mask16;
	uint16_t EQD2mask16;
	uint16_t EQD3mask16;
	uint16_t EQD4mask16;

	uint16_t FinalVector12mask16;
	uint16_t FinalVector34mask16;
#endif 

	if (cbPattern > cbTarget) return(NULL);

	if ( cbPattern<4 ) { // needle 2..3; SCALAR

        	pbTarget = pbTarget+cbPattern;
		ulHashPattern = ( (*(char *)(pbPattern))<<8 ) + *(pbPattern+(cbPattern-1));
		if ( cbPattern==3 ) {
			for ( ;; ) {
				if ( ulHashPattern == ( (*(char *)(pbTarget-3))<<8 ) + *(pbTarget-1) ) {
					if ( *(char *)(pbPattern+1) == *(char *)(pbTarget-2) ) return((pbTarget-3));
				}
				if ( (char)(ulHashPattern>>8) != *(pbTarget-2) ) { 
					pbTarget++;
					if ( (char)(ulHashPattern>>8) != *(pbTarget-2) ) pbTarget++;
				}
				pbTarget++;
				if (pbTarget > pbTargetMax) return(NULL);
			}
		} else {
		}
		for ( ;; ) {
			if ( ulHashPattern == ( (*(char *)(pbTarget-2))<<8 ) + *(pbTarget-1) ) return((pbTarget-2));
			if ( (char)(ulHashPattern>>8) != *(pbTarget-1) ) pbTarget++;
			pbTarget++;
			if (pbTarget > pbTargetMax) return(NULL);
		}

	} else { // Below: haystack <128; needle >=4; SCALAR
		if (cbTarget<128) { // This value is arbitrary (don't know how exactly), it ensures (at least must) better performance than 'Boyer_Moore_Horspool'.

		pbTarget = pbTarget+cbPattern;
		ulHashPattern = *(uint32_t *)(pbPattern);
		SINGLET = ulHashPattern & 0xFF;
		Quadruplet2nd = SINGLET<<8;
		Quadruplet3rd = SINGLET<<16;
		Quadruplet4th = SINGLET<<24;
		for ( ;; ) {
			AdvanceHopperGrass = 0;
			ulHashTarget = *(uint32_t *)(pbTarget-cbPattern);
			if ( ulHashPattern == ulHashTarget ) { // Three unnecessary comparisons here, but 'AdvanceHopperGrass' must be calculated - it has a higher priority.
				count = cbPattern-1;
				while ( count && *(char *)(pbPattern+(cbPattern-count)) == *(char *)(pbTarget-count) ) {
					if ( cbPattern-1==AdvanceHopperGrass+count && SINGLET != *(char *)(pbTarget-count) ) AdvanceHopperGrass++;
					count--;
				}
				if ( count == 0) return((pbTarget-cbPattern));
			} else { // The goal here: to avoid memory accesses by stressing the registers.
				if ( Quadruplet2nd != (ulHashTarget & 0x0000FF00) ) {
					AdvanceHopperGrass++;
					if ( Quadruplet3rd != (ulHashTarget & 0x00FF0000) ) {
						AdvanceHopperGrass++;
						if ( Quadruplet4th != (ulHashTarget & 0xFF000000) ) AdvanceHopperGrass++;
					}
				}
			}
			AdvanceHopperGrass++;
			pbTarget = pbTarget + AdvanceHopperGrass;
			if (pbTarget > pbTargetMax) return(NULL);
		}
		} else { // Below: haystack >=128; needle >=4; VECTOR

		// Stage 1: SSE2 or AVX2 i.e. 16 or 32 strides.
		// Stage 2: Dealing with the eventual remainder.
		//          Careful! Remainder starts (overlapping with the last 32byte chunk, if Needle<32) at NEXT position to 32*(YMM_Chunks_Traversed)+Order4-Needle_Length = 2*32+4-14 = 54:
		//          Chunk #0                          Chunk #1                          Remainder
		//          [00000000001111111111222222222233][33333333444444444455555555556666][6666...
		//          [01234567890123456789012345678901][23456789012345678901234567890123][4567...
		//                                                                  Linus Torva  lds  ! The needle's postfix of order 4 was sought up to 63 (ensuring the 32 bytes skips).
		//                                                                   Linus Torv  alds  ! Then next possible hit is at 54 position, or suffix starting at next to 63 or 63+1=64.
		// The main idea: Stressing the registers as it was done in Quadruplet (the above fastest etude) - outperforms Stephen R. van den Berg's strstr at http://www.scs.stanford.edu/histar/src/pkg/uclibc/libc/string/generic/strstr.c
		// __m256i _mm256_cmpeq_epi32 (__m256i a, __m256i b) needs AVX2; the more attractive __mmask8 _mm256_cmpeq_epi32_mask (__m256i a, __m256i b) needs AVX512??
		
// Pattern: "Linus Torvalds" 
// Order4:            [    ] skip 32 if not a single occurrence of 'alds' within YMM + (Order - 1) = 32 + 3 = 35 bytes window:
// Haystack:                                 "otto.......................Torvalds" 
// YMM HaystackVector1:                      "otto.......................Torva" 
// YMM HaystackVector2:                      "tto.......................Torval" 
// YMM HaystackVector3:                      "to.......................Torvald" 
// YMM HaystackVector4:                      "o.......................Torvalds" 
// YMM Vector1:                              "aldsaldsaldsaldsaldsaldsaldsalds" 
// 
// Mask1=(HaystackVector1 eqd Vector1):       0   0   0   0   0   0   0   0     ! 8bit !
// Mask2=(HaystackVector2 eqd Vector1):       0   0   0   0   0   0   0   0     ! 8bit !
// Mask3=(HaystackVector3 eqd Vector1):       0   0   0   0   0   0   0   0     ! 8bit !
// Mask4=(HaystackVector4 eqd Vector1):       0   0   0   0   0   0   0   1     ! 8bit !
// Result=(Mask1 OR Mask2 OR Mask3 OR Mask4): 0   0   0   0   0   0   0   1     ! 8bit !

// printf("&pbPattern[cbPattern - 1 -3] = %s\n",&pbPattern[cbPattern - 1 -3]); //debug

#ifdef XMMtengu
	VECTORchunks = cbTarget/SkipWholeVector -1; // in here, ensured at least 7 chunks; in order to avoid past haystack XMM reads - decrease 1 chunk and finish with Scalar_Quadruplet
	// The preemptive search for the first char is slower SIGNIFICANTLY on i7 3rd gen?!
//	last1 = _mm_set1_epi8(*(uint8_t*)&pbPattern[0]); //cbPattern - 1
//	first2 = _mm_set1_epi16(*(uint16_t*)&pbPattern[0]); 
	first4 = _mm_set1_epi32(*(uint32_t*)&pbPattern[0]);
	for (i = 0; i < VECTORchunks*SkipWholeVector; i += SkipWholeVector) {
	HaystackVector1 = _mm_loadu_si128 ((const __m128i*)(pbTarget + i + 0));
//	EQD1 = _mm_cmpeq_epi8(HaystackVector1, last1);
//	mask = _mm_movemask_epi8( EQD1 );

//	if ( mask != 0 ) 
	{
	HaystackVector2 = _mm_loadu_si128 ((const __m128i*)(pbTarget + i + 1));
	EQD1 = _mm_cmpeq_epi32(HaystackVector1, first4);
	EQD2 = _mm_cmpeq_epi32(HaystackVector2, first4);
	HaystackVector3 = _mm_loadu_si128 ((const __m128i*)(pbTarget + i + 2));
	HaystackVector4 = _mm_loadu_si128 ((const __m128i*)(pbTarget + i + 3));
	EQD3 = _mm_cmpeq_epi32(HaystackVector3, first4);
	EQD4 = _mm_cmpeq_epi32(HaystackVector4, first4);

	FinalVector12 = _mm_or_si128(EQD1, EQD2);
	FinalVector34 = _mm_or_si128(EQD3, EQD4);

	mask = _mm_movemask_ps( _mm_castsi128_ps(_mm_or_si128(FinalVector12, FinalVector34)) );
	}

	_mm_prefetch((char*)(pbTarget + 64*64), _MM_HINT_T0);
#endif 
#ifdef YMMtengu
	VECTORchunks = cbTarget/SkipWholeVector -1; // in here, ensured at least 3 chunks; in order to avoid past haystack YMM reads - decrease 1 chunk and finish with Scalar_Quadruplet
//	last1 = _mm256_set1_epi8(*(uint8_t*)&pbPattern[0]); //cbPattern - 1
	first4 = _mm256_set1_epi32(*(uint32_t*)&pbPattern[0]);
	for (i = 0; i < VECTORchunks*SkipWholeVector; i += SkipWholeVector) {
	HaystackVector1 = _mm256_loadu_si256((const __m256i*)(pbTarget + i + 0));
//	EQD1 = _mm256_cmpeq_epi8(HaystackVector1, last1);
//	mask = _mm256_movemask_epi8( EQD1 );

//	if ( mask != 0 ) 
	{
	HaystackVector2 = _mm256_loadu_si256((const __m256i*)(pbTarget + i + 1));
	EQD1 = _mm256_cmpeq_epi32(HaystackVector1, first4);
	EQD2 = _mm256_cmpeq_epi32(HaystackVector2, first4);
	HaystackVector3 = _mm256_loadu_si256((const __m256i*)(pbTarget + i + 2));
	HaystackVector4 = _mm256_loadu_si256((const __m256i*)(pbTarget + i + 3));
	EQD3 = _mm256_cmpeq_epi32(HaystackVector3, first4);
	EQD4 = _mm256_cmpeq_epi32(HaystackVector4, first4);

	FinalVector12 = _mm256_or_si256(EQD1, EQD2);
	FinalVector34 = _mm256_or_si256(EQD3, EQD4);

	mask = _mm256_movemask_ps( _mm256_castsi256_ps(_mm256_or_si256(FinalVector12, FinalVector34)) );
	}
	_mm_prefetch((char*)(pbTarget + 64*64), _MM_HINT_T0);
#endif 
// The vector/main loop is (0012c-000fd+2)+(00175-0016d+2)= 59 bytes
/*
; mark_description "Intel(R) C++ Compiler XE for applications running on IA-32, Version 15.0.0.108 Build 20140726";
; mark_description "-O3 -DYMMtengu -D_WIN32_ENVIRONMENT_ -D_N_HIGH_PRIORITY -FeNyotengu_YMM_IntelV150_32bit -FAcs";

.B10.21:                        

;;; 	HaystackVector1 = _mm256_loadu_si256((const __m256i*)(pbTarget + i + 0));
;;; 	HaystackVector2 = _mm256_loadu_si256((const __m256i*)(pbTarget + i + 1));
;;; 	EQD1 = _mm256_cmpeq_epi32(HaystackVector1, first4);
;;; 	EQD2 = _mm256_cmpeq_epi32(HaystackVector2, first4);
;;; 	HaystackVector3 = _mm256_loadu_si256((const __m256i*)(pbTarget + i + 2));
;;; 	HaystackVector4 = _mm256_loadu_si256((const __m256i*)(pbTarget + i + 3));
;;; 	EQD3 = _mm256_cmpeq_epi32(HaystackVector3, first4);
;;; 	EQD4 = _mm256_cmpeq_epi32(HaystackVector4, first4);
;;; 	FinalVector12 = _mm256_or_si256(EQD1, EQD2);
;;; 	FinalVector34 = _mm256_or_si256(EQD3, EQD4);
;;; 	mask = _mm256_movemask_ps( _mm256_castsi256_ps(_mm256_or_si256(FinalVector12, FinalVector34)) );
;;; 	_mm_prefetch((char*)(pbTarget + 64*64), _MM_HINT_T0);

  000fd 0f 18 8e 00 10 
        00 00            prefetcht0 BYTE PTR [4096+esi]         
  00104 c5 fd 76 0b      vpcmpeqd ymm1, ymm0, YMMWORD PTR [ebx] 
  00108 c5 fd 76 54 32 
        01               vpcmpeqd ymm2, ymm0, YMMWORD PTR [1+edx+esi] 
  0010e c5 fd 76 5c 32 
        02               vpcmpeqd ymm3, ymm0, YMMWORD PTR [2+edx+esi] 
  00114 c5 fd 76 64 32 
        03               vpcmpeqd ymm4, ymm0, YMMWORD PTR [3+edx+esi] 
  0011a c5 f5 eb ea      vpor ymm5, ymm1, ymm2                  
  0011e c5 e5 eb f4      vpor ymm6, ymm3, ymm4                  
  00122 c5 d5 eb fe      vpor ymm7, ymm5, ymm6                  
  00126 c5 fc 50 cf      vmovmskps ecx, ymm7                    

;;; 	if ( mask != 0 ) {

  0012a 85 c9            test ecx, ecx                          
  0012c 74 3f            je .B10.26 

...

.B10.26:                        
  0016d 83 c2 20         add edx, 32                            
  00170 83 c3 20         add ebx, 32                            
  00173 3b d0            cmp edx, eax                           
  00175 72 86            jb .B10.21 

.B10.28:                        
*/

// __mmask16 _mm256_cmpeq_epi16_mask (__m256i a, __m256i b)
// __mmask16 _mm512_cmpeq_epi32_mask (__m512i a, __m512i b)
 // __mmask8 _mm256_cmpeq_epi32_mask (__m256i a, __m256i b)
#ifdef ZMMtengu
	VECTORchunks = cbTarget/SkipWholeVector -1; // in here, ensured at least 128/64-1=1 chunk; in order to avoid past haystack ZMM reads - decrease 1 chunk and finish with Scalar_Quadruplet
	first4 = _mm512_set1_epi32(*(uint32_t*)&pbPattern[0]);
	for (i = 0; i < VECTORchunks*SkipWholeVector; i += SkipWholeVector) {
	HaystackVector1 = _mm512_loadu_si512((const __m256i*)(pbTarget + i + 0));
	HaystackVector2 = _mm512_loadu_si512((const __m256i*)(pbTarget + i + 1));
	EQD1mask16 = _mm512_cmpeq_epi32_mask(HaystackVector1, first4);
	EQD2mask16 = _mm512_cmpeq_epi32_mask(HaystackVector2, first4);
	HaystackVector3 = _mm512_loadu_si512((const __m256i*)(pbTarget + i + 2));
	HaystackVector4 = _mm512_loadu_si512((const __m256i*)(pbTarget + i + 3));
	EQD3mask16 = _mm512_cmpeq_epi32_mask(HaystackVector3, first4);
	EQD4mask16 = _mm512_cmpeq_epi32_mask(HaystackVector4, first4);

	FinalVector12mask16 = (EQD1mask16 | EQD2mask16);
	FinalVector34mask16 = (EQD3mask16 | EQD4mask16);

	mask = (FinalVector12mask16 | FinalVector34mask16);
	
	_mm_prefetch((char*)(pbTarget + 64*64), _MM_HINT_T0);
#endif 
// The vector/main loop is (00143-000fc+2)+(00187-0017d+6)= 89 bytes
/*
; mark_description "Intel(R) C++ Compiler XE for applications running on IA-32, Version 15.0.0.108 Build 20140726";
; mark_description "-O3 -DZMMtengu -D_WIN32_ENVIRONMENT_ -D_N_HIGH_PRIORITY -FeNyotengu_ZMM_IntelV150_32bit -FAcs";

;;; #ifdef ZMMtengu
;;; 	VECTORchunks = cbTarget/SkipWholeVector -1; // in here, ensured at least 128/64-1=1 chunk; in order to avoid past haystack ZMM reads - decrease 1 chunk and finish with Scalar_Quadruplet
;;; 	first4 = _mm512_set1_epi32(*(uint32_t*)&pbPattern[0]);

  000df 8b 45 0c         mov eax, DWORD PTR [12+ebp]            
  000e2 8d 53 c0         lea edx, DWORD PTR [-64+ebx]           

;;; 	for (i = 0; i < VECTORchunks*SkipWholeVector; i += SkipWholeVector) {

  000e5 83 e2 c0         and edx, -64                           
  000e8 62 f2 7d 48 58 
        00               vpbroadcastd zmm0, DWORD PTR [eax]     
  000ee 0f 84 99 00 00 
        00               je .B10.28 

.B10.20:                        
  000f4 89 54 24 44      mov DWORD PTR [68+esp], edx            
  000f8 33 c0            xor eax, eax                           
  000fa 8b de            mov ebx, esi                           

.B10.21:                        

;;; 	HaystackVector1 = _mm512_loadu_si512((const __m256i*)(pbTarget + i + 0));
;;; 	HaystackVector2 = _mm512_loadu_si512((const __m256i*)(pbTarget + i + 1));
;;; 	EQD1mask16 = _mm512_cmpeq_epi32_mask(HaystackVector1, first4);
;;; 	EQD2mask16 = _mm512_cmpeq_epi32_mask(HaystackVector2, first4);
;;; 	HaystackVector3 = _mm512_loadu_si512((const __m256i*)(pbTarget + i + 2));
;;; 	HaystackVector4 = _mm512_loadu_si512((const __m256i*)(pbTarget + i + 3));
;;; 	EQD3mask16 = _mm512_cmpeq_epi32_mask(HaystackVector3, first4);
;;; 	EQD4mask16 = _mm512_cmpeq_epi32_mask(HaystackVector4, first4);
;;; 	FinalVector12mask16 = (EQD1mask16 | EQD2mask16);
;;; 	FinalVector34mask16 = (EQD3mask16 | EQD4mask16);
;;; 	mask = (FinalVector12mask16 | FinalVector34mask16);
;;; 	_mm_prefetch((char*)(pbTarget + 64*64), _MM_HINT_T0);

  000fc 8b 7d 08         mov edi, DWORD PTR [8+ebp]             
  000ff 0f 18 8f 00 10 
        00 00            prefetcht0 BYTE PTR [4096+edi]         
  00106 62 f1 7d 48 76 
        03               vpcmpeqd k0, zmm0, ZMMWORD PTR [ebx]   
  0010c 62 f1 7d 48 76 
        8c 38 01 00 00 
        00               vpcmpeqd k1, zmm0, ZMMWORD PTR [1+eax+edi] 
  00117 62 f1 7d 48 76 
        94 38 02 00 00 
        00               vpcmpeqd k2, zmm0, ZMMWORD PTR [2+eax+edi] 
  00122 62 f1 7d 48 76 
        9c 38 03 00 00 
        00               vpcmpeqd k3, zmm0, ZMMWORD PTR [3+eax+edi] 
  0012d c5 f8 93 f0      kmovw esi, k0                          
  00131 c5 f8 93 c9      kmovw ecx, k1                          
  00135 c5 f8 93 d2      kmovw edx, k2                          
  00139 c5 f8 93 fb      kmovw edi, k3                          
  0013d 0b f1            or esi, ecx                            
  0013f 0b d7            or edx, edi                            
  00141 0b f2            or esi, edx                            
;;; 	if ( mask != 0 ) {
  00143 74 38            je .B10.26 
                                
...
                                
.B10.26:                        
  0017d 83 c0 40         add eax, 64                            
  00180 83 c3 40         add ebx, 64                            
  00183 3b 44 24 44      cmp eax, DWORD PTR [68+esp]            
  00187 0f 82 6f ff ff 
        ff               jb .B10.21 
                                
.B10.28:                        
*/


//		printf("mask = %02x\n", mask); //debug
	if ( mask != 0 ) {
//		printf("_mm_popcnt_u32(mask) = %d\n", _mm_popcnt_u32(mask)); //debug

// For these two:
// char *Haystack = "CPU Benchmark: Linus Torvalds ................................................................................... Linus Torvalds"; // 128 bytes long
// char *Needle = "Linus Torvalds"; // 14 bytes long
// the 'debug' outcome is:
// &pbPattern[cbPattern - 1 -3] = alds
// mask = 40
// _mm_popcnt_u32(mask) = 1
// Okay, 0x40 is 0000 0010 (LSB first) i.e. 6th bit is set, it means 4 possible positions within Chunk #6 (4*6=24 offset) (in fact it is only 25th):
// DWORD #0DWORD #1DWORD #2DWORD #3DWORD #4DWORD #5DWORD #6DWORD #7
// [00..03][04..07][08..11][12..15][16..19][20..23][24..27][28..31]
//                                                  |      
//                                                  /
//                                                 /
//                                                \/
//                        000000000011111111112222[2222]2233
//                        012345678901234567890123[4567]8901
//                        CPU Benchmark: Linus Tor[vald]s ..

		// Manually find the first suffix position:
		//j = i; // somewhere in chunk #i lie possible POPCNT(mask) matches...
		// Okay, doing it dirty as a start - checking all the 16/32/64 positions one-by-one:
	for (j = 0; j < SkipWholeVector; j++)
		if (memcmp(pbTarget + i + j, &pbPattern[cbPattern - cbPattern], cbPattern) == 0) return( pbTarget + i + j ); //first4
	// pbTarget + i + j points to offset of DWORD/suffix so we have to repoint it to the start offset, namely, pbTarget + i + j - (cbPattern-4)
		//while (memcmp(pbTarget + j, &pbPattern[cbPattern - 1 -3], 4) != 0) j++;
		// Don't forget! Comparing the rest of the Needle (to the left) has to be boundary checked (to not go outside) - for speed, this check has to be done outside this loop.
/*
						if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
						// Order 4 [
					// Let's try something "outrageous" like comparing with[out] overlap BBs 4bytes long instead of 1 byte back-to-back:
					// Inhere we are using order 4, 'cbPattern - Order + 1' is the number of BBs for text 'cbPattern' bytes long, for example, for cbPattern=11 'fastest fox' and Order=4 we have BBs = 11-4+1=8:
					//0:"fast" if the comparison failed here, 'count' is 1; 'Gulliver' is cbPattern-(4-1)-7
					//1:"aste" if the comparison failed here, 'count' is 2; 'Gulliver' is cbPattern-(4-1)-6
					//2:"stes" if the comparison failed here, 'count' is 3; 'Gulliver' is cbPattern-(4-1)-5
					//3:"test" if the comparison failed here, 'count' is 4; 'Gulliver' is cbPattern-(4-1)-4
					//4:"est " if the comparison failed here, 'count' is 5; 'Gulliver' is cbPattern-(4-1)-3
					//5:"st f" if the comparison failed here, 'count' is 6; 'Gulliver' is cbPattern-(4-1)-2
					//6:"t fo" if the comparison failed here, 'count' is 7; 'Gulliver' is cbPattern-(4-1)-1
					//7:" fox" if the comparison failed here, 'count' is 8; 'Gulliver' is cbPattern-(4-1)
						count = cbPattern-4+1; 
						//count = count-4; // Double-beauty here of already being checked 'ulHashTarget' and not polluting/repeating the final lookup below.
						while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
							count = count-4; // - order, of course order 4 is much more SWEET&CHEAP - less loops
						if ( count <= 0 )
							return(pbTarget+i);
						// Order 4 ]
						}
*/

	} //if ( mask != 0 ) {
	} //for (i = 0; i <

// Deal with the remainder (starts right after the last chunk) with Scalar code [
pbTarget = pbTarget+ i; // 'i' has to be the traversed pool by the vector
	//if (cbPattern > cbTarget) return(NULL);
	// Above check precedes all Railguns, inhere 'cbTarget' is the HaystackLen-i i.e. the remainder
	if (cbPattern > cbTarget-(i)) return(NULL);

		pbTarget = pbTarget+cbPattern;
		ulHashPattern = *(uint32_t *)(pbPattern);
		SINGLET = ulHashPattern & 0xFF;
		Quadruplet2nd = SINGLET<<8;
		Quadruplet3rd = SINGLET<<16;
		Quadruplet4th = SINGLET<<24;
		for ( ;; ) {
			AdvanceHopperGrass = 0;
			ulHashTarget = *(uint32_t *)(pbTarget-cbPattern);
			if ( ulHashPattern == ulHashTarget ) { // Three unnecessary comparisons here, but 'AdvanceHopperGrass' must be calculated - it has a higher priority.
				count = cbPattern-1;
				while ( count && *(char *)(pbPattern+(cbPattern-count)) == *(char *)(pbTarget-count) ) {
					if ( cbPattern-1==AdvanceHopperGrass+count && SINGLET != *(char *)(pbTarget-count) ) AdvanceHopperGrass++;
					count--;
				}
				if ( count == 0) return((pbTarget-cbPattern));
			} else { // The goal here: to avoid memory accesses by stressing the registers.
				if ( Quadruplet2nd != (ulHashTarget & 0x0000FF00) ) {
					AdvanceHopperGrass++;
					if ( Quadruplet3rd != (ulHashTarget & 0x00FF0000) ) {
						AdvanceHopperGrass++;
						if ( Quadruplet4th != (ulHashTarget & 0xFF000000) ) AdvanceHopperGrass++;
					}
				}
			}
			AdvanceHopperGrass++;
			pbTarget = pbTarget + AdvanceHopperGrass;
			if (pbTarget > pbTargetMax) return(NULL);
		}
// Deal with the remainder (starts right after the last chunk) with Scalar code ]

		} //if (cbTarget<128) {
	} //if ( cbPattern<4 ) { needle 2..3; SCALAR

return(NULL);
}

// https://software.intel.com/sites/landingpage/IntrinsicsGuide/#expand=233,272&text=_mm_aesenc_si128
/*
__m128i _mm_aesenc_si128 (__m128i a, __m128i RoundKey)
Synopsis
__m128i _mm_aesenc_si128 (__m128i a, __m128i RoundKey)
#include <wmmintrin.h>
Instruction: aesenc xmm, xmm
CPUID Flags: AES
Description
Perform one round of an AES encryption flow on data (state) in a using the round key in RoundKey, and store the result in dst."
Operation
a[127:0] := ShiftRows(a[127:0])
a[127:0] := SubBytes(a[127:0])
a[127:0] := MixColumns(a[127:0])
dst[127:0] := a[127:0] XOR RoundKey[127:0]

Performance
Architecture	Latency	Throughput (CPI)
Skylake		4	1
Broadwell	7	1
Haswell		7	1
Ivy Bridge	8	1
*/

/*
#include <stdlib.h>
#include <stdint.h> // uint64_t needed
#include <string.h> // memset
#include <smmintrin.h> // SSE4.1 intrinsics
#include <wmmintrin.h>
void SlowCopy128bit (const char *SOURCE, char *TARGET) { _mm_storeu_si128((__m128i *)(TARGET), _mm_loadu_si128((const __m128i *)(SOURCE))); }
unsigned char DDAES[16];
void DoubleDeuceAES(const uint8_t *buffer, const size_t length) {
	uint32_t i;
	char MaxTo64a[64], MaxTo64b[64], MaxTo64c[64], MaxTo64d[64];
    __m128i hashA = _mm_set_epi64x(0x6c62272e07bb0142, 0x62b821756295c58d); // 0x6c62272e07bb014262b821756295c58d // _mm_setzero_si128();
    __m128i hashB = _mm_set_epi64x(0xdd268dbcaac55036, 0x2d98c384c4e576cc); // 0xdd268dbcaac550362d98c384c4e576ccc8b1536847b6bbb31023b4c8caee0535 // FNV offset basis
    __m128i hashC = _mm_set_epi64x(0xc8b1536847b6bbb3, 0x1023b4c8caee0535); // 0xdd268dbcaac550362d98c384c4e576ccc8b1536847b6bbb31023b4c8caee0535 // FNV offset basis
    __m128i hashD = _mm_setzero_si128();
    const __m128i *ptr128a, *ptr128b, *ptr128c, *ptr128d;
	memset(MaxTo64a,0x33,4*(128/8)); // padding the keys to be multiples of 128, up to 64 bytes
	memset(MaxTo64b,0x77,4*(128/8)); // padding the keys to be multiples of 128, up to 64 bytes
	for (i = 0; i < length; i++) {
		MaxTo64a[i]=buffer[i];
        MaxTo64b[63-i]=buffer[i]; // MaxTo64b[63-i]=MaxTo64a[i];
	}
	for (i = 0; i < (64>>1)/1; i++) { // 64/2/BYTE=31 i.e 0..31
		MaxTo64c[(i<<1)+0]=MaxTo64a[i+0]; // a: 00,32 / 01,33 / ...31,63
		MaxTo64c[(i<<1)+1]=MaxTo64a[i+32]; // c: 0*2+0,0*2+1 / 1*2+0,1*2+1 / 2*2+0,2*2+1 which is 0,1 / 2,3 / 4,5
		MaxTo64d[(i<<1)+0]=MaxTo64b[i+0]; 
		MaxTo64d[(i<<1)+1]=MaxTo64b[i+32]; 
	}
	ptr128a=(__m128i *)MaxTo64a;
	ptr128b=(__m128i *)MaxTo64b;
	ptr128c=(__m128i *)MaxTo64c;
	ptr128d=(__m128i *)MaxTo64d;
            for (i = 0; i < 64 / 16; i++) {
                __m128i a = _mm_loadu_si128(ptr128a++);
                __m128i b = _mm_loadu_si128(ptr128b++);
                __m128i c = _mm_loadu_si128(ptr128c++);
                __m128i d = _mm_loadu_si128(ptr128d++);
                hashA = _mm_aesenc_si128(hashA, a);
                hashB = _mm_aesenc_si128(hashB, b);
                hashC = _mm_aesenc_si128(hashC, c);
                hashD = _mm_aesenc_si128(hashD, d);
            }
	hashA = _mm_aesenc_si128(hashA, hashB);
	hashA = _mm_aesenc_si128(hashA, hashC);
	hashA = _mm_aesenc_si128(hashA, hashD);
	SlowCopy128bit( (const char *)(&hashA), (char *)&DDAES[0]);
}
*/

//static const uint8_t VectorsNeedNonVAriable1[256] __attribute__((aligned(16))) =
static const uint8_t VectorsNeedNonVAriable1[256] =
{
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00
};
static const __m128i *Mumbotron = (__m128i *) VectorsNeedNonVAriable1;
//static const uint8_t VectorsNeedNonVAriable2[256] __attribute__((aligned(16))) =
static const uint8_t VectorsNeedNonVAriable2[256] =
{
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF
}; 
static const __m128i *Jumbotron = (__m128i *) VectorsNeedNonVAriable2;

// https://github.com/Cyan4973/xxHash/issues/568
// https://github.com/google/highwayhash/issues/102
// Revision 2021-Aug-28 [
// Written by Sanmayce, inspired by J. Andrew Rogers's https://github.com/jandrewrogers/AquaHash/blob/master/aquahash.h
// This hash function serves two ... functions - useful for table lookups and to shrink keys (usually 64...256 bytes in length) down to 16 bytes:
// Its linear speed is quite good - 8+GB/s on Zen 2 Renoir 4.3GHz, DDR4 3200MHz.
// Some non-synthetic speed measurements:
/*
Testfile: KAZE_(Dictionary_Specification_Language_(ABBYY_Software_House))Hanyu_Cihai_new_Sea-of-Words(Zho-Zho).dsl (42,920,232 bytes)
Testmachine: Testmachine: laptop 'Brutalitto' AMD 4800H max turbo 4.3GHz, 64GB DDR4 3200MHz, Windows 10
Hashtable: 26bit, i.e. 67,108,864 slots, greater than (42,920,232 bytes), since in case of perfect hasher - slots should be more than the keys (could be all unique) at each position

+--------------------------+-----------------------------+----------------------------------+---------------------------------+
| Hasher,                  | Number Of Hash Collisions = | RAW Hashing Speed (in one pass,  | Linear Hashing Speed,           |
| GCC-10.1 compiler        | Distinct Keys -             | at each position) for keys       | the whole file as one key       |
| -O3 -mavx                | Number Of Trees             | 4,6,8,10,12,14,16,18,36,64 bytes |                                 |
+--------------------------+-----------------------------+----------------------------------+---------------------------------+
| XXH3_64bits v0.8.0       |                  41,108,202 |      295,187,276 KEYS-PER-SECOND | 21,786,919,796 BYTES-PER-SECOND |
| HighwayHash128 (generic) |                  41,109,295 |        5,986,502 KEYS-PER-SECOND |  1,644,642,372 BYTES-PER-SECOND |
| CRC32C (_mm_crc32_u32)   |                  41,109,478 |      274,426,023 KEYS-PER-SECOND |  5,241,205,519 BYTES-PER-SECOND |
| XXH3_128bits v0.8.0      |                  41,111,196 |      214,493,903 KEYS-PER-SECOND | 20,331,706,300 BYTES-PER-SECOND |
| SHA3-224                 |                  41,111,291 |          153,854 KEYS-PER-SECOND |     22,319,413 BYTES-PER-SECOND |
| wyhash final             |                  41,112,870 |      449,897,589 KEYS-PER-SECOND | 15,086,197,539 BYTES-PER-SECOND |
| DoubleDeuceAES_Gumbotron |                  41,117,352 |      204,869,832 KEYS-PER-SECOND |  8,690,065,195 BYTES-PER-SECOND |
| FNV1A_Pippip             |                  41,488,327 |      449,897,589 KEYS-PER-SECOND |  8,101,214,043 BYTES-PER-SECOND |
+--------------------------+-----------------------------+----------------------------------+---------------------------------+
Note1: The second column houses the cumulative value for all collisions, the collisions for all orders 4..64 were summed, that is.
Note2: Folding of those 128bits should lessen the collisions.

Testfile: TERAPIG_Encyclopaedia_Judaica_(in_22_volumes)_TXT.tar (107,784,192 bytes)
Testmachine: Testmachine: laptop 'Brutalitto' AMD 4800H max turbo 4.3GHz, 64GB DDR4 3200MHz, Windows 10
Hashtable: 27bit, i.e. 134,217,728 slots, greater than (107,784,192 bytes), since in case of perfect hasher - slots should be more than the keys (could be all unique) at each position

+--------------------------+-----------------------------+----------------------------------+---------------------------------+
| Hasher,                  | Number Of Hash Collisions = | RAW Hashing Speed (in one pass,  | Linear Hashing Speed,           |
| GCC-10.1 compiler        | Distinct Keys -             | at each position) for keys       | the whole file as one key       |
| -O3 -mavx                | Number Of Trees             | 4,6,8,10,12,14,16,18,36,64 bytes |                                 |
+--------------------------+-----------------------------+----------------------------------+---------------------------------+
| DoubleDeuceAES_Gumbotron |                 135,752,271 |      204,640,573 KEYS-PER-SECOND |  8,742,330,440 BYTES-PER-SECOND |
| HighwayHash128 (generic) |                 135,754,873 |        6,336,146 KEYS-PER-SECOND |  1,435,801,622 BYTES-PER-SECOND |
| XXH3_128bits v0.8.0      |                 135,756,978 |      212,843,977 KEYS-PER-SECOND | 22,539,563,362 BYTES-PER-SECOND |
| wyhash final             |                 135,762,454 |      442,100,861 KEYS-PER-SECOND | 14,959,638,029 BYTES-PER-SECOND |
| XXH3_64bits v0.8.0       |                 135,763,366 |      290,994,033 KEYS-PER-SECOND | 22,464,400,166 BYTES-PER-SECOND |
| CRC32C (_mm_crc32_u32)   |                 135,764,628 |      252,599,460 KEYS-PER-SECOND |  5,241,402,061 BYTES-PER-SECOND |
| FNV1A_Pippip             |                 135,768,302 |      450,602,801 KEYS-PER-SECOND |  8,048,401,433 BYTES-PER-SECOND |
| SHA3-224                 |                 135,771,905 |          153,841 KEYS-PER-SECOND |     22,246,479 BYTES-PER-SECOND |
+--------------------------+-----------------------------+----------------------------------+---------------------------------+
The part I use is from https://github.com/google/highwayhash/tree/master/c
*/
// // https://godbolt.org/ [[[
// #include <stdlib.h>
// #include <stdint.h> // uint64_t needed
// #include <string.h> // memset
// #include <smmintrin.h> // SSE4.1 intrinsics
// #include <wmmintrin.h>
// void SlowCopy128bit (const char *SOURCE, char *TARGET) { _mm_storeu_si128((__m128i *)(TARGET), _mm_loadu_si128((const __m128i *)(SOURCE))); }
// unsigned char DDAES[16];
// // https://godbolt.org/ ]]]
// Collision Benchmark - DoubleDeuceAES_128bits versus XXH3_64bits v0.8.0
// 
// Testset: "A billion Knight-Tours variants (each KT with 256 variants, the KT itself omitted) - each 128 bytes long"
// Testfile: 1000000000.KnightTours.txt (130,000,000,000 bytes)
// 
// The name of the game - hashing all lines and taking either 5 bytes or 6,7,8 bytes from the hash.
// 
// ```
// +------------------------+----------------------------------------------------------+
// | Hasher                 |                          Collisions within first 5 bytes |
// +------------------------+----------------------------------------------------------+
// | XXH3_64bits v0.8.0     | 1,000,000,000 - 999,545,727 distinct lines =     454,273 |
// +------------------------+----------------------------------------------------------+
// | DoubleDeuceAES_128bits | 1,000,000,000 - 999,545,796 distinct lines =     454,204 |  
// +------------------------+----------------------------------------------------------+
// 
// +------------------------+----------------------------------------------------------+
// | Hasher                 |                          Collisions within first 6 bytes |
// +------------------------+----------------------------------------------------------+
// | XXH3_64bits v0.8.0     | 1,000,000,000 - 999,998,214 distinct lines =       1,786 |
// +------------------------+----------------------------------------------------------+
// | DoubleDeuceAES_128bits | 1,000,000,000 - 999,998,213 distinct lines =       1,787 |
// +------------------------+----------------------------------------------------------+
// 
// +------------------------+----------------------------------------------------------+
// | Hasher                 |                          Collisions within first 7 bytes |
// +------------------------+----------------------------------------------------------+
// | XXH3_64bits v0.8.0     | 1,000,000,000 - 999,999,989 distinct lines =          11 |
// +------------------------+----------------------------------------------------------+
// | DoubleDeuceAES_128bits | 1,000,000,000 - 999,999,994 distinct lines =           6 | 
// +------------------------+----------------------------------------------------------+
// 
// +------------------------+----------------------------------------------------------+
// | Hasher                 |                          Collisions within first 8 bytes |
// +------------------------+----------------------------------------------------------+
// | XXH3_64bits v0.8.0     | 1,000,000,000 - 1,000,000,000 distinct lines =         0 |
// +------------------------+----------------------------------------------------------+
// | DoubleDeuceAES_128bits | 1,000,000,000 - 1,000,000,000 distinct lines =         0 | 
// +------------------------+----------------------------------------------------------+
// ```
// 
// The benchmark package (allowing to reproduce all the stuff):
// www.sanmayce.com/COLLISION_Hashliner.zip
// 
// This is how the console looks like:
// 
// ```
// C:\test\COLLISION_Hashliner>GENERATE_Xmillion_Knight-Tours.bat 1000000000
// Generating 1000000000 Knight-Tours and dumping them into file ...
// 
// C:\test\COLLISION_Hashliner>Knight-Tour_FNV1A_YoshimitsuTRIADii_vs_CRC32_TRISMUS.exe a8 1000000000  1>1000000000.KnightTours.txt
// 
// C:\test\COLLISION_Hashliner>bench7.bat 1000000000.KnightTours.txt
// 
// C:\test\COLLISION_Hashliner>Hashliner_XXH3_dump7byteshash.exe 1000000000.KnightTours.txt  1>1000000000.KnightTours.txt.xxh3.txt
// 
// C:\test\COLLISION_Hashliner>Hashliner_DDAES_dump7byteshash.exe 1000000000.KnightTours.txt  1>1000000000.KnightTours.txt.DDAES.txt
// 
// C:\test\COLLISION_Hashliner>Sandokan_QuickSortExternal_Deduplicated_4+GB_64bit_Intel.exe 1000000000.KnightTours.txt.xxh3.txt /fast /descend 3000
// Sandokan_QuickSortExternal_4+GB r.3+, written by Kaze, using Bill Durango's Quicksort source.
// Size of input file: 16,000,000,000
// Counting lines ...
// Lines encountered: 1,000,000,000
// Longest line (including CR if present): 15
// Allocated memory for pointers-to-lines in MB: 7629
// Assigning pointers ...
// sizeof(int), sizeof(void*): 4, 8
// Trying to allocate memory for the file itself in MB: 15258 ... OK! Get on with fast internal accesses.
// Uploading ...
// Sorting 1,000,000,000 Pointers ...
// Quicksort (Insertionsort for small blocks) commenced ...
// / RightEnd: 000,328,304,267; NumberOfSplittings: 0,114,284,204; Done: 100% ...
// NumberOfComparisons: 34,310,536,510
// The time to sort 1,000,000,000 items via Quicksort+Insertionsort was 2,848,402 clocks.
// Performance: 12,045,534 Comparisons_128B_long-Per-Second i.e 24,091,068 RandomReads_128B_long-Per-Second.
// Dumping the sorted data (Regime=2)...
// \ Done 100% ...
// Dumped 1,000,000,000 lines.
// OK! Incoming and resultant file's sizes match.
// Dumping the sorted data [deduplicated] ...
// Dumped 999,999,989 distinct lines.
// Dump time: 460,940 clocks.
// Total time: 3,347,265 clocks.
// Performance: 4,780 bytes/clock.
// Done successfully.
// 
// C:\test\COLLISION_Hashliner>sort /R QuickSortExternal_4+GB.distinct.txt  1>1000000000.KnightTours.txt.xxh3.7bytes.2orABOVE.txt
// 
// C:\test\COLLISION_Hashliner>Sandokan_QuickSortExternal_Deduplicated_4+GB_64bit_Intel.exe 1000000000.KnightTours.txt.DDAES.txt /fast /descend 3000
// Sandokan_QuickSortExternal_4+GB r.3+, written by Kaze, using Bill Durango's Quicksort source.
// Size of input file: 16,000,000,000
// Counting lines ...
// Lines encountered: 1,000,000,000
// Longest line (including CR if present): 15
// Allocated memory for pointers-to-lines in MB: 7629
// Assigning pointers ...
// sizeof(int), sizeof(void*): 4, 8
// Trying to allocate memory for the file itself in MB: 15258 ... OK! Get on with fast internal accesses.
// Uploading ...
// Sorting 1,000,000,000 Pointers ...
// Quicksort (Insertionsort for small blocks) commenced ...
// - RightEnd: 000,759,555,061; NumberOfSplittings: 0,114,282,509; Done: 100% ...
// NumberOfComparisons: 34,551,039,764
// The time to sort 1,000,000,000 items via Quicksort+Insertionsort was 2,896,271 clocks.
// Performance: 11,929,487 Comparisons_128B_long-Per-Second i.e 23,858,974 RandomReads_128B_long-Per-Second.
// Dumping the sorted data (Regime=2)...
// \ Done 100% ...
// Dumped 1,000,000,000 lines.
// OK! Incoming and resultant file's sizes match.
// Dumping the sorted data [deduplicated] ...
// Dumped 999,999,994 distinct lines.
// Dump time: 458,406 clocks.
// Total time: 3,393,196 clocks.
// Performance: 4,715 bytes/clock.
// Done successfully.
// 
// C:\test\COLLISION_Hashliner>sort /R QuickSortExternal_4+GB.distinct.txt  1>1000000000.KnightTours.txt.DDAES.7bytes.2orABOVE.txt
// 
// C:\test\COLLISION_Hashliner>dir *7b*
// 
// 15-Aug-21  12:28               156 1000000000.KnightTours.txt.DDAES.7bytes.2orABOVE.txt
// 15-Aug-21  11:32               286 1000000000.KnightTours.txt.xxh3.7bytes.2orABOVE.txt
// 
// C:\test\COLLISION_Hashliner>type 1000000000.KnightTours.txt.xxh3.7bytes.2orABOVE.txt
// 0,000,002       f84627e722e85e
// 0,000,002       f0039d0c4e4fce
// 0,000,002       c87c64d97df0e7
// 0,000,002       bb4344a5546572
// 0,000,002       af2f628f4b3ffb
// 0,000,002       a8cb8675c94610
// 0,000,002       a742cf83948622
// 0,000,002       657cb9dff2d962
// 0,000,002       436aef7ab54ce7
// 0,000,002       270fcde0563670
// 0,000,002       0b533d70915c51
// 
// C:\test\COLLISION_Hashliner>
// ```

#include <wmmintrin.h>
void SlowCopy128bit (const char *SOURCE, char *TARGET) { _mm_storeu_si128((__m128i *)(TARGET), _mm_loadu_si128((const __m128i *)(SOURCE))); }
unsigned char DDAES[16];

void DoubleDeuceAES_Gumbotron(const uint8_t *buffer, size_t length, uint64_t *LoPart, uint64_t *HiPart) {
	size_t i, Cycles;
	__m128i hashA = _mm_set_epi64x(0x6c62272e07bb0142, 0x62b821756295c58d); // 0x6c62272e07bb014262b821756295c58d // _mm_setzero_si128();
	__m128i hashB = _mm_set_epi64x(0xdd268dbcaac55036, 0x2d98c384c4e576cc); // 0xdd268dbcaac550362d98c384c4e576ccc8b1536847b6bbb31023b4c8caee0535 // FNV offset basis
	__m128i hashC = _mm_set_epi64x(0xc8b1536847b6bbb3, 0x1023b4c8caee0535); // 0xdd268dbcaac550362d98c384c4e576ccc8b1536847b6bbb31023b4c8caee0535 // FNV offset basis
	__m128i hashD = _mm_setzero_si128();
	__m128i a0,a1,a2,a3; // Instead of this chunkenization, ZMM houses the 4 XMMs, if there is shuffle across all the 512bits, use it. There is, but __m256i _mm256_shuffle_epi8(__m256i a, __m256i b) is more handy.
	__m128i b0,b1,b2,b3;
	__m128i c0,c1,c2,c3;
	__m128i d0,d1,d2,d3;
	__m128i tmp0,tmp1,tmp2,tmp3;
	__m128i ReverseMask =   _mm_set_epi8(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15);
	__m128i PartialInterleavingMask1 = _mm_set_epi8(0x80,7,0x80,6,0x80,5,0x80,4,0x80,3,0x80,2,0x80,1,0x80,0);
	__m128i PartialInterleavingMask2 = _mm_set_epi8(0x80,0xf,0x80,0xe,0x80,0xd,0x80,0xc,0x80,0xb,0x80,0xa,0x80,9,0x80,8); 
	__m128i PartialInterleavingMask3 = _mm_set_epi8(7,0x80,6,0x80,5,0x80,4,0x80,3,0x80,2,0x80,1,0x80,0,0x80);
	__m128i PartialInterleavingMask4 = _mm_set_epi8(0xf,0x80,0xe,0x80,0xd,0x80,0xc,0x80,0xb,0x80,0xa,0x80,9,0x80,8,0x80);
	const __m128i *ptr128a, *ptr128b, *ptr128c, *ptr128d;

	__m128i AgainstRules, GumbotronREVER, GumbotronINTER, Gumbotron, GumbotronREVERINTER;
	const __m128i *ptr128; 
	__m128i InterleaveMask =   _mm_set_epi8(15,7,14,6,13,5,12,4,11,3,10,2,9,1,8,0);

	if (length >= 64) {
		Cycles = length/64;
		for(; Cycles--; buffer += 64) {
			a0 = _mm_loadu_si128((__m128i *)(buffer+0*16)); 
			a1 = _mm_loadu_si128((__m128i *)(buffer+1*16)); 
			a2 = _mm_loadu_si128((__m128i *)(buffer+2*16)); 
			a3 = _mm_loadu_si128((__m128i *)(buffer+3*16)); 
			b0 = _mm_shuffle_epi8 (a3, ReverseMask); 
			b1 = _mm_shuffle_epi8 (a2, ReverseMask); 
			b2 = _mm_shuffle_epi8 (a1, ReverseMask); 
			b3 = _mm_shuffle_epi8 (a0, ReverseMask); 
			tmp0 = _mm_shuffle_epi8 (a0, PartialInterleavingMask1);
			tmp1 = _mm_shuffle_epi8 (a0, PartialInterleavingMask2);
			tmp2 = _mm_shuffle_epi8 (a2, PartialInterleavingMask3);
			tmp3 = _mm_shuffle_epi8 (a2, PartialInterleavingMask4);
			c0 = _mm_or_si128 (tmp0, tmp2);
			c1 = _mm_or_si128 (tmp1, tmp3);
			tmp0 = _mm_shuffle_epi8 (a1, PartialInterleavingMask1);
			tmp1 = _mm_shuffle_epi8 (a1, PartialInterleavingMask2);
			tmp2 = _mm_shuffle_epi8 (a3, PartialInterleavingMask3);
			tmp3 = _mm_shuffle_epi8 (a3, PartialInterleavingMask4);
			c2 = _mm_or_si128 (tmp0, tmp2);
			c3 = _mm_or_si128 (tmp1, tmp3);
			tmp0 = _mm_shuffle_epi8 (b0, PartialInterleavingMask1);
			tmp1 = _mm_shuffle_epi8 (b0, PartialInterleavingMask2);
			tmp2 = _mm_shuffle_epi8 (b2, PartialInterleavingMask3);
			tmp3 = _mm_shuffle_epi8 (b2, PartialInterleavingMask4);
			d0 = _mm_or_si128 (tmp0, tmp2);
			d1 = _mm_or_si128 (tmp1, tmp3);
			tmp0 = _mm_shuffle_epi8 (b1, PartialInterleavingMask1);
			tmp1 = _mm_shuffle_epi8 (b1, PartialInterleavingMask2);
			tmp2 = _mm_shuffle_epi8 (b3, PartialInterleavingMask3);
			tmp3 = _mm_shuffle_epi8 (b3, PartialInterleavingMask4);
			d2 = _mm_or_si128 (tmp0, tmp2);
			d3 = _mm_or_si128 (tmp1, tmp3);

			hashA = _mm_aesenc_si128(hashA, a0);
			hashB = _mm_aesenc_si128(hashB, b0);
			hashC = _mm_aesenc_si128(hashC, c0);
			hashD = _mm_aesenc_si128(hashD, d0);

			hashA = _mm_aesenc_si128(hashA, a1);
			hashB = _mm_aesenc_si128(hashB, b1);
			hashC = _mm_aesenc_si128(hashC, c1);
			hashD = _mm_aesenc_si128(hashD, d1);

			hashA = _mm_aesenc_si128(hashA, a2);
			hashB = _mm_aesenc_si128(hashB, b2);
			hashC = _mm_aesenc_si128(hashC, c2);
			hashD = _mm_aesenc_si128(hashD, d2);

			hashA = _mm_aesenc_si128(hashA, a3);
			hashB = _mm_aesenc_si128(hashB, b3);
			hashC = _mm_aesenc_si128(hashC, c3);
			hashD = _mm_aesenc_si128(hashD, d3);

			hashA = _mm_aesenc_si128(hashA, hashB);
			hashA = _mm_aesenc_si128(hashA, hashC);
			hashA = _mm_aesenc_si128(hashA, hashD);
			length = length - 64;
		}
	}

	ptr128 = (__m128i *)buffer;
	if (length >=16) {
		Cycles = length/16;
		for(; Cycles--; buffer += 16) {
			AgainstRules = _mm_loadu_si128(ptr128++);
			GumbotronREVER = _mm_shuffle_epi8 (AgainstRules, ReverseMask);
			GumbotronINTER = _mm_shuffle_epi8 (AgainstRules, InterleaveMask);
			GumbotronREVERINTER = _mm_shuffle_epi8 (GumbotronREVER, InterleaveMask);
			hashA = _mm_aesenc_si128(hashA, AgainstRules);
			hashB = _mm_aesenc_si128(hashB, GumbotronREVER);
			hashC = _mm_aesenc_si128(hashC, GumbotronINTER);
			hashD = _mm_aesenc_si128(hashD, GumbotronREVERINTER);
			hashA = _mm_aesenc_si128(hashA, hashB);
			hashA = _mm_aesenc_si128(hashA, hashC);
			hashA = _mm_aesenc_si128(hashA, hashD);
			length = length - 16;
		}
	} 
	// Inhere using Pippip's approach to read past the end ("the dirty" sentinel like style, or more like padding):
	if (length&(16-1)) {
		AgainstRules = _mm_loadu_si128(ptr128);		
		//AgainstRules = _mm_srli_si128 (AgainstRules, 16-length); // catastrophic error: Intrinsic parameter must be an immediate value
		AgainstRules = _mm_and_si128 (AgainstRules, Mumbotron[length]);
		//Gumbotron = _mm_slli_si128 (Gumbotron, 16-length); // catastrophic error: Intrinsic parameter must be an immediate value
		Gumbotron = _mm_and_si128 (hashB, Jumbotron[length]);
		AgainstRules = _mm_or_si128 (AgainstRules, Gumbotron);

		GumbotronREVER = _mm_shuffle_epi8 (AgainstRules, ReverseMask);
		GumbotronINTER = _mm_shuffle_epi8 (AgainstRules, InterleaveMask);
		GumbotronREVERINTER = _mm_shuffle_epi8 (GumbotronREVER, InterleaveMask);
			hashA = _mm_aesenc_si128(hashA, AgainstRules);
			hashB = _mm_aesenc_si128(hashB, GumbotronREVER);
			hashC = _mm_aesenc_si128(hashC, GumbotronINTER);
			hashD = _mm_aesenc_si128(hashD, GumbotronREVERINTER);
			hashA = _mm_aesenc_si128(hashA, hashB);
			hashA = _mm_aesenc_si128(hashA, hashC);
			hashA = _mm_aesenc_si128(hashA, hashD);
	}
	//SlowCopy128bit( (const char *)(&hashA), (char *)&DDAES[0]);
	memcpy ( LoPart, (const char *)(&hashA), 8);
	memcpy ( HiPart, (const char *)(&hashA)+8, 8);
}
/*
; mark_description "Intel(R) C++ Compiler XE for applications running on Intel(R) 64, Version 15.0.0.108 Build 20140726";
; mark_description "-O3 -arch:avx -FA -D_WIN32_ENVIRONMENT_ -D_N_DDAES";

DoubleDeuceAES_Gumbotron	PROC 
        sub       rsp, 216                                      
        mov       r8, rdx                                       
        vmovups   xmm3, XMMWORD PTR [_2il0floatpacket.0]        
        lea       rdx, QWORD PTR [__ImageBase]                  
        vmovups   xmm4, XMMWORD PTR [_2il0floatpacket.1]        
        vpxor     xmm2, xmm2, xmm2                              
        vmovups   xmm5, XMMWORD PTR [_2il0floatpacket.2]        
        vmovdqu   xmm1, XMMWORD PTR [_2il0floatpacket.4]        
        vmovdqu   xmm0, XMMWORD PTR [_2il0floatpacket.5]        
        cmp       r8, 64                                        
        jbe       .B6.6         
        mov       rax, r8                                       
        shr       rax, 6                                        
        dec       rax                                           
        cmp       rax, -1                                       
        je        .B6.6         
        vmovups   XMMWORD PTR [64+rsp], xmm6                    
        vmovups   XMMWORD PTR [48+rsp], xmm7                    
        vmovups   XMMWORD PTR [32+rsp], xmm8                    
        vmovups   XMMWORD PTR [80+rsp], xmm9                    
        vmovups   XMMWORD PTR [96+rsp], xmm10                   
        vmovups   XMMWORD PTR [112+rsp], xmm11                  
        vmovups   XMMWORD PTR [128+rsp], xmm12                  
        vmovups   XMMWORD PTR [144+rsp], xmm13                  
        vmovups   XMMWORD PTR [160+rsp], xmm14                  
        vmovups   XMMWORD PTR [176+rsp], xmm15                  
.B6.4::                         
        vmovdqu   xmm10, XMMWORD PTR [48+rcx]                   
        vmovdqu   xmm6, XMMWORD PTR [32+rcx]                    
        vmovdqu   xmm11, XMMWORD PTR [16+rcx]                   
        vmovdqu   xmm12, XMMWORD PTR [rcx]                      
        vmovdqu   xmm14, XMMWORD PTR [_2il0floatpacket.3]       
        dec       rax                                           
        vpshufb   xmm8, xmm10, xmm14                            
        vpshufb   xmm13, xmm6, xmm14                            
        vpshufb   xmm9, xmm11, xmm14                            
        vpshufb   xmm14, xmm12, xmm14                           
        vpshufb   xmm15, xmm12, xmm1                            
        vaesenc   xmm4, xmm4, xmm8                              
        add       r8, -64                                       
        vaesenc   xmm7, xmm4, xmm13                             
        vaesenc   xmm4, xmm7, xmm9                              
        vaesenc   xmm7, xmm4, xmm14                             
        vmovdqu   xmm4, XMMWORD PTR [_2il0floatpacket.6]        
        vmovups   XMMWORD PTR [192+rsp], xmm7                   
        vpshufb   xmm7, xmm6, xmm4                              
        vpor      xmm15, xmm15, xmm7                            
        vmovdqu   xmm7, XMMWORD PTR [_2il0floatpacket.7]        
        vaesenc   xmm15, xmm5, xmm15                            
        vpshufb   xmm5, xmm12, xmm0                             
        vpshufb   xmm6, xmm6, xmm7                              
        vpor      xmm5, xmm5, xmm6                              
        vaesenc   xmm15, xmm15, xmm5                            
        vpshufb   xmm6, xmm11, xmm1                             
        vpshufb   xmm5, xmm10, xmm4                             
        vpor      xmm6, xmm6, xmm5                              
        vaesenc   xmm5, xmm15, xmm6                             
        vpshufb   xmm15, xmm11, xmm0                            
        vpshufb   xmm6, xmm10, xmm7                             
        vpor      xmm15, xmm15, xmm6                            
        vaesenc   xmm5, xmm5, xmm15                             
        vpshufb   xmm6, xmm8, xmm1                              
        vpshufb   xmm15, xmm9, xmm4                             
        vpshufb   xmm8, xmm8, xmm0                              
        vpshufb   xmm9, xmm9, xmm7                              
        vpshufb   xmm4, xmm14, xmm4                             
        vpor      xmm6, xmm6, xmm15                             
        vaesenc   xmm2, xmm2, xmm6                              
        vpor      xmm6, xmm8, xmm9                              
        vaesenc   xmm6, xmm2, xmm6                              
        vpshufb   xmm2, xmm13, xmm1                             
        vpshufb   xmm13, xmm13, xmm0                            
        vpor      xmm2, xmm2, xmm4                              
        vaesenc   xmm8, xmm6, xmm2                              
        vpshufb   xmm2, xmm14, xmm7                             
        vaesenc   xmm3, xmm3, xmm12                             
        vpor      xmm4, xmm13, xmm2                             
        vaesenc   xmm2, xmm8, xmm4                              
        vaesenc   xmm4, xmm3, xmm11                             
        vaesenc   xmm3, xmm4, XMMWORD PTR [32+rcx]              
        add       rcx, 64                                       
        vaesenc   xmm6, xmm3, xmm10                             
        vmovups   xmm4, XMMWORD PTR [192+rsp]                   
        vaesenc   xmm7, xmm6, xmm4                              
        vaesenc   xmm8, xmm7, xmm5                              
        vaesenc   xmm3, xmm8, xmm2                              
        cmp       rax, -1                                       
        jne       .B6.4         
        vmovups   xmm6, XMMWORD PTR [64+rsp]                    
        vmovups   xmm7, XMMWORD PTR [48+rsp]                    
        vmovups   xmm8, XMMWORD PTR [32+rsp]                    
        vmovups   xmm9, XMMWORD PTR [80+rsp]                    
        vmovups   xmm10, XMMWORD PTR [96+rsp]                   
        vmovups   xmm11, XMMWORD PTR [112+rsp]                  
        vmovups   xmm12, XMMWORD PTR [128+rsp]                  
        vmovups   xmm13, XMMWORD PTR [144+rsp]                  
        vmovups   xmm14, XMMWORD PTR [160+rsp]                  
        vmovups   xmm15, XMMWORD PTR [176+rsp]                  
.B6.6::                         
        cmp       r8, 16                                        
        jb        .B6.11        
        mov       rax, r8                                       
        shr       rax, 4                                        
        dec       rax                                           
        cmp       rax, -1                                       
        je        .B6.11        
        vmovups   XMMWORD PTR [64+rsp], xmm6                    
        vmovups   XMMWORD PTR [48+rsp], xmm7                    
        vmovups   XMMWORD PTR [32+rsp], xmm8                    
        vmovdqu   xmm0, XMMWORD PTR [_2il0floatpacket.8]        
        vmovdqu   xmm6, XMMWORD PTR [_2il0floatpacket.3]        
        ALIGN     16
.B6.9::                         
        vmovdqu   xmm1, XMMWORD PTR [rcx]                       
        vpshufb   xmm8, xmm1, xmm6                              
        vpshufb   xmm7, xmm1, xmm0                              
        vaesenc   xmm5, xmm5, xmm7                              
        dec       rax                                           
        vpshufb   xmm7, xmm8, xmm0                              
        vaesenc   xmm4, xmm4, xmm8                              
        add       rcx, 16                                       
        vaesenc   xmm3, xmm3, xmm1                              
        add       r8, -16                                       
        vaesenc   xmm1, xmm3, xmm4                              
        vaesenc   xmm2, xmm2, xmm7                              
        vaesenc   xmm3, xmm1, xmm5                              
        vaesenc   xmm3, xmm3, xmm2                              
        cmp       rax, -1                                       
        jne       .B6.9         
        vmovups   xmm6, XMMWORD PTR [64+rsp]                    
        vmovups   xmm7, XMMWORD PTR [48+rsp]                    
        vmovups   xmm8, XMMWORD PTR [32+rsp]                    
.B6.11::                        
        test      r8, 15                                        
        je        .B6.13        
        shl       r8, 4                                         
        vmovdqu   xmm1, XMMWORD PTR [rcx]                       
        vpand     xmm0, xmm1, XMMWORD PTR [imagerel(VectorsNeedNonVAriable1)+rdx+r8] 
        vpand     xmm1, xmm4, XMMWORD PTR [imagerel(VectorsNeedNonVAriable2)+rdx+r8] 
        vpor      xmm0, xmm0, xmm1                              
        vpshufb   xmm1, xmm0, XMMWORD PTR [_2il0floatpacket.3]  
        vaesenc   xmm3, xmm3, xmm0                              
        vaesenc   xmm4, xmm4, xmm1                              
        vaesenc   xmm4, xmm3, xmm4                              
        vmovdqu   xmm3, XMMWORD PTR [_2il0floatpacket.8]        
        vpshufb   xmm0, xmm0, xmm3                              
        vpshufb   xmm1, xmm1, xmm3                              
        vaesenc   xmm5, xmm5, xmm0                              
        vaesenc   xmm0, xmm4, xmm5                              
        vaesenc   xmm2, xmm2, xmm1                              
        vaesenc   xmm3, xmm0, xmm2                              
.B6.13::                        
        vmovups   XMMWORD PTR [DDAES], xmm3                     
        add       rsp, 216                                      
        ret                                                     
        ALIGN     16
DoubleDeuceAES_Gumbotron ENDP
*/

//#define KAZE_AVX2
#ifdef KAZE_AVX2
// Revision 2021-Aug-22 [
//VPSHUFB:__m256i _mm256_shuffle_epi8(__m256i a, __m256i b)
//VPSHUFB __m512i _mm512_shuffle_epi8(__m512i a, __m512i b);
void DoubleDeuceAES_Gumbotron_YMM(const uint8_t *buffer, size_t length, uint64_t *LoPart, uint64_t *HiPart) {
	size_t i, Cycles;
	__m128i hashA = _mm_set_epi64x(0x6c62272e07bb0142, 0x62b821756295c58d); // 0x6c62272e07bb014262b821756295c58d // _mm_setzero_si128();
	__m128i hashB = _mm_set_epi64x(0xdd268dbcaac55036, 0x2d98c384c4e576cc); // 0xdd268dbcaac550362d98c384c4e576ccc8b1536847b6bbb31023b4c8caee0535 // FNV offset basis
	__m128i hashC = _mm_set_epi64x(0xc8b1536847b6bbb3, 0x1023b4c8caee0535); // 0xdd268dbcaac550362d98c384c4e576ccc8b1536847b6bbb31023b4c8caee0535 // FNV offset basis
	__m128i hashD = _mm_setzero_si128();
	__m128i a0,a1,a2,a3; // Instead of this chunkenization, ZMM houses the 4 XMMs, if there is shuffle across all the 512bits, use it. There is, but __m256i _mm256_shuffle_epi8(__m256i a, __m256i b) is more handy.
	__m256i a0YMM,a2YMM;
	__m128i b0,b1,b2,b3;
	__m256i b0YMM,b2YMM;
	__m128i c0,c1,c2,c3;
	__m256i c0YMM,c2YMM;
	__m128i d0,d1,d2,d3;
	__m256i d0YMM,d2YMM;
	__m128i tmp0,tmp1,tmp2,tmp3;
	__m256i tmp0YMM,tmp2YMM;
	__m128i ReverseMask =   _mm_set_epi8(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15);
	__m256i ReverseMaskYMM = _mm256_set_epi8(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31);
	__m128i PartialInterleavingMask1 = _mm_set_epi8(0x80,7,0x80,6,0x80,5,0x80,4,0x80,3,0x80,2,0x80,1,0x80,0);
	__m128i PartialInterleavingMask2 = _mm_set_epi8(0x80,0xf,0x80,0xe,0x80,0xd,0x80,0xc,0x80,0xb,0x80,0xa,0x80,9,0x80,8); 
	__m128i PartialInterleavingMask3 = _mm_set_epi8(7,0x80,6,0x80,5,0x80,4,0x80,3,0x80,2,0x80,1,0x80,0,0x80);
	__m128i PartialInterleavingMask4 = _mm_set_epi8(0xf,0x80,0xe,0x80,0xd,0x80,0xc,0x80,0xb,0x80,0xa,0x80,9,0x80,8,0x80);
	__m256i PartialInterleavingMask1YMM = _mm256_set_epi8(0x80,0xf,0x80,0xe,0x80,0xd,0x80,0xc,0x80,0xb,0x80,0xa,0x80,9,0x80,8,0x80,7,0x80,6,0x80,5,0x80,4,0x80,3,0x80,2,0x80,1,0x80,0);
//	__m256i PartialInterleavingMask2YMM = _mm256_set_epi8(0x80,0xf+16,0x80,0xe+16,0x80,0xd+16,0x80,0xc+16,0x80,0xb+16,0x80,0xa+16,0x80,9+16,0x80,8+16,0x80,7+16,0x80,6+16,0x80,5+16,0x80,4+16,0x80,3+16,0x80,2+16,0x80,1+16,0x80,0+16);
	__m256i PartialInterleavingMask3YMM = _mm256_set_epi8(0xf,0x80,0xe,0x80,0xd,0x80,0xc,0x80,0xb,0x80,0xa,0x80,9,0x80,8,0x80,7,0x80,6,0x80,5,0x80,4,0x80,3,0x80,2,0x80,1,0x80,0,0x80);
//	__m256i PartialInterleavingMask4YMM = _mm256_set_epi8(0xf+16,0x80,0xe+16,0x80,0xd+16,0x80,0xc+16,0x80,0xb+16,0x80,0xa+16,0x80,9+16,0x80,8+16,0x80,7+16,0x80,6+16,0x80,5+16,0x80,4+16,0x80,3+16,0x80,2+16,0x80,1+16,0x80,0+16,0x80);
	const __m128i *ptr128a, *ptr128b, *ptr128c, *ptr128d;

	__m128i AgainstRules, GumbotronREVER, GumbotronINTER, Gumbotron, GumbotronREVERINTER;
	const __m128i *ptr128; 
	__m128i InterleaveMask =   _mm_set_epi8(15,7,14,6,13,5,12,4,11,3,10,2,9,1,8,0);
uint8_t vector[32];

	if (length >= 64) {
		Cycles = length/64;
		for(; Cycles--; buffer += 64) {
			//a0 = _mm_loadu_si128((__m128i *)(buffer+0*16)); 
			//a1 = _mm_loadu_si128((__m128i *)(buffer+1*16)); 
			//a2 = _mm_loadu_si128((__m128i *)(buffer+2*16)); 
			//a3 = _mm_loadu_si128((__m128i *)(buffer+3*16)); 
			a0YMM = _mm256_loadu_si256((__m256i *)(buffer+0*16)); 
			a2YMM = _mm256_loadu_si256((__m256i *)(buffer+2*16)); 
			//b0 = _mm_shuffle_epi8 (a3, ReverseMask); 
			//b1 = _mm_shuffle_epi8 (a2, ReverseMask); 
			//b2 = _mm_shuffle_epi8 (a1, ReverseMask); 
			//b3 = _mm_shuffle_epi8 (a0, ReverseMask); 
			b0YMM = _mm256_shuffle_epi8 (a2YMM, ReverseMaskYMM); // Caution: the stupid intrinsic works on 128bit not on 256bit! b0YMM = b1+b0 not b0+b1
			b2YMM = _mm256_shuffle_epi8 (a0YMM, ReverseMaskYMM); 
// Should swap:
// https://godbolt.org/z/dY74zv1Ph
b0YMM = _mm256_permute4x64_epi64(b0YMM, 0b01001110); //# ymm0 = ymm0[2,3,0,1]
b2YMM = _mm256_permute4x64_epi64(b2YMM, 0b01001110); //# ymm0 = ymm0[2,3,0,1]

/*
__m256i _mm256_permute4x64_epi64 (__m256i a, const int imm8)
#include <immintrin.h>
Instruction: vpermq ymm, ymm, imm8
CPUID Flags: AVX2
Description
Shuffle 64-bit integers in a across lanes using the control in imm8, and store the results in dst.
Operation
DEFINE SELECT4(src, control) {
	CASE(control[1:0]) OF
	0:	tmp[63:0] := src[63:0]
	1:	tmp[63:0] := src[127:64]
	2:	tmp[63:0] := src[191:128]
	3:	tmp[63:0] := src[255:192]
	ESAC
	RETURN tmp[63:0]
}
dst[63:0] := SELECT4(a[255:0], imm8[1:0])
dst[127:64] := SELECT4(a[255:0], imm8[3:2])
dst[191:128] := SELECT4(a[255:0], imm8[5:4])
dst[255:192] := SELECT4(a[255:0], imm8[7:6])
dst[MAX:256] := 0
*/

//a8C7E8G7H5G3H1F2H3G1E2C1A2B4A6B8D7F8H7G5F7H8G6H4G2E1C2A1B3A5B7D8C6A7C8E7G8H6G4H2F1D2B1A3B5D6F5D4F3E5C4B2D3F4E6C5A4B6D5F6E4C3D1E3
//                             a0]                              a2]                              a0]                              a2]
//a8C7E8G7H5G3H1F2H3G1E2C1A2B4A6B8 D7F8H7G5F7H8G6H4G2E1C2A1B3A5B7D8 C6A7C8E7G8H6G4H2F1D2B1A3B5D6F5D4 F3E5C4B2D3F4E6C5A4B6D5F6E4C3D1E3

//a0: 61 38 43 37 | 45 38 47 37 | 48 35 47 33 | 48 31 46 32 ! 48 33 47 31 | 45 32 43 31 | 41 32 42 34 | 41 36 42 38
//a2: 44 37 46 38 | 48 37 47 35 | 46 37 48 38 | 47 36 48 34 ! 47 32 45 31 | 43 32 41 31 | 42 33 41 35 | 42 37 44 38
//b0: 34 48 36 47 | 38 48 37 46 | 35 47 37 48 | 38 46 37 44 ! 38 44 37 42 | 35 41 33 42 | 31 41 32 43 | 31 45 32 47
//b2: 32 46 31 48 | 33 47 35 48 | 37 47 38 45 | 37 43 38 61 ! 38 42 36 41 | 34 42 32 41 | 31 43 32 45 | 31 47 33 48

			//tmp0 = _mm_shuffle_epi8 (a0, PartialInterleavingMask1);
			//tmp1 = _mm_shuffle_epi8 (a0, PartialInterleavingMask2);
			//tmp2 = _mm_shuffle_epi8 (a2, PartialInterleavingMask3);
			//tmp3 = _mm_shuffle_epi8 (a2, PartialInterleavingMask4);
			//c0 = _mm_or_si128 (tmp0, tmp2);
			//c1 = _mm_or_si128 (tmp1, tmp3);
			//tmp0 = _mm_shuffle_epi8 (a1, PartialInterleavingMask1);
			//tmp1 = _mm_shuffle_epi8 (a1, PartialInterleavingMask2);
			//tmp2 = _mm_shuffle_epi8 (a3, PartialInterleavingMask3);
			//tmp3 = _mm_shuffle_epi8 (a3, PartialInterleavingMask4);
			//c2 = _mm_or_si128 (tmp0, tmp2);
			//c3 = _mm_or_si128 (tmp1, tmp3);
// c0: 00 20 01 21 | 02 22 03 23 | 04 24 05 25 | 06 26 07 27
// c1: 08 28 09 29 | 0a 2a 0b 2b | 0c 2c 0d 2d | 0e 2e 0f 2f
// c2: 10 30 11 31 | 12 32 13 33 | 14 34 15 35 | 16 36 17 37
// c3: 18 38 19 39 | 1a 3a 1b 3b | 1c 3c 1d 3d | 1e 3e 1f 3f
/*
__m256i _mm256_unpacklo_epi8 (__m256i a, __m256i b)
Synopsis
__m256i _mm256_unpacklo_epi8 (__m256i a, __m256i b)
#include <immintrin.h>
Instruction: vpunpcklbw ymm, ymm, ymm
CPUID Flags: AVX2
Description
Unpack and interleave 8-bit integers from the low half of each 128-bit lane in a and b, and store the results in dst.
Operation
DEFINE INTERLEAVE_BYTES(src1[127:0], src2[127:0]) {
	dst[7:0] := src1[7:0] 
	dst[15:8] := src2[7:0] 
	dst[23:16] := src1[15:8] 
	dst[31:24] := src2[15:8] 
	dst[39:32] := src1[23:16] 
	dst[47:40] := src2[23:16] 
	dst[55:48] := src1[31:24] 
	dst[63:56] := src2[31:24] 
	dst[71:64] := src1[39:32]
	dst[79:72] := src2[39:32] 
	dst[87:80] := src1[47:40] 
	dst[95:88] := src2[47:40] 
	dst[103:96] := src1[55:48] 
	dst[111:104] := src2[55:48] 
	dst[119:112] := src1[63:56] 
	dst[127:120] := src2[63:56] 
	RETURN dst[127:0]
}
dst[127:0] := INTERLEAVE_BYTES(a[127:0], b[127:0])
dst[255:128] := INTERLEAVE_BYTES(a[255:128], b[255:128])
dst[MAX:256] := 0
*/
//__m128i _mm_unpacklo_epi8 (__m128i a, __m128i b)

			c0YMM = _mm256_unpacklo_epi8 (a0YMM, a2YMM); 
			c2YMM = _mm256_unpackhi_epi8 (a0YMM, a2YMM); 
// Above two lines gave:
/*
    [                      0]   [                      1]   [                      2]   [                      3]
a0: 61 38 43 37 | 45 38 47 37 | 48 35 47 33 | 48 31 46 32 ! 48 33 47 31 | 45 32 43 31 | 41 32 42 34 | 41 36 42 38
    [                      4]   [                      5]   [                      6]   [                      7]
a2: 44 37 46 38 | 48 37 47 35 | 46 37 48 38 | 47 36 48 34 ! 47 32 45 31 | 43 32 41 31 | 42 33 41 35 | 42 37 44 38

    [                                                0+4]   [                                                2+6]   
c0: 61 44 38 37 | 43 46 37 38 | 45 48 38 37 | 47 47 37 35 ! 48 47 33 32 | 47 45 31 31 | 45 43 32 32 | 43 41 31 31
    [                                                1+5]   [                                                3+7]   
c2: 48 46 35 37 | 47 48 33 38 | 48 47 31 36 | 46 48 32 34 ! 41 42 32 33 | 42 41 34 35 | 41 42 36 37 | 42 44 38 38
*/
// But I need:
// c0,c1,c2,c3     not c0,c2,c1,c3
// 0+4,1+5,2+6,3+7 not 0+4,2+6,1+5,3+7
// as in XMM:
// c0: 00 20 01 21 | 02 22 03 23 | 04 24 05 25 | 06 26 07 27
// c1: 08 28 09 29 | 0a 2a 0b 2b | 0c 2c 0d 2d | 0e 2e 0f 2f
// c2: 10 30 11 31 | 12 32 13 33 | 14 34 15 35 | 16 36 17 37
// c3: 18 38 19 39 | 1a 3a 1b 3b | 1c 3c 1d 3d | 1e 3e 1f 3f

//a0: 61 38 43 37 | 45 38 47 37 | 48 35 47 33 | 48 31 46 32 ! 48 33 47 31 | 45 32 43 31 | 41 32 42 34 | 41 36 42 38
//a2: 44 37 46 38 | 48 37 47 35 | 46 37 48 38 | 47 36 48 34 ! 47 32 45 31 | 43 32 41 31 | 42 33 41 35 | 42 37 44 38

//tmp0YMM: 61 00 38 00 | 43 00 37 00 | 45 00 38 00 | 47 00 37 00 ! 41 00 32 00 | 42 00 34 00 | 41 00 36 00 | 42 00 38 00
//tmp2YMM: 00 44 00 37 | 00 46 00 38 | 00 48 00 37 | 00 47 00 35 ! 00 42 00 33 | 00 41 00 35 | 00 42 00 37 | 00 44 00 38

//			tmp0YMM = _mm256_shuffle_epi8 (a0YMM, PartialInterleavingMask1YMM); 
//			tmp2YMM = _mm256_shuffle_epi8 (a2YMM, PartialInterleavingMask3YMM); 
//			c0YMM = _mm256_or_si256 (tmp0YMM, tmp2YMM);
//			tmp0YMM = _mm256_shuffle_epi8 (a0YMM, PartialInterleavingMask1YMM); 
//			tmp2YMM = _mm256_shuffle_epi8 (a2YMM, PartialInterleavingMask3YMM); 
//			c2YMM = _mm256_or_si256 (tmp0YMM, tmp2YMM);

			//tmp0 = _mm_shuffle_epi8 (b0, PartialInterleavingMask1);
			//tmp1 = _mm_shuffle_epi8 (b0, PartialInterleavingMask2);
			//tmp2 = _mm_shuffle_epi8 (b2, PartialInterleavingMask3);
			//tmp3 = _mm_shuffle_epi8 (b2, PartialInterleavingMask4);
			//d0 = _mm_or_si128 (tmp0, tmp2);
			//d1 = _mm_or_si128 (tmp1, tmp3);
			//tmp0 = _mm_shuffle_epi8 (b1, PartialInterleavingMask1);
			//tmp1 = _mm_shuffle_epi8 (b1, PartialInterleavingMask2);
			//tmp2 = _mm_shuffle_epi8 (b3, PartialInterleavingMask3);
			//tmp3 = _mm_shuffle_epi8 (b3, PartialInterleavingMask4);
			//d2 = _mm_or_si128 (tmp0, tmp2);
			//d3 = _mm_or_si128 (tmp1, tmp3);
// d0: 3f 1f 3e 1e | 3d 1d 3c 1c | 3b 1b 3a 1a | 39 19 38 18
// d1: 37 17 36 16 | 35 15 34 14 | 33 13 32 12 | 31 11 30 10
// d2: 2f 0f 2e 0e | 2d 0d 2c 0c | 2b 0b 2a 0a | 29 09 28 08
// d3: 27 07 26 06 | 25 05 24 04 | 23 03 22 02 | 21 01 20 00
			// [[[ Next 6 lines are identical to simply REVERSE C vector - which is in 2 lines
			/*
			tmp0YMM = _mm256_shuffle_epi8 (b0YMM, PartialInterleavingMask1YMM); 
			tmp2YMM = _mm256_shuffle_epi8 (b2YMM, PartialInterleavingMask3YMM); 
			d0YMM = _mm256_or_si256 (tmp0YMM, tmp2YMM);
			tmp0YMM = _mm256_shuffle_epi8 (b0YMM, PartialInterleavingMask2YMM); 
			tmp2YMM = _mm256_shuffle_epi8 (b2YMM, PartialInterleavingMask4YMM); 
			d2YMM = _mm256_or_si256 (tmp0YMM, tmp2YMM);
			*/
			// ]]] Next 6 lines are identical to simply REVERSE C vector - which is in 2 lines, but I don't have it, so {{{
			d0YMM = _mm256_unpacklo_epi8 (b0YMM, b2YMM); 
			d2YMM = _mm256_unpackhi_epi8 (b0YMM, b2YMM); 
			// }}}

// For above code (the last thing to fix: b should be REVERSED a, not b1,b0,b3,b2):
//a0: 61 38 43 37 | 45 38 47 37 | 48 35 47 33 | 48 31 46 32 ! 48 33 47 31 | 45 32 43 31 | 41 32 42 34 | 41 36 42 38
//a2: 44 37 46 38 | 48 37 47 35 | 46 37 48 38 | 47 36 48 34 ! 47 32 45 31 | 43 32 41 31 | 42 33 41 35 | 42 37 44 38
//
//b0: 34 48 36 47 | 38 48 37 46 | 35 47 37 48 | 38 46 37 44 ! 38 44 37 42 | 35 41 33 42 | 31 41 32 43 | 31 45 32 47
//b2: 32 46 31 48 | 33 47 35 48 | 37 47 38 45 | 37 43 38 61 ! 38 42 36 41 | 34 42 32 41 | 31 43 32 45 | 31 47 33 48
//
//c0: 61 44 38 37 | 43 46 37 38 | 45 48 38 37 | 47 47 37 35 ! 48 47 33 32 | 47 45 31 31 | 45 43 32 32 | 43 41 31 31
//c2: 48 46 35 37 | 47 48 33 38 | 48 47 31 36 | 46 48 32 34 ! 41 42 32 33 | 42 41 34 35 | 41 42 36 37 | 42 44 38 38
//
//d0: 34 32 48 46 | 36 31 47 48 | 38 33 48 47 | 37 35 46 48 ! 38 38 44 42 | 37 36 42 41 | 35 34 41 42 | 33 32 42 41
//d2: 35 37 47 47 | 37 38 48 45 | 38 37 46 43 | 37 38 44 61 ! 31 31 41 43 | 32 32 43 45 | 31 31 45 47 | 32 33 47 48

/*
    _mm256_storeu_si256((__m256i*)vector, a0YMM);
    printf("a0: %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x ! %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x\n",
           vector[0], vector[1],  vector[2],  vector[3],  vector[4],  vector[5],  vector[6],  vector[7],
           vector[8], vector[9], vector[10], vector[11], vector[12], vector[13], vector[14], vector[15],
           vector[0+16], vector[1+16],  vector[2+16],  vector[3+16],  vector[4+16],  vector[5+16],  vector[6+16],  vector[7+16],
           vector[8+16], vector[9+16], vector[10+16], vector[11+16], vector[12+16], vector[13+16], vector[14+16], vector[15+16]);

    _mm256_storeu_si256((__m256i*)vector, a2YMM);
    printf("a2: %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x ! %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x\n",
           vector[0], vector[1],  vector[2],  vector[3],  vector[4],  vector[5],  vector[6],  vector[7],
           vector[8], vector[9], vector[10], vector[11], vector[12], vector[13], vector[14], vector[15],
           vector[0+16], vector[1+16],  vector[2+16],  vector[3+16],  vector[4+16],  vector[5+16],  vector[6+16],  vector[7+16],
           vector[8+16], vector[9+16], vector[10+16], vector[11+16], vector[12+16], vector[13+16], vector[14+16], vector[15+16]);

    _mm256_storeu_si256((__m256i*)vector, b0YMM);
    printf("b0: %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x ! %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x\n",
           vector[0], vector[1],  vector[2],  vector[3],  vector[4],  vector[5],  vector[6],  vector[7],
           vector[8], vector[9], vector[10], vector[11], vector[12], vector[13], vector[14], vector[15],
           vector[0+16], vector[1+16],  vector[2+16],  vector[3+16],  vector[4+16],  vector[5+16],  vector[6+16],  vector[7+16],
           vector[8+16], vector[9+16], vector[10+16], vector[11+16], vector[12+16], vector[13+16], vector[14+16], vector[15+16]);

    _mm256_storeu_si256((__m256i*)vector, b2YMM);
    printf("b2: %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x ! %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x\n",
           vector[0], vector[1],  vector[2],  vector[3],  vector[4],  vector[5],  vector[6],  vector[7],
           vector[8], vector[9], vector[10], vector[11], vector[12], vector[13], vector[14], vector[15],
           vector[0+16], vector[1+16],  vector[2+16],  vector[3+16],  vector[4+16],  vector[5+16],  vector[6+16],  vector[7+16],
           vector[8+16], vector[9+16], vector[10+16], vector[11+16], vector[12+16], vector[13+16], vector[14+16], vector[15+16]);

    _mm256_storeu_si256((__m256i*)vector, c0YMM);
    printf("c0: %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x ! %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x\n",
           vector[0], vector[1],  vector[2],  vector[3],  vector[4],  vector[5],  vector[6],  vector[7],
           vector[8], vector[9], vector[10], vector[11], vector[12], vector[13], vector[14], vector[15],
           vector[0+16], vector[1+16],  vector[2+16],  vector[3+16],  vector[4+16],  vector[5+16],  vector[6+16],  vector[7+16],
           vector[8+16], vector[9+16], vector[10+16], vector[11+16], vector[12+16], vector[13+16], vector[14+16], vector[15+16]);
    _mm256_storeu_si256((__m256i*)vector, c2YMM);
    printf("c2: %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x ! %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x\n",
           vector[0], vector[1],  vector[2],  vector[3],  vector[4],  vector[5],  vector[6],  vector[7],
           vector[8], vector[9], vector[10], vector[11], vector[12], vector[13], vector[14], vector[15],
           vector[0+16], vector[1+16],  vector[2+16],  vector[3+16],  vector[4+16],  vector[5+16],  vector[6+16],  vector[7+16],
           vector[8+16], vector[9+16], vector[10+16], vector[11+16], vector[12+16], vector[13+16], vector[14+16], vector[15+16]);

    _mm256_storeu_si256((__m256i*)vector, d0YMM);
    printf("d0: %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x ! %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x\n",
           vector[0], vector[1],  vector[2],  vector[3],  vector[4],  vector[5],  vector[6],  vector[7],
           vector[8], vector[9], vector[10], vector[11], vector[12], vector[13], vector[14], vector[15],
           vector[0+16], vector[1+16],  vector[2+16],  vector[3+16],  vector[4+16],  vector[5+16],  vector[6+16],  vector[7+16],
           vector[8+16], vector[9+16], vector[10+16], vector[11+16], vector[12+16], vector[13+16], vector[14+16], vector[15+16]);
    _mm256_storeu_si256((__m256i*)vector, d2YMM);
    printf("d2: %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x ! %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x\n",
           vector[0], vector[1],  vector[2],  vector[3],  vector[4],  vector[5],  vector[6],  vector[7],
           vector[8], vector[9], vector[10], vector[11], vector[12], vector[13], vector[14], vector[15],
           vector[0+16], vector[1+16],  vector[2+16],  vector[3+16],  vector[4+16],  vector[5+16],  vector[6+16],  vector[7+16],
           vector[8+16], vector[9+16], vector[10+16], vector[11+16], vector[12+16], vector[13+16], vector[14+16], vector[15+16]);

    printf("\n");
*/

/*
G:\Lookupperorama_r13\COLLISION_Hashliner>Hashliner_DDAES_dump5byteshash.exe 1.KnightTours.txt
394e907d43

G:\Lookupperorama_r13\COLLISION_Hashliner>Hashliner_DDAES-XMM_dump5byteshash.exe 1.KnightTours.txt
f4b027e3ab

G:\Lookupperorama_r13\COLLISION_Hashliner>d:

D:\>g:

G:\Lookupperorama_r13\COLLISION_Hashliner>Hashliner_DDAES_dump5byteshash.exe 1.KnightTours.txt
a0: 61 38 43 37 | 45 38 47 37 | 48 35 47 33 | 48 31 46 32 ! 48 33 47 31 | 45 32 43 31 | 41 32 42 34 | 41 36 42 38
a2: 44 37 46 38 | 48 37 47 35 | 46 37 48 38 | 47 36 48 34 ! 47 32 45 31 | 43 32 41 31 | 42 33 41 35 | 42 37 44 38
c0: 61 44 38 37 | 43 46 37 38 | 45 48 38 37 | 47 47 37 35 ! 41 42 32 33 | 42 41 34 35 | 41 42 36 37 | 42 44 38 38
c2: 61 44 38 37 | 43 46 37 38 | 45 48 38 37 | 47 47 37 35 ! 41 42 32 33 | 42 41 34 35 | 41 42 36 37 | 42 44 38 38

a0: 43 36 41 37 | 43 38 45 37 | 47 38 48 36 | 47 34 48 32 ! 46 31 44 32 | 42 31 41 33 | 42 35 44 36 | 46 35 44 34
a2: 46 33 45 35 | 43 34 42 32 | 44 33 46 34 | 45 36 43 35 ! 41 34 42 36 | 44 35 46 36 | 45 34 43 33 | 44 31 45 33
c0: 43 46 36 33 | 41 45 37 35 | 43 43 38 34 | 45 42 37 32 ! 42 45 35 34 | 44 43 36 33 | 46 44 35 31 | 44 45 34 33
c2: 43 46 36 33 | 41 45 37 35 | 43 43 38 34 | 45 42 37 32 ! 42 45 35 34 | 44 43 36 33 | 46 44 35 31 | 44 45 34 33

394e907d43

G:\Lookupperorama_r13\COLLISION_Hashliner>type 1.KnightTours.txt
a8C7E8G7H5G3H1F2H3G1E2C1A2B4A6B8D7F8H7G5F7H8G6H4G2E1C2A1B3A5B7D8C6A7C8E7G8H6G4H2F1D2B1A3B5D6F5D4F3E5C4B2D3F4E6C5A4B6D5F6E4C3D1E3

G:\Lookupperorama_r13\COLLISION_Hashliner>
                             a0]                              a2]                              a0]                              a2]
a8C7E8G7H5G3H1F2H3G1E2C1A2B4A6B8 D7F8H7G5F7H8G6H4G2E1C2A1B3A5B7D8 C6A7C8E7G8H6G4H2F1D2B1A3B5D6F5D4 F3E5C4B2D3F4E6C5A4B6D5F6E4C3D1E3

*/

/*
    _mm_storeu_si128((__m128i*)vector, *(__m128i *)(&a0YMM));
    printf("a0lo: %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x\n",
           vector[0], vector[1],  vector[2],  vector[3],  vector[4],  vector[5],  vector[6],  vector[7],
           vector[8], vector[9], vector[10], vector[11], vector[12], vector[13], vector[14], vector[15]);
    _mm_storeu_si128((__m128i*)vector, *((__m128i *)(&a0YMM)+1));
    printf("a0hi: %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x | %02x %02x %02x %02x\n",
           vector[0], vector[1],  vector[2],  vector[3],  vector[4],  vector[5],  vector[6],  vector[7],
           vector[8], vector[9], vector[10], vector[11], vector[12], vector[13], vector[14], vector[15]);

    printf("Above two should equal a0YMM\n");
*/
//void SlowCopy128bit (const char *SOURCE, char *TARGET) { _mm_storeu_si128((__m128i *)(TARGET), _mm_loadu_si128((const __m128i *)(SOURCE))); }

// Okay, the final dump (shows XMM and YMM variants produce the same hash):
/*

D:\Lookupperorama_r13\COLLISION_Hashliner>Hashliner_DDAES_dump5byteshash.exe 1.KnightTours.txt
a0: 61 38 43 37 | 45 38 47 37 | 48 35 47 33 | 48 31 46 32
a1: 48 33 47 31 | 45 32 43 31 | 41 32 42 34 | 41 36 42 38
a2: 44 37 46 38 | 48 37 47 35 | 46 37 48 38 | 47 36 48 34
a3: 47 32 45 31 | 43 32 41 31 | 42 33 41 35 | 42 37 44 38

b0: 38 44 37 42 | 35 41 33 42 | 31 41 32 43 | 31 45 32 47
b1: 34 48 36 47 | 38 48 37 46 | 35 47 37 48 | 38 46 37 44
b2: 38 42 36 41 | 34 42 32 41 | 31 43 32 45 | 31 47 33 48
b3: 32 46 31 48 | 33 47 35 48 | 37 47 38 45 | 37 43 38 61

c0: 61 44 38 37 | 43 46 37 38 | 45 48 38 37 | 47 47 37 35
c1: 48 46 35 37 | 47 48 33 38 | 48 47 31 36 | 46 48 32 34
c2: 48 47 33 32 | 47 45 31 31 | 45 43 32 32 | 43 41 31 31
c3: 41 42 32 33 | 42 41 34 35 | 41 42 36 37 | 42 44 38 38

d0: 38 38 44 42 | 37 36 42 41 | 35 34 41 42 | 33 32 42 41
d1: 31 31 41 43 | 32 32 43 45 | 31 31 45 47 | 32 33 47 48
d2: 34 32 48 46 | 36 31 47 48 | 38 33 48 47 | 37 35 46 48
d3: 35 37 47 47 | 37 38 48 45 | 38 37 46 43 | 37 38 44 61

a0: 43 36 41 37 | 43 38 45 37 | 47 38 48 36 | 47 34 48 32
a1: 46 31 44 32 | 42 31 41 33 | 42 35 44 36 | 46 35 44 34
a2: 46 33 45 35 | 43 34 42 32 | 44 33 46 34 | 45 36 43 35
a3: 41 34 42 36 | 44 35 46 36 | 45 34 43 33 | 44 31 45 33

b0: 33 45 31 44 | 33 43 34 45 | 36 46 35 44 | 36 42 34 41
b1: 35 43 36 45 | 34 46 33 44 | 32 42 34 43 | 35 45 33 46
b2: 34 44 35 46 | 36 44 35 42 | 33 41 31 42 | 32 44 31 46
b3: 32 48 34 47 | 36 48 38 47 | 37 45 38 43 | 37 41 36 43

c0: 43 46 36 33 | 41 45 37 35 | 43 43 38 34 | 45 42 37 32
c1: 47 44 38 33 | 48 46 36 34 | 47 45 34 36 | 48 43 32 35
c2: 46 41 31 34 | 44 42 32 36 | 42 44 31 35 | 41 46 33 36
c3: 42 45 35 34 | 44 43 36 33 | 46 44 35 31 | 44 45 34 33

d0: 33 34 45 44 | 31 35 44 46 | 33 36 43 44 | 34 35 45 42
d1: 36 33 46 41 | 35 31 44 42 | 36 32 42 44 | 34 31 41 46
d2: 35 32 43 48 | 36 34 45 47 | 34 36 46 48 | 33 38 44 47
d3: 32 37 42 45 | 34 38 43 43 | 35 37 45 41 | 33 36 46 43

f4b027e3ab
a0: 61 38 43 37 | 45 38 47 37 | 48 35 47 33 | 48 31 46 32 ! 48 33 47 31 | 45 32 43 31 | 41 32 42 34 | 41 36 42 38
a2: 44 37 46 38 | 48 37 47 35 | 46 37 48 38 | 47 36 48 34 ! 47 32 45 31 | 43 32 41 31 | 42 33 41 35 | 42 37 44 38
b0: 38 44 37 42 | 35 41 33 42 | 31 41 32 43 | 31 45 32 47 ! 34 48 36 47 | 38 48 37 46 | 35 47 37 48 | 38 46 37 44
b2: 38 42 36 41 | 34 42 32 41 | 31 43 32 45 | 31 47 33 48 ! 32 46 31 48 | 33 47 35 48 | 37 47 38 45 | 37 43 38 61
c0: 61 44 38 37 | 43 46 37 38 | 45 48 38 37 | 47 47 37 35 ! 48 47 33 32 | 47 45 31 31 | 45 43 32 32 | 43 41 31 31
c2: 48 46 35 37 | 47 48 33 38 | 48 47 31 36 | 46 48 32 34 ! 41 42 32 33 | 42 41 34 35 | 41 42 36 37 | 42 44 38 38
d0: 38 38 44 42 | 37 36 42 41 | 35 34 41 42 | 33 32 42 41 ! 34 32 48 46 | 36 31 47 48 | 38 33 48 47 | 37 35 46 48
d2: 31 31 41 43 | 32 32 43 45 | 31 31 45 47 | 32 33 47 48 ! 35 37 47 47 | 37 38 48 45 | 38 37 46 43 | 37 38 44 61

a0lo: 61 38 43 37 | 45 38 47 37 | 48 35 47 33 | 48 31 46 32
a0hi: 48 33 47 31 | 45 32 43 31 | 41 32 42 34 | 41 36 42 38
Above two should equal a0YMM
a0: 43 36 41 37 | 43 38 45 37 | 47 38 48 36 | 47 34 48 32 ! 46 31 44 32 | 42 31 41 33 | 42 35 44 36 | 46 35 44 34
a2: 46 33 45 35 | 43 34 42 32 | 44 33 46 34 | 45 36 43 35 ! 41 34 42 36 | 44 35 46 36 | 45 34 43 33 | 44 31 45 33
b0: 33 45 31 44 | 33 43 34 45 | 36 46 35 44 | 36 42 34 41 ! 35 43 36 45 | 34 46 33 44 | 32 42 34 43 | 35 45 33 46
b2: 34 44 35 46 | 36 44 35 42 | 33 41 31 42 | 32 44 31 46 ! 32 48 34 47 | 36 48 38 47 | 37 45 38 43 | 37 41 36 43
c0: 43 46 36 33 | 41 45 37 35 | 43 43 38 34 | 45 42 37 32 ! 46 41 31 34 | 44 42 32 36 | 42 44 31 35 | 41 46 33 36
c2: 47 44 38 33 | 48 46 36 34 | 47 45 34 36 | 48 43 32 35 ! 42 45 35 34 | 44 43 36 33 | 46 44 35 31 | 44 45 34 33
d0: 33 34 45 44 | 31 35 44 46 | 33 36 43 44 | 34 35 45 42 ! 35 32 43 48 | 36 34 45 47 | 34 36 46 48 | 33 38 44 47
d2: 36 33 46 41 | 35 31 44 42 | 36 32 42 44 | 34 31 41 46 ! 32 37 42 45 | 34 38 43 43 | 35 37 45 41 | 33 36 46 43

a0lo: 43 36 41 37 | 43 38 45 37 | 47 38 48 36 | 47 34 48 32
a0hi: 46 31 44 32 | 42 31 41 33 | 42 35 44 36 | 46 35 44 34
Above two should equal a0YMM
f4b027e3ab

D:\Lookupperorama_r13\COLLISION_Hashliner>
*/

			//In YMM should swap c1 and c2, also d1 and d2

			//hashA = _mm_aesenc_si128(hashA, a0);
			hashA = _mm_aesenc_si128(hashA, *(__m128i *)(&a0YMM));
			//hashB = _mm_aesenc_si128(hashB, b0);
				hashB = _mm_aesenc_si128(hashB, *(__m128i *)(&b0YMM));
				//hashB = _mm_aesenc_si128(hashB, *((__m128i *)(&b0YMM)+1));
			//hashC = _mm_aesenc_si128(hashC, c0);
			hashC = _mm_aesenc_si128(hashC, *(__m128i *)(&c0YMM));
			//hashD = _mm_aesenc_si128(hashD, d0);
			hashD = _mm_aesenc_si128(hashD, *(__m128i *)(&d0YMM));

			//hashA = _mm_aesenc_si128(hashA, a1);
			hashA = _mm_aesenc_si128(hashA, *((__m128i *)(&a0YMM)+1));
			//hashB = _mm_aesenc_si128(hashB, b1);
				hashB = _mm_aesenc_si128(hashB, *((__m128i *)(&b0YMM)+1));
				//hashB = _mm_aesenc_si128(hashB, *(__m128i *)(&b0YMM));
			//hashC = _mm_aesenc_si128(hashC, c1);
			hashC = _mm_aesenc_si128(hashC, *((__m128i *)(&c2YMM)));
			//hashD = _mm_aesenc_si128(hashD, d1);
			hashD = _mm_aesenc_si128(hashD, *((__m128i *)(&d2YMM)));

			//hashA = _mm_aesenc_si128(hashA, a2);
			hashA = _mm_aesenc_si128(hashA, *(__m128i *)(&a2YMM));
			//hashB = _mm_aesenc_si128(hashB, b2);
				hashB = _mm_aesenc_si128(hashB, *(__m128i *)(&b2YMM));
				//hashB = _mm_aesenc_si128(hashB, *((__m128i *)(&b2YMM)+1));
			//hashC = _mm_aesenc_si128(hashC, c2);
			hashC = _mm_aesenc_si128(hashC, *((__m128i *)(&c0YMM)+1));
			//hashD = _mm_aesenc_si128(hashD, d2);
			hashD = _mm_aesenc_si128(hashD, *((__m128i *)(&d0YMM)+1));

			//hashA = _mm_aesenc_si128(hashA, a3);
			hashA = _mm_aesenc_si128(hashA, *((__m128i *)(&a2YMM)+1));
			//hashB = _mm_aesenc_si128(hashB, b3);
				hashB = _mm_aesenc_si128(hashB, *((__m128i *)(&b2YMM)+1));
				//hashB = _mm_aesenc_si128(hashB, *(__m128i *)(&b2YMM));
			//hashC = _mm_aesenc_si128(hashC, c3);
			hashC = _mm_aesenc_si128(hashC, *((__m128i *)(&c2YMM)+1));
			//hashD = _mm_aesenc_si128(hashD, d3);
			hashD = _mm_aesenc_si128(hashD, *((__m128i *)(&d2YMM)+1));

			hashA = _mm_aesenc_si128(hashA, hashB);
			hashA = _mm_aesenc_si128(hashA, hashC);
			hashA = _mm_aesenc_si128(hashA, hashD);
			length = length - 64;
		}
	}

	ptr128 = (__m128i *)buffer;
	if (length >=16) {
		Cycles = length/16;
		for(; Cycles--; buffer += 16) {
			AgainstRules = _mm_loadu_si128(ptr128++);
			GumbotronREVER = _mm_shuffle_epi8 (AgainstRules, ReverseMask);
			GumbotronINTER = _mm_shuffle_epi8 (AgainstRules, InterleaveMask);
			GumbotronREVERINTER = _mm_shuffle_epi8 (GumbotronREVER, InterleaveMask);
			hashA = _mm_aesenc_si128(hashA, AgainstRules);
			hashB = _mm_aesenc_si128(hashB, GumbotronREVER);
			hashC = _mm_aesenc_si128(hashC, GumbotronINTER);
			hashD = _mm_aesenc_si128(hashD, GumbotronREVERINTER);
			hashA = _mm_aesenc_si128(hashA, hashB);
			hashA = _mm_aesenc_si128(hashA, hashC);
			hashA = _mm_aesenc_si128(hashA, hashD);
			length = length - 16;
		}
	} 
	// Inhere using Pippip's approach to read past the end ("the dirty" sentinel like style, or more like padding):
	if (length&(16-1)) {
		AgainstRules = _mm_loadu_si128(ptr128);		
		//AgainstRules = _mm_srli_si128 (AgainstRules, 16-length); // catastrophic error: Intrinsic parameter must be an immediate value
		AgainstRules = _mm_and_si128 (AgainstRules, Mumbotron[length]);
		//Gumbotron = _mm_slli_si128 (Gumbotron, 16-length); // catastrophic error: Intrinsic parameter must be an immediate value
		Gumbotron = _mm_and_si128 (hashB, Jumbotron[length]);
		AgainstRules = _mm_or_si128 (AgainstRules, Gumbotron);

		GumbotronREVER = _mm_shuffle_epi8 (AgainstRules, ReverseMask);
		GumbotronINTER = _mm_shuffle_epi8 (AgainstRules, InterleaveMask);
		GumbotronREVERINTER = _mm_shuffle_epi8 (GumbotronREVER, InterleaveMask);
			hashA = _mm_aesenc_si128(hashA, AgainstRules);
			hashB = _mm_aesenc_si128(hashB, GumbotronREVER);
			hashC = _mm_aesenc_si128(hashC, GumbotronINTER);
			hashD = _mm_aesenc_si128(hashD, GumbotronREVERINTER);
			hashA = _mm_aesenc_si128(hashA, hashB);
			hashA = _mm_aesenc_si128(hashA, hashC);
			hashA = _mm_aesenc_si128(hashA, hashD);
	}
	//SlowCopy128bit( (const char *)(&hashA), (char *)&DDAES[0]);
	memcpy ( LoPart, (const char *)(&hashA), 8);
	memcpy ( HiPart, (const char *)(&hashA)+8, 8);
}
// Revision 2021-Aug-22 ]
#endif

